var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __require = typeof require !== "undefined" ? require : (x) => {
  throw new Error('Dynamic require of "' + x + '" is not supported');
};
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// src/app/app.js
import React15, { useEffect as useEffect8, useRef as useRef5, useState as useState5 } from "react";

// src/utils.js
function fromEntries(iterable) {
  return [...iterable].reduce((obj, { 0: key, 1: val }) => Object.assign(obj, { [key]: val }), {});
}
function capitalize(word) {
  return word.charAt(0).toUpperCase() + word.slice(1);
}
function getNextScope(prevScopes) {
  const chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
  const nextCharIndices = [0];
  function next() {
    const r = [];
    nextCharIndices.forEach((charIndex) => {
      r.unshift(chars[charIndex]);
    });
    let increment = true;
    for (let i = 0; i < nextCharIndices.length; i++) {
      const val = ++nextCharIndices[i];
      if (val >= chars.length) {
        nextCharIndices[i] = 0;
      } else {
        increment = false;
        break;
      }
    }
    if (increment) {
      nextCharIndices.push(0);
    }
    return r.join("");
  }
  let nextScope;
  do {
    nextScope = next();
  } while (prevScopes.includes(nextScope));
  return nextScope;
}

// src/app/constants.js
var Component = {
  DESCRIPTION: "description",
  STATUS: "status"
};
var DataType = {};
var FileType = {};
var CoordinationType = {
  DATASET: "dataset",
  OBS_TYPE: "obsType",
  FEATURE_TYPE: "featureType",
  FEATURE_VALUE_TYPE: "featureValueType"
};

// src/api/VitessceConfig.js
var VitessceConfigDatasetFile = class {
  constructor(url, dataType, fileType, options) {
    this.file = __spreadValues({
      url,
      type: dataType,
      fileType
    }, options !== null ? { options } : {});
  }
  toJSON() {
    return this.file;
  }
};
var VitessceConfigDataset = class {
  constructor(uid, name2, description2) {
    this.dataset = {
      uid,
      name: name2,
      description: description2,
      files: []
    };
  }
  addFile(url, dataType, fileType, options = null) {
    this.dataset.files.push(new VitessceConfigDatasetFile(url, dataType, fileType, options));
    return this;
  }
  toJSON() {
    return __spreadProps(__spreadValues({}, this.dataset), {
      files: this.dataset.files.map((f) => f.toJSON())
    });
  }
};
var VitessceConfigView = class {
  constructor(component, coordinationScopes, x, y, w, h) {
    this.view = {
      component,
      coordinationScopes,
      x,
      y,
      w,
      h
    };
  }
  useCoordination(...args) {
    const cScopes = args;
    cScopes.forEach((cScope) => {
      this.view.coordinationScopes[cScope.cType] = cScope.cScope;
    });
    return this;
  }
  setXYWH(x, y, w, h) {
    this.view.x = x;
    this.view.y = y;
    this.view.w = w;
    this.view.h = h;
    return this;
  }
  setProps(props) {
    this.view.props = __spreadValues(__spreadValues({}, this.view.props || {}), props);
    return this;
  }
  toJSON() {
    return this.view;
  }
};
var VitessceConfigViewHConcat = class {
  constructor(views) {
    this.views = views;
  }
};
var VitessceConfigViewVConcat = class {
  constructor(views) {
    this.views = views;
  }
};
function hconcat(...views) {
  const vcvhc = new VitessceConfigViewHConcat(views);
  return vcvhc;
}
function vconcat(...views) {
  const vcvvc = new VitessceConfigViewVConcat(views);
  return vcvvc;
}
var VitessceConfigCoordinationScope = class {
  constructor(cType, cScope) {
    this.cType = cType;
    this.cScope = cScope;
    this.cValue = null;
  }
  setValue(cValue) {
    this.cValue = cValue;
    return this;
  }
};
var VitessceConfig = class {
  constructor(schemaVersion, name2 = void 0, description2 = void 0) {
    this.config = {
      version: schemaVersion,
      name: name2,
      description: description2,
      datasets: [],
      coordinationSpace: {},
      layout: [],
      initStrategy: "auto"
    };
  }
  addDataset(name2 = void 0, description2 = void 0, options = void 0) {
    const { uid } = options || {};
    const prevDatasetUids = this.config.datasets.map((d) => d.dataset.uid);
    const nextUid = uid || getNextScope(prevDatasetUids);
    const newDataset = new VitessceConfigDataset(nextUid, name2, description2);
    this.config.datasets.push(newDataset);
    const [newScope] = this.addCoordination(CoordinationType.DATASET);
    newScope.setValue(nextUid);
    return newDataset;
  }
  addView(dataset, component, options) {
    const {
      x = 0,
      y = 0,
      w = 1,
      h = 1,
      mapping = null
    } = options || {};
    const datasetMatches = this.config.coordinationSpace[CoordinationType.DATASET] ? Object.entries(this.config.coordinationSpace[CoordinationType.DATASET]).filter(([scopeName, datasetScope2]) => datasetScope2.cValue === dataset.dataset.uid).map(([scopeName]) => scopeName) : [];
    let datasetScope;
    if (datasetMatches.length === 1) {
      [datasetScope] = datasetMatches;
    } else {
      throw new Error("No coordination scope matching the dataset parameter could be found in the coordination space.");
    }
    const coordinationScopes = {
      [CoordinationType.DATASET]: datasetScope
    };
    const newView = new VitessceConfigView(component, coordinationScopes, x, y, w, h);
    if (mapping) {
      const [etScope] = this.addCoordination(CoordinationType.EMBEDDING_TYPE);
      etScope.setValue(mapping);
      newView.useCoordination(etScope);
    }
    this.config.layout.push(newView);
    return newView;
  }
  addCoordination(...args) {
    const cTypes = args;
    const result = [];
    cTypes.forEach((cType) => {
      const prevScopes = this.config.coordinationSpace[cType] ? Object.keys(this.config.coordinationSpace[cType]) : [];
      const scope = new VitessceConfigCoordinationScope(cType, getNextScope(prevScopes));
      if (!this.config.coordinationSpace[scope.cType]) {
        this.config.coordinationSpace[scope.cType] = {};
      }
      this.config.coordinationSpace[scope.cType][scope.cScope] = scope;
      result.push(scope);
    });
    return result;
  }
  linkViews(views, cTypes, cValues = null) {
    const cScopes = this.addCoordination(...cTypes);
    views.forEach((view) => {
      cScopes.forEach((cScope) => {
        view.useCoordination(cScope);
      });
    });
    if (Array.isArray(cValues) && cValues.length === cTypes.length) {
      cScopes.forEach((cScope, i) => {
        cScope.setValue(cValues[i]);
      });
    }
    return this;
  }
  layout(viewConcat) {
    function layoutAux(obj, xMin, xMax, yMin, yMax) {
      const w = xMax - xMin;
      const h = yMax - yMin;
      if (obj instanceof VitessceConfigView) {
        obj.setXYWH(xMin, yMin, w, h);
      } else if (obj instanceof VitessceConfigViewHConcat) {
        const { views } = obj;
        const numViews = views.length;
        views.forEach((view, i) => {
          layoutAux(view, xMin + w / numViews * i, xMin + w / numViews * (i + 1), yMin, yMax);
        });
      } else if (obj instanceof VitessceConfigViewVConcat) {
        const { views } = obj;
        const numViews = views.length;
        views.forEach((view, i) => {
          layoutAux(view, xMin, xMax, yMin + h / numViews * i, yMin + h / numViews * (i + 1));
        });
      }
    }
    layoutAux(viewConcat, 0, 12, 0, 12);
    return this;
  }
  toJSON() {
    return __spreadProps(__spreadValues({}, this.config), {
      datasets: this.config.datasets.map((d) => d.toJSON()),
      coordinationSpace: fromEntries(Object.entries(this.config.coordinationSpace).map(([cType, cScopes]) => [
        cType,
        fromEntries(Object.entries(cScopes).map(([cScopeName, cScope]) => [
          cScopeName,
          cScope.cValue
        ]))
      ])),
      layout: this.config.layout.map((c) => c.toJSON())
    });
  }
  static fromJSON(config) {
    const { name: name2, description: description2, version: schemaVersion } = config;
    const vc = new VitessceConfig(schemaVersion, name2, description2);
    config.datasets.forEach((d) => {
      const newDataset = vc.addDataset(d.name, d.description, { uid: d.uid });
      d.files.forEach((f) => {
        newDataset.addFile(f.url, f.type, f.fileType);
      });
    });
    Object.keys(config.coordinationSpace).forEach((cType) => {
      if (cType !== CoordinationType.DATASET) {
        const cObj = config.coordinationSpace[cType];
        vc.config.coordinationSpace[cType] = {};
        Object.entries(cObj).forEach(([cScopeName, cScopeValue]) => {
          const scope = new VitessceConfigCoordinationScope(cType, cScopeName);
          scope.setValue(cScopeValue);
          vc.config.coordinationSpace[cType][cScopeName] = scope;
        });
      }
    });
    config.layout.forEach((c) => {
      const newView = new VitessceConfigView(c.component, c.coordinationScopes, c.x, c.y, c.w, c.h);
      vc.config.layout.push(newView);
    });
    return vc;
  }
};

// src/demo/utils.js
var urlPrefix = "https://s3.amazonaws.com/vitessce-data/0.0.31/master_release";
function makeDatasetNameToJsonFiles(datasetPrefix) {
  return (name2) => ({
    type: name2,
    fileType: `${name2}.json`,
    url: `${urlPrefix}/${datasetPrefix}/${datasetPrefix}.${name2}.json`
  });
}
function getS3Url(datasetPrefix, name2) {
  return `${urlPrefix}/${datasetPrefix}/${datasetPrefix}.${name2}.json`;
}
function notPublic(config) {
  return __spreadProps(__spreadValues({}, config), {
    public: void 0
  });
}
var vapi = {
  VitessceConfig,
  hconcat,
  vconcat,
  cm: Component,
  dt: DataType,
  ft: FileType,
  ct: CoordinationType
};

// src/demo/view-configs/codeluppi.js
var linnarssonDataTypes = [
  "cells",
  "cell-sets",
  "raster",
  "molecules",
  "neighborhoods"
];
var linnarssonName = "Codeluppi et al., Nature Methods 2018";
var linnarssonDescription = "Spatial organization of the somatosensory cortex revealed by osmFISH";
var linnarssonBase = {
  name: linnarssonName,
  description: linnarssonDescription,
  version: "1.0.0",
  initStrategy: "auto",
  datasets: [
    {
      uid: "codeluppi",
      name: "Codeluppi",
      files: [
        ...linnarssonDataTypes.map(makeDatasetNameToJsonFiles("linnarsson")),
        __spreadProps(__spreadValues({}, makeDatasetNameToJsonFiles("linnarsson")("clusters")), {
          type: "expression-matrix"
        })
      ]
    }
  ]
};
var linnarssonBaseNoMolecules = {
  name: linnarssonName,
  description: linnarssonDescription,
  version: "1.0.0",
  initStrategy: "auto",
  datasets: [
    {
      uid: "codeluppi",
      name: "Codeluppi",
      files: [
        ...linnarssonDataTypes.filter((dtype) => dtype !== "molecules").map(makeDatasetNameToJsonFiles("linnarsson")),
        __spreadProps(__spreadValues({}, makeDatasetNameToJsonFiles("linnarsson")("clusters")), {
          type: "expression-matrix"
        })
      ]
    }
  ]
};
var justScatter = {
  version: "1.0.0",
  name: "Codeluppi, just scatterplot",
  public: false,
  initStrategy: "auto",
  datasets: [
    {
      uid: "codeluppi",
      name: "Codeluppi",
      files: [
        __spreadProps(__spreadValues({}, makeDatasetNameToJsonFiles("linnarsson")("cells")), {
          requestInit: {
            method: "GET",
            headers: { "x-foo": "FAKE" },
            mode: "cors",
            credentials: "omit",
            cache: "no-store",
            redirect: "error",
            referrer: "FAKE",
            integrity: "FAKE"
          }
        })
      ]
    }
  ],
  coordinationSpace: {
    embeddingType: {
      A: "t-SNE"
    },
    embeddingZoom: {
      A: 0.75
    }
  },
  layout: [
    {
      component: "scatterplot",
      coordinationScopes: {
        embeddingType: "A",
        embeddingZoom: "A"
      },
      x: 0,
      y: 0,
      w: 12,
      h: 2
    }
  ]
};
var justScatterExpression = {
  version: "1.0.0",
  name: "Codeluppi, just scatterplot and expression",
  public: false,
  initStrategy: "auto",
  datasets: [
    {
      uid: "codeluppi",
      name: "Codeluppi",
      files: [
        makeDatasetNameToJsonFiles("linnarsson")("cells"),
        makeDatasetNameToJsonFiles("linnarsson")("genes")
      ]
    }
  ],
  coordinationSpace: {
    embeddingType: {
      A: "t-SNE"
    },
    embeddingZoom: {
      A: 0.75
    }
  },
  layout: [
    {
      component: "scatterplot",
      coordinationScopes: {
        embeddingType: "A",
        embeddingZoom: "A"
      },
      x: 0,
      y: 0,
      w: 12,
      h: 2
    },
    {
      component: "genes",
      x: 8,
      y: 2,
      w: 4,
      h: 2
    }
  ]
};
var justSpatial = __spreadProps(__spreadValues({}, linnarssonBase), {
  coordinationSpace: {
    spatialZoom: {
      A: -6.5
    },
    spatialTargetX: {
      A: 18e3
    },
    spatialTargetY: {
      A: 18e3
    }
  },
  layout: [
    {
      component: "spatial",
      coordinationScopes: {
        spatialZoom: "A",
        spatialTargetX: "A",
        spatialTargetY: "A"
      },
      x: 0,
      y: 0,
      w: 10,
      h: 2
    },
    {
      component: "genes",
      x: 10,
      y: 1,
      w: 2,
      h: 1
    }
  ]
});
var codeluppi2018 = __spreadProps(__spreadValues({}, linnarssonBase), {
  public: true,
  coordinationSpace: {
    embeddingZoom: {
      PCA: 0,
      TSNE: 0.75
    },
    embeddingType: {
      PCA: "PCA",
      TSNE: "t-SNE"
    },
    spatialZoom: {
      A: -5.5
    },
    spatialTargetX: {
      A: 16e3
    },
    spatialTargetY: {
      A: 2e4
    }
  },
  layout: [
    {
      component: "description",
      props: {
        description: `${linnarssonName}: ${linnarssonDescription}`
      },
      x: 0,
      y: 0,
      w: 2,
      h: 1
    },
    {
      component: "layerController",
      x: 0,
      y: 1,
      w: 2,
      h: 4
    },
    {
      component: "status",
      x: 0,
      y: 5,
      w: 2,
      h: 1
    },
    {
      component: "spatial",
      coordinationScopes: {
        spatialZoom: "A",
        spatialTargetX: "A",
        spatialTargetY: "A"
      },
      x: 2,
      y: 0,
      w: 4,
      h: 4
    },
    {
      component: "genes",
      x: 9,
      y: 0,
      w: 3,
      h: 2
    },
    {
      component: "cellSets",
      x: 9,
      y: 3,
      w: 3,
      h: 2
    },
    {
      component: "heatmap",
      props: {
        transpose: true
      },
      x: 2,
      y: 4,
      w: 5,
      h: 2
    },
    {
      component: "cellSetExpression",
      x: 7,
      y: 4,
      w: 5,
      h: 2
    },
    {
      component: "scatterplot",
      coordinationScopes: {
        embeddingType: "PCA",
        embeddingZoom: "PCA"
      },
      x: 6,
      y: 0,
      w: 3,
      h: 2
    },
    {
      component: "scatterplot",
      coordinationScopes: {
        embeddingType: "TSNE",
        embeddingZoom: "TSNE"
      },
      x: 6,
      y: 2,
      w: 3,
      h: 2
    }
  ]
});
var linnarssonWithRorb = __spreadProps(__spreadValues({}, linnarssonBaseNoMolecules), {
  coordinationSpace: {
    embeddingZoom: {
      PCA: 0,
      TSNE: 0.75
    },
    embeddingType: {
      PCA: "PCA",
      TSNE: "t-SNE"
    },
    spatialZoom: {
      A: -5.5
    },
    spatialTargetX: {
      A: 16e3
    },
    spatialTargetY: {
      A: 2e4
    },
    geneSelection: {
      A: ["Rorb"]
    },
    geneExpressionColormapRange: {
      A: [0, 0.75]
    }
  },
  layout: [
    {
      component: "description",
      props: {
        description: `${linnarssonName}: ${linnarssonDescription}`
      },
      x: 0,
      y: 0,
      w: 2,
      h: 2
    },
    {
      component: "layerController",
      x: 0,
      y: 2,
      w: 2,
      h: 4
    },
    {
      component: "spatial",
      coordinationScopes: {
        spatialZoom: "A",
        spatialTargetX: "A",
        spatialTargetY: "A",
        geneSelection: "A"
      },
      x: 2,
      y: 0,
      w: 4,
      h: 4
    },
    {
      component: "genes",
      coordinationScopes: {
        geneSelection: "A"
      },
      x: 9,
      y: 0,
      w: 3,
      h: 2
    },
    {
      component: "cellSets",
      x: 9,
      y: 3,
      w: 3,
      h: 2
    },
    {
      component: "heatmap",
      coordinationScopes: {
        geneSelection: "A",
        geneExpressionColormapRange: "A"
      },
      props: {
        transpose: true
      },
      x: 2,
      y: 4,
      w: 10,
      h: 2
    },
    {
      component: "scatterplot",
      coordinationScopes: {
        embeddingType: "TSNE",
        embeddingZoom: "TSNE",
        geneSelection: "A"
      },
      x: 6,
      y: 0,
      w: 3,
      h: 4
    }
  ]
});
function getCodeluppiViewConfig(name2, description2) {
  const vc = new vapi.VitessceConfig("1.0.0", name2, description2);
  const dataset = vc.addDataset(linnarssonName, linnarssonDescription).addFile(getS3Url("linnarsson", "cells"), vapi.dt.CELLS, vapi.ft.CELLS_JSON).addFile(getS3Url("linnarsson", "cell-sets"), vapi.dt.CELL_SETS, vapi.ft.CELL_SETS_JSON).addFile(getS3Url("linnarsson", "raster"), vapi.dt.RASTER, vapi.ft.RASTER_JSON).addFile(getS3Url("linnarsson", "molecules"), vapi.dt.MOLECULES, vapi.ft.MOLECULES_JSON);
  return [vc, dataset];
}

// src/demo/view-configs/eng.js
var driesName = "Eng et al., Nature 2019";
var driesDescription = "Transcriptome-scale super-resolved imaging in tissues by RNA seqFISH";
var eng2019 = {
  name: driesName,
  version: "1.0.14",
  description: driesDescription,
  public: true,
  datasets: [
    {
      uid: "dries-2019",
      name: "Dries 2019",
      files: [
        "cells",
        "cell-sets"
      ].map(makeDatasetNameToJsonFiles("dries"))
    }
  ],
  initStrategy: "auto",
  coordinationSpace: {
    embeddingCellSetPolygonsVisible: {
      A: false
    },
    embeddingCellSetLabelsVisible: {
      A: true
    },
    embeddingCellSetLabelSize: {
      A: 16
    },
    embeddingCellRadius: {
      A: 1
    },
    embeddingZoom: {
      TSNE: 3,
      UMAP: 3
    },
    spatialZoom: {
      A: -4.4
    },
    spatialTargetX: {
      A: 3800
    },
    spatialTargetY: {
      A: -900
    }
  },
  layout: [
    {
      component: "description",
      props: {
        description: `${driesName}: ${driesDescription}`
      },
      x: 9,
      y: 0,
      w: 3,
      h: 2
    },
    {
      component: "status",
      x: 9,
      y: 2,
      w: 3,
      h: 2
    },
    {
      component: "cellSets",
      x: 9,
      y: 4,
      w: 3,
      h: 4
    },
    {
      component: "cellSetSizes",
      x: 5,
      y: 4,
      w: 4,
      h: 4
    },
    {
      component: "scatterplot",
      coordinationScopes: {
        embeddingZoom: "TSNE",
        embeddingCellSetLabelsVisible: "A",
        embeddingCellSetLabelSize: "A",
        embeddingCellSetPolygonsVisible: "A",
        embeddingCellRadius: "A"
      },
      coordinationValues: {
        embeddingType: "t-SNE"
      },
      x: 0,
      y: 2,
      w: 5,
      h: 4
    },
    {
      component: "spatial",
      props: {
        cellRadius: 50
      },
      coordinationScopes: {
        spatialZoom: "A",
        spatialTargetX: "A",
        spatialTargetY: "A"
      },
      x: 5,
      y: 0,
      w: 4,
      h: 4
    },
    {
      component: "scatterplot",
      coordinationScopes: {
        embeddingZoom: "UMAP",
        embeddingCellSetLabelsVisible: "A",
        embeddingCellSetLabelSize: "A",
        embeddingCellSetPolygonsVisible: "A",
        embeddingCellRadius: "A"
      },
      coordinationValues: {
        embeddingType: "UMAP"
      },
      x: 0,
      y: 0,
      w: 5,
      h: 4
    }
  ]
};
function getEngViewConfig(name2, description2) {
  const vc = new vapi.VitessceConfig("1.0.0", name2, description2);
  const dataset = vc.addDataset(driesName, driesDescription).addFile(getS3Url("dries", "cells"), vapi.dt.CELLS, vapi.ft.CELLS_JSON).addFile(getS3Url("dries", "cell-sets"), vapi.dt.CELL_SETS, vapi.ft.CELL_SETS_JSON);
  return [vc, dataset];
}

// src/demo/view-configs/wang.js
var wangName = "Wang et al., Scientific Reports 2018";
var wangDescription = "Multiplexed imaging of high-density libraries of RNAs with MERFISH and expansion microscopy";
var wang2018 = {
  name: wangName,
  version: "1.0.0",
  description: wangDescription,
  public: true,
  datasets: [
    {
      uid: "wang-2018",
      name: "Wang 2018",
      files: [
        ...[
          "cells",
          "molecules"
        ].map(makeDatasetNameToJsonFiles("wang")),
        __spreadProps(__spreadValues({}, makeDatasetNameToJsonFiles("wang")("genes")), {
          type: "expression-matrix"
        })
      ]
    }
  ],
  initStrategy: "auto",
  coordinationSpace: {
    spatialZoom: {
      A: -1
    },
    spatialLayers: {
      A: [
        {
          type: "molecules",
          radius: 2,
          opacity: 1,
          visible: true
        },
        {
          type: "cells",
          opacity: 1,
          radius: 50,
          visible: true,
          stroked: false
        }
      ]
    }
  },
  layout: [
    {
      component: "spatial",
      coordinationScopes: {
        spatialZoom: "A",
        spatialLayers: "A"
      },
      x: 0,
      y: 0,
      w: 10,
      h: 2
    },
    {
      component: "genes",
      x: 10,
      y: 0,
      w: 2,
      h: 2
    }
  ]
};

// src/demo/view-configs/spraggins.js
var vanderbiltDescription = "High bit depth (uint16) multiplex immunofluorescence images of the kidney by the BIOmolecular Multimodal Imaging Center (BIOMIC) at Vanderbilt University";
var vanderbiltBase = {
  description: vanderbiltDescription,
  layers: [
    {
      name: "raster",
      type: "RASTER",
      fileType: "raster.json",
      url: `${urlPrefix}/spraggins/spraggins.raster.json`
    }
  ]
};
var spraggins2020 = __spreadProps(__spreadValues({}, vanderbiltBase), {
  version: "0.1.0",
  name: "Spraggins",
  public: true,
  staticLayout: [
    {
      component: "spatial",
      props: {
        view: {
          zoom: -6.5,
          target: [2e4, 2e4, 0]
        }
      },
      x: 0,
      y: 0,
      w: 9,
      h: 2
    },
    {
      component: "layerController",
      x: 9,
      y: 0,
      w: 3,
      h: 2
    }
  ]
});
var neumann2020 = {
  version: "1.0.1",
  name: "Neumann et al., 2020",
  description: "Four registered imaging modalities (PAS, IMS, AF) from HuBMAP collection HBM876.XNRH.336",
  datasets: [
    {
      uid: "A",
      name: "Spraggins",
      files: [
        {
          type: "raster",
          fileType: "raster.json",
          options: {
            schemaVersion: "0.0.2",
            images: [
              {
                name: "PAS",
                type: "ome-tiff",
                url: "https://assets.hubmapconsortium.org/f4188a148e4c759092d19369d310883b/ometiff-pyramids/processedMicroscopy/VAN0006-LK-2-85-PAS_images/VAN0006-LK-2-85-PAS_registered.ome.tif?token="
              },
              {
                name: "AF",
                type: "ome-tiff",
                url: "https://assets.hubmapconsortium.org/2130d5f91ce61d7157a42c0497b06de8/ometiff-pyramids/processedMicroscopy/VAN0006-LK-2-85-AF_preIMS_images/VAN0006-LK-2-85-AF_preIMS_registered.ome.tif?token="
              },
              {
                name: "IMS PosMode",
                type: "ome-tiff",
                url: "https://assets.hubmapconsortium.org/be503a021ed910c0918842e318e6efa2/ometiff-pyramids/ometiffs/VAN0006-LK-2-85-IMS_PosMode_multilayer.ome.tif?token="
              },
              {
                name: "IMS NegMode",
                type: "ome-tiff",
                url: "https://assets.hubmapconsortium.org/ca886a630b2038997a4cfbbf4abfd283/ometiff-pyramids/ometiffs/VAN0006-LK-2-85-IMS_NegMode_multilayer.ome.tif?token="
              }
            ],
            usePhysicalSizeScaling: true,
            renderLayers: [
              "PAS",
              "AF",
              "IMS PosMode",
              "IMS NegMode"
            ]
          }
        }
      ]
    }
  ],
  coordinationSpace: {},
  layout: [
    {
      component: "spatial",
      coordinationScopes: {},
      x: 0,
      y: 0,
      w: 9,
      h: 12
    },
    {
      component: "layerController",
      coordinationScopes: {},
      x: 9,
      y: 0,
      w: 3,
      h: 12
    }
  ],
  initStrategy: "auto"
};

// src/demo/view-configs/satija.js
var satijaName = "HBM336.FWTN.636";
var satijaDescription = "Spleen scRNA-seq HuBMAP dataset with cell type annotations generated by the Satija lab and the Seurat v3.1 Label Transfer workflow";
var satija2020 = {
  version: "1.0.15",
  name: satijaName,
  description: satijaDescription,
  public: true,
  datasets: [
    {
      uid: "339952f4-a47f-46dc-9228-18ba2ca256f2",
      name: "339952f4-a47f-46dc-9228-18ba2ca256f2",
      files: [
        {
          fileType: "cells.json",
          url: "https://s3.amazonaws.com/vitessce-data/0.0.31/master_release/satija/2dca1bf5832a4102ba780e9e54f6c350.cells.json"
        },
        {
          fileType: "cell-sets.json",
          url: "https://s3.amazonaws.com/vitessce-data/0.0.31/master_release/satija/2dca1bf5832a4102ba780e9e54f6c350.cell-sets.json"
        },
        {
          fileType: "expression-matrix.zarr",
          url: "https://vitessce-data.storage.googleapis.com/0.0.31/master_release/satija/2dca1bf5832a4102ba780e9e54f6c350.expression-matrix.zarr"
        }
      ]
    }
  ],
  initStrategy: "auto",
  coordinationSpace: {
    embeddingType: {
      UMAP: "UMAP"
    },
    embeddingZoom: {
      A: 3
    },
    embeddingTargetX: {
      A: 0
    },
    embeddingTargetY: {
      A: 0
    },
    spatialZoom: {},
    spatialTargetX: {},
    spatialTargetY: {},
    geneExpressionColormapRange: {
      A: [0, 0.25]
    }
  },
  layout: [
    {
      component: "cellSets",
      h: 4,
      w: 4,
      x: 4,
      y: 0,
      coordinationScopes: {}
    },
    {
      component: "cellSetSizes",
      h: 4,
      w: 4,
      x: 8,
      y: 0,
      coordinationScopes: {}
    },
    {
      component: "scatterplot",
      h: 4,
      props: {
        mapping: "UMAP",
        view: {
          target: [
            0,
            0,
            0
          ],
          zoom: 3
        }
      },
      w: 4,
      x: 0,
      y: 0,
      coordinationScopes: {
        embeddingType: "UMAP",
        embeddingZoom: "A",
        embeddingTargetX: "A",
        embeddingTargetY: "A"
      }
    },
    {
      component: "heatmap",
      h: 4,
      w: 10,
      x: 0,
      y: 4,
      coordinationScopes: {
        geneExpressionColormapRange: "A"
      }
    },
    {
      component: "description",
      h: 4,
      w: 2,
      x: 10,
      y: 4,
      props: {
        description: `${satijaName}: ${satijaDescription}`
      }
    }
  ]
};

// src/demo/view-configs/rao.js
var justHiglass = {
  public: false,
  initStrategy: "auto",
  version: "1.0.0",
  datasets: [
    {
      uid: "higlass-dataset",
      name: "HiGlass Dataset",
      files: []
    }
  ],
  name: "HiGlass demo",
  coordinationSpace: {
    genomicZoomX: {
      A: 0
    },
    genomicZoomY: {
      A: 0
    },
    genomicTargetX: {
      A: 15499999995e-1
    },
    genomicTargetY: {
      A: 15499999995e-1
    }
  },
  layout: [
    {
      component: "higlass",
      coordinationScopes: {
        genomicZoomX: "A",
        genomicZoomY: "A",
        genomicTargetX: "A",
        genomicTargetY: "A"
      },
      props: {
        hgViewConfig: {
          uid: "aa",
          autocompleteSource: "/api/v1/suggest/?d=OHJakQICQD6gTD7skx4EWA&",
          genomePositionSearchBox: {
            autocompleteServer: "//higlass.io/api/v1",
            autocompleteId: "OHJakQICQD6gTD7skx4EWA",
            chromInfoServer: "//higlass.io/api/v1",
            chromInfoId: "hg19",
            visible: true
          },
          chromInfoPath: "//s3.amazonaws.com/pkerp/data/hg19/chromSizes.tsv",
          tracks: {
            top: [
              {
                type: "horizontal-gene-annotations",
                height: 60,
                tilesetUid: "OHJakQICQD6gTD7skx4EWA",
                server: "//higlass.io/api/v1",
                uid: "OHJakQICQD6gTD7skx4EWA",
                options: {
                  name: "Gene Annotations (hg19)",
                  fontSize: 10,
                  labelPosition: "hidden",
                  labelLeftMargin: 0,
                  labelRightMargin: 0,
                  labelTopMargin: 0,
                  labelBottomMargin: 0,
                  minHeight: 24,
                  geneAnnotationHeight: 16,
                  geneLabelPosition: "outside",
                  geneStrandSpacing: 4,
                  showMousePosition: true,
                  mousePositionColor: "#ff00ff",
                  plusStrandColor: "#fdff54",
                  minusStrandColor: "#68bf30",
                  labelColor: "black",
                  trackBorderWidth: 0,
                  trackBorderColor: "black"
                }
              },
              {
                chromInfoPath: "//s3.amazonaws.com/pkerp/data/hg19/chromSizes.tsv",
                type: "horizontal-chromosome-labels",
                height: 30,
                uid: "X4e_1DKiQHmyghDa6lLMVA",
                options: {
                  color: "#808080",
                  stroke: "black",
                  fontSize: 12,
                  fontIsLeftAligned: false,
                  showMousePosition: true,
                  mousePositionColor: "#ff00ff"
                }
              }
            ],
            left: [
              {
                type: "vertical-gene-annotations",
                width: 60,
                tilesetUid: "OHJakQICQD6gTD7skx4EWA",
                server: "//higlass.io/api/v1",
                options: {
                  labelPosition: "bottomRight",
                  name: "Gene Annotations (hg19)",
                  fontSize: 10,
                  labelLeftMargin: 0,
                  labelRightMargin: 0,
                  labelTopMargin: 0,
                  labelBottomMargin: 0,
                  minWidth: 24,
                  geneAnnotationHeight: 16,
                  geneLabelPosition: "outside",
                  geneStrandSpacing: 4,
                  showMousePosition: true,
                  mousePositionColor: "#ff00ff",
                  plusStrandColor: "#fdff54",
                  minusStrandColor: "#68bf30",
                  labelColor: "black",
                  trackBorderWidth: 0,
                  trackBorderColor: "black"
                },
                uid: "dqBTMH78Rn6DeSyDBoAEXw"
              },
              {
                chromInfoPath: "//s3.amazonaws.com/pkerp/data/hg19/chromSizes.tsv",
                type: "vertical-chromosome-labels",
                width: 30,
                uid: "RHdQK4IRQ7yJeDmKWb7Pcg",
                options: {
                  color: "#777777",
                  stroke: "black",
                  fontSize: 12,
                  fontIsLeftAligned: false,
                  minWidth: 35,
                  showMousePosition: true,
                  mousePositionColor: "#ff00ff"
                }
              }
            ],
            center: [
              {
                uid: "c1",
                type: "combined",
                height: 600,
                contents: [
                  {
                    server: "//higlass.io/api/v1",
                    tilesetUid: "CQMd6V_cRw6iCI_-Unl3PQ",
                    type: "heatmap",
                    options: {
                      maxZoom: null,
                      labelPosition: "bottomRight",
                      name: "Rao et al. (2014) GM12878 MboI (allreps) 1kb",
                      backgroundColor: "black",
                      labelLeftMargin: 0,
                      labelRightMargin: 0,
                      labelTopMargin: 0,
                      labelBottomMargin: 0,
                      labelShowResolution: true,
                      labelShowAssembly: true,
                      labelColor: "#ffffff",
                      labelTextOpacity: 0.5,
                      labelBackgroundColor: "black",
                      labelBackgroundOpacity: 0.01,
                      colorRange: [
                        "#000000",
                        "#222e54",
                        "#448db2",
                        "#68bf30",
                        "#fdff54",
                        "#FFFFFF"
                      ],
                      colorbarBackgroundColor: "black",
                      colorbarBackgroundOpacity: 0.01,
                      colorbarPosition: "topRight",
                      trackBorderWidth: 0,
                      trackBorderColor: "black",
                      heatmapValueScaling: "log",
                      showMousePosition: true,
                      mousePositionColor: "#ff00ff",
                      showTooltip: false,
                      extent: "full",
                      zeroValueColor: null,
                      scaleStartPercent: "0.00000",
                      scaleEndPercent: "1.00000"
                    },
                    height: 500,
                    uid: "GjuZed1ySGW1IzZZqFB9BA",
                    transforms: [
                      {
                        name: "ICE",
                        value: "weight"
                      }
                    ]
                  }
                ],
                options: {}
              }
            ],
            right: [],
            bottom: [],
            whole: [],
            gallery: []
          },
          layout: {
            w: 12,
            h: 12,
            x: 0,
            y: 0,
            moved: false,
            static: false
          }
        }
      },
      x: 0,
      y: 0,
      w: 8,
      h: 2
    },
    {
      component: "higlass",
      coordinationScopes: {
        genomicZoomX: "A",
        genomicZoomY: "A",
        genomicTargetX: "A",
        genomicTargetY: "A"
      },
      props: {
        hgViewConfig: {
          uid: "aa",
          autocompleteSource: "/api/v1/suggest/?d=OHJakQICQD6gTD7skx4EWA&",
          genomePositionSearchBox: {
            autocompleteServer: "//higlass.io/api/v1",
            autocompleteId: "OHJakQICQD6gTD7skx4EWA",
            chromInfoServer: "//higlass.io/api/v1",
            chromInfoId: "hg19",
            visible: true
          },
          chromInfoPath: "//s3.amazonaws.com/pkerp/data/hg19/chromSizes.tsv",
          tracks: {
            top: [
              {
                type: "horizontal-gene-annotations",
                height: 60,
                tilesetUid: "OHJakQICQD6gTD7skx4EWA",
                server: "//higlass.io/api/v1",
                uid: "OHJakQICQD6gTD7skx4EWA",
                options: {
                  name: "Gene Annotations (hg19)",
                  fontSize: 10,
                  labelPosition: "hidden",
                  labelLeftMargin: 0,
                  labelRightMargin: 0,
                  labelTopMargin: 0,
                  labelBottomMargin: 0,
                  minHeight: 24,
                  geneAnnotationHeight: 16,
                  geneLabelPosition: "outside",
                  geneStrandSpacing: 4,
                  showMousePosition: true,
                  mousePositionColor: "#ff00ff",
                  plusStrandColor: "#fdff54",
                  minusStrandColor: "#68bf30",
                  labelColor: "black",
                  trackBorderWidth: 0,
                  trackBorderColor: "black"
                }
              },
              {
                chromInfoPath: "//s3.amazonaws.com/pkerp/data/hg19/chromSizes.tsv",
                type: "horizontal-chromosome-labels",
                height: 30,
                uid: "X4e_1DKiQHmyghDa6lLMVA",
                options: {
                  color: "#808080",
                  stroke: "black",
                  fontSize: 12,
                  fontIsLeftAligned: false,
                  showMousePosition: true,
                  mousePositionColor: "#ff00ff"
                }
              }
            ],
            left: [
              {
                type: "vertical-gene-annotations",
                width: 60,
                tilesetUid: "OHJakQICQD6gTD7skx4EWA",
                server: "//higlass.io/api/v1",
                options: {
                  labelPosition: "bottomRight",
                  name: "Gene Annotations (hg19)",
                  fontSize: 10,
                  labelLeftMargin: 0,
                  labelRightMargin: 0,
                  labelTopMargin: 0,
                  labelBottomMargin: 0,
                  minWidth: 24,
                  geneAnnotationHeight: 16,
                  geneLabelPosition: "outside",
                  geneStrandSpacing: 4,
                  showMousePosition: true,
                  mousePositionColor: "#ff00ff",
                  plusStrandColor: "#fdff54",
                  minusStrandColor: "#68bf30",
                  labelColor: "black",
                  trackBorderWidth: 0,
                  trackBorderColor: "black"
                },
                uid: "dqBTMH78Rn6DeSyDBoAEXw"
              },
              {
                chromInfoPath: "//s3.amazonaws.com/pkerp/data/hg19/chromSizes.tsv",
                type: "vertical-chromosome-labels",
                width: 30,
                uid: "RHdQK4IRQ7yJeDmKWb7Pcg",
                options: {
                  color: "#777777",
                  stroke: "black",
                  fontSize: 12,
                  fontIsLeftAligned: false,
                  minWidth: 35,
                  showMousePosition: true,
                  mousePositionColor: "#ff00ff"
                }
              }
            ],
            center: [
              {
                uid: "c1",
                type: "combined",
                height: 600,
                contents: [
                  {
                    server: "//higlass.io/api/v1",
                    tilesetUid: "CQMd6V_cRw6iCI_-Unl3PQ",
                    type: "heatmap",
                    options: {
                      maxZoom: null,
                      labelPosition: "bottomRight",
                      name: "Rao et al. (2014) GM12878 MboI (allreps) 1kb",
                      backgroundColor: "black",
                      labelLeftMargin: 0,
                      labelRightMargin: 0,
                      labelTopMargin: 0,
                      labelBottomMargin: 0,
                      labelShowResolution: true,
                      labelShowAssembly: true,
                      labelColor: "#ffffff",
                      labelTextOpacity: 0.5,
                      labelBackgroundColor: "black",
                      labelBackgroundOpacity: 0.01,
                      colorRange: [
                        "#000000",
                        "#222e54",
                        "#448db2",
                        "#68bf30",
                        "#fdff54",
                        "#FFFFFF"
                      ],
                      colorbarBackgroundColor: "black",
                      colorbarBackgroundOpacity: 0.01,
                      colorbarPosition: "topRight",
                      trackBorderWidth: 0,
                      trackBorderColor: "black",
                      heatmapValueScaling: "log",
                      showMousePosition: true,
                      mousePositionColor: "#ff00ff",
                      showTooltip: false,
                      extent: "full",
                      zeroValueColor: null,
                      scaleStartPercent: "0.00000",
                      scaleEndPercent: "1.00000"
                    },
                    height: 500,
                    uid: "GjuZed1ySGW1IzZZqFB9BA",
                    transforms: [
                      {
                        name: "ICE",
                        value: "weight"
                      }
                    ]
                  }
                ],
                options: {}
              }
            ],
            right: [],
            bottom: [],
            whole: [],
            gallery: []
          },
          layout: {
            w: 12,
            h: 12,
            x: 0,
            y: 0,
            moved: false,
            static: false
          }
        }
      },
      x: 8,
      y: 0,
      w: 4,
      h: 2
    }
  ]
};

// src/demo/view-configs/tenx.js
var scAtacSeq10xPbmc = {
  version: "1.0.0",
  name: "HiGlass serverless demo with 10x Genomics scATAC-seq 5k PBMC dataset",
  datasets: [
    {
      uid: "10x-genomics-pbmc",
      name: "10x Genomics PBMC",
      files: [
        {
          type: "genomic-profiles",
          fileType: "genomic-profiles.zarr",
          url: "http://higlass-serverless.s3.amazonaws.com/multivec/pbmc_10x_peaks_by_cluster.zarr"
        }
      ]
    }
  ],
  layout: [
    {
      component: "genomicProfiles",
      props: {
        profileTrackUidKey: "file"
      },
      x: 0,
      y: 0,
      w: 8,
      h: 2
    },
    {
      component: "description",
      props: {
        description: "10x Genomics scATAC-seq of 5k PBMCs. Note: the Zarr HiGlass Plugin Datafetcher is not yet optimized. Please be patient while the HiGlass tracks load."
      },
      x: 8,
      y: 0,
      w: 4,
      h: 2
    }
  ],
  initStrategy: "auto"
};

// src/demo/view-configs/blin.js
var blinName = "Blin et al., PLoS Biol 2019";
var blinDescription = "Mouse blastocysts imaged by confocal microscopy";
var blin2019 = {
  version: "1.0.6",
  name: blinName,
  description: blinDescription,
  public: true,
  datasets: [
    {
      uid: "idr0062-blin-nuclearsegmentation/6001240",
      name: "idr0062-blin-nuclearsegmentation/6001240",
      files: [
        {
          type: "raster",
          fileType: "raster.ome-zarr",
          url: "https://minio-dev.openmicroscopy.org/idr/v0.3/idr0062-blin-nuclearsegmentation/6001240.zarr"
        }
      ]
    }
  ],
  initStrategy: "auto",
  layout: [
    {
      component: "spatial",
      x: 0,
      y: 0,
      w: 8,
      h: 12
    },
    {
      component: "layerController",
      x: 8,
      y: 0,
      w: 4,
      h: 6
    },
    {
      component: "description",
      x: 8,
      y: 6,
      w: 4,
      h: 3
    },
    {
      component: "status",
      x: 8,
      y: 9,
      w: 4,
      h: 3
    }
  ]
};

// src/demo/view-configs/ome-ngff-legacy.js
var blinName2 = "179706";
var blinDescription2 = "Example of OME-NGFF v0.1";
var omeNgffLegacy = {
  version: "1.0.6",
  name: blinName2,
  description: blinDescription2,
  public: false,
  datasets: [
    {
      uid: "179706",
      name: "179706",
      files: [
        {
          type: "raster",
          fileType: "raster.ome-zarr",
          url: "https://s3.embassy.ebi.ac.uk/idr/zarr/v0.1/179706.zarr"
        }
      ]
    }
  ],
  coordinationSpace: {
    spatialZoom: {
      A: -0.38015
    },
    spatialTargetX: {
      A: 807.843
    },
    spatialTargetY: {
      A: 537.031
    }
  },
  initStrategy: "auto",
  layout: [
    {
      component: "spatial",
      coordinationScopes: {
        spatialZoom: "A",
        spatialTargetX: "A",
        spatialTargetY: "A"
      },
      x: 0,
      y: 0,
      w: 8,
      h: 12
    },
    {
      component: "layerController",
      x: 8,
      y: 0,
      w: 4,
      h: 6
    },
    {
      component: "description",
      x: 8,
      y: 6,
      w: 4,
      h: 3
    },
    {
      component: "status",
      x: 8,
      y: 9,
      w: 4,
      h: 3
    }
  ]
};

// src/demo/view-configs/hubmap.js
function getConfig() {
  const vc = new vapi.VitessceConfig("1.0.0", "HBM485.TBWH.322", "Large intestine snATAC-seq HuBMAP dataset with genomic data visualization powered by HiGlass");
  const baseUrl = "https://vitessce-data.s3.amazonaws.com/0.0.32/master_release/human_intestine_2020_hubmap";
  const dataset = vc.addDataset("HBM485.TBWH.322", "Human large intestine, snATAC-seq").addFile(`${baseUrl}/human_intestine_2020_hubmap.cells.json`, vapi.dt.CELLS, vapi.ft.CELLS_JSON).addFile(`${baseUrl}/human_intestine_2020_hubmap.cell-sets.json`, vapi.dt.CELL_SETS, vapi.ft.CELL_SETS_JSON).addFile(`${baseUrl}/human_intestine_2020_hubmap.genomic-profiles.zarr`, vapi.dt.GENOMIC_PROFILES, vapi.ft.GENOMIC_PROFILES_ZARR);
  const umap = vc.addView(dataset, vapi.cm.SCATTERPLOT, { mapping: "UMAP" });
  const cellSetsManager = vc.addView(dataset, vapi.cm.CELL_SETS);
  const genomicProfiles = vc.addView(dataset, vapi.cm.GENOMIC_PROFILES);
  vc.layout(vapi.vconcat(genomicProfiles, vapi.hconcat(umap, cellSetsManager)));
  return vc.toJSON();
}
var hubmapIntestineSnAtacSeq = getConfig();

// src/demo/view-configs/coordination-types/embeddingZoom.js
function getConfig2() {
  const [vc, dataset] = getCodeluppiViewConfig(`Coordination Type: ${vapi.ct.EMBEDDING_ZOOM}`, "Zoom levels in the scatterplots are coordinated.");
  const v1 = vc.addView(dataset, vapi.cm.SCATTERPLOT, { mapping: "t-SNE" });
  const v2 = vc.addView(dataset, vapi.cm.SCATTERPLOT, { mapping: "t-SNE" });
  vc.linkViews([v1, v2], [vapi.ct.EMBEDDING_ZOOM], [-1]);
  vc.layout(vapi.hconcat(v1, v2));
  return vc.toJSON();
}
var embeddingZoomConfig = getConfig2();

// src/demo/view-configs/coordination-types/embeddingTargetX.js
function getConfig3() {
  const [vc, dataset] = getCodeluppiViewConfig(`Coordination Type: ${vapi.ct.EMBEDDING_TARGET_X}`, "Panning along the x-axis of the scatterplots is coordinated.");
  const v1 = vc.addView(dataset, vapi.cm.SCATTERPLOT, { mapping: "t-SNE" });
  const v2 = vc.addView(dataset, vapi.cm.SCATTERPLOT, { mapping: "t-SNE" });
  vc.linkViews([v1, v2], [vapi.ct.EMBEDDING_TARGET_X], [0]);
  vc.layout(vapi.hconcat(v1, v2));
  return vc.toJSON();
}
var embeddingTargetXConfig = getConfig3();

// src/demo/view-configs/coordination-types/embeddingTargetY.js
function getConfig4() {
  const [vc, dataset] = getCodeluppiViewConfig(`Coordination Type: ${vapi.ct.EMBEDDING_TARGET_Y}`, "Panning along the y-axis of the scatterplots is coordinated.");
  const v1 = vc.addView(dataset, vapi.cm.SCATTERPLOT, { mapping: "t-SNE" });
  const v2 = vc.addView(dataset, vapi.cm.SCATTERPLOT, { mapping: "t-SNE" });
  vc.linkViews([v1, v2], [vapi.ct.EMBEDDING_TARGET_Y], [0]);
  vc.layout(vapi.hconcat(v1, v2));
  return vc.toJSON();
}
var embeddingTargetYConfig = getConfig4();

// src/demo/view-configs/coordination-types/embeddingCellSetPolygonsVisible.js
function getConfig5() {
  const [vc, dataset] = getEngViewConfig(`Coordination Type: ${vapi.ct.EMBEDDING_CELL_SET_POLYGONS_VISIBLE}`, 'Visibility of polygon overlays is coordinated in the top two scatterplots, and independent in the bottom two. Try clicking the gear above each plot and toggling the "Cell Set Polygons Visible" checkboxes.');
  const v1 = vc.addView(dataset, vapi.cm.SCATTERPLOT, {
    mapping: "t-SNE",
    x: 0,
    y: 0,
    w: 5,
    h: 6
  });
  const v2 = vc.addView(dataset, vapi.cm.SCATTERPLOT, {
    mapping: "t-SNE",
    x: 5,
    y: 0,
    w: 5,
    h: 6
  });
  vc.addView(dataset, vapi.cm.SCATTERPLOT, {
    mapping: "t-SNE",
    x: 0,
    y: 6,
    w: 5,
    h: 6
  });
  const v4 = vc.addView(dataset, vapi.cm.SCATTERPLOT, {
    mapping: "t-SNE",
    x: 5,
    y: 6,
    w: 5,
    h: 6
  });
  vc.addView(dataset, vapi.cm.CELL_SETS, {
    x: 10,
    y: 0,
    w: 2,
    h: 12
  });
  vc.linkViews([v1, v2], [vapi.ct.EMBEDDING_CELL_SET_POLYGONS_VISIBLE], [true]);
  vc.linkViews([v4], [vapi.ct.EMBEDDING_CELL_SET_POLYGONS_VISIBLE], [true]);
  return vc.toJSON();
}
var embeddingCellSetPolygonsVisibleConfig = getConfig5();

// src/demo/configs.js
var coordinationTypeConfigs = {
  [vapi.ct.EMBEDDING_ZOOM]: embeddingZoomConfig,
  [vapi.ct.EMBEDDING_TARGET_X]: embeddingTargetXConfig,
  [vapi.ct.EMBEDDING_TARGET_Y]: embeddingTargetYConfig,
  [vapi.ct.EMBEDDING_OBS_SET_POLYGONS_VISIBLE]: embeddingCellSetPolygonsVisibleConfig
};
var configs = __spreadValues({
  "just-scatter": justScatter,
  "just-scatter-expression": justScatterExpression,
  "just-spatial": justSpatial,
  "just-higlass": justHiglass,
  "codeluppi-2018": codeluppi2018,
  "eng-2019": eng2019,
  "wang-2018": wang2018,
  "spraggins-2020": spraggins2020,
  "neumann-2020": neumann2020,
  "satija-2020": satija2020,
  "sn-atac-seq-hubmap-2020": hubmapIntestineSnAtacSeq,
  "sc-atac-seq-10x-genomics-pbmc": scAtacSeq10xPbmc,
  "blin-2019": blin2019,
  "ome-ngff-v0.1": omeNgffLegacy,
  "linnarsson-2018": notPublic(codeluppi2018),
  vanderbilt: notPublic(spraggins2020),
  "dries-2019": notPublic(eng2019)
}, coordinationTypeConfigs);

// src/demo/view-configs/plugin-view-type.js
import React4 from "react";

// src/app/constant-relationships.js
var FILE_TYPE_DATA_TYPE_MAPPING = {
  [FileType.CELLS_JSON]: DataType.CELLS,
  [FileType.CELL_SETS_JSON]: DataType.CELL_SETS,
  [FileType.EXPRESSION_MATRIX_ZARR]: DataType.EXPRESSION_MATRIX,
  [FileType.GENOMIC_PROFILES_ZARR]: DataType.GENOMIC_PROFILES,
  [FileType.MOLECULES_JSON]: DataType.MOLECULES,
  [FileType.NEIGHBORHOODS_JSON]: DataType.NEIGHBORHOODS,
  [FileType.RASTER_JSON]: DataType.RASTER,
  [FileType.RASTER_OME_ZARR]: DataType.RASTER,
  [FileType.CLUSTERS_JSON]: DataType.EXPRESSION_MATRIX,
  [FileType.GENES_JSON]: DataType.EXPRESSION_MATRIX,
  [FileType.ANNDATA_CELL_SETS_ZARR]: DataType.CELL_SETS,
  [FileType.ANNDATA_CELLS_ZARR]: DataType.CELLS,
  [FileType.ANNDATA_EXPRESSION_MATRIX_ZARR]: DataType.EXPRESSION_MATRIX
};

// src/app/state/coordination.js
var DEFAULT_COORDINATION_VALUES = {
  [CoordinationType.OBS_TYPE]: "cell",
  [CoordinationType.FEATURE_TYPE]: "gene",
  [CoordinationType.FEATURE_VALUE_TYPE]: "expression"
};
var AUTO_INDEPENDENT_COORDINATION_TYPES = [];
var COMPONENT_COORDINATION_TYPES = {
  [Component.STATUS]: [
    CoordinationType.DATASET
  ],
  [Component.DESCRIPTION]: [
    CoordinationType.DATASET
  ]
};

// src/app/plugins.js
var PLUGINS_KEY = "__VITESSCE_PLUGINS__";
var PLUGIN_VIEW_TYPES_KEY = "viewTypes";
var PLUGIN_COORDINATION_TYPES_KEY = "coordinationTypes";
var PLUGIN_COORDINATION_TYPES_PER_VIEW_KEY = "coordinationTypesPerView";
var PLUGIN_FILE_TYPES_KEY = "fileTypes";
var PLUGIN_FILE_TYPE_DATA_TYPE_MAPPING_KEY = "fileTypeDataTypeMapping";
var PLUGIN_CONVENIENCE_FILE_TYPES_KEY = "convenienceFileTypes";
window[PLUGINS_KEY] = {};
var PLUGINS = window[PLUGINS_KEY];
PLUGINS[PLUGIN_VIEW_TYPES_KEY] = PLUGINS[PLUGIN_VIEW_TYPES_KEY] || {};
PLUGINS[PLUGIN_COORDINATION_TYPES_KEY] = PLUGINS[PLUGIN_COORDINATION_TYPES_KEY] || {};
PLUGINS[PLUGIN_COORDINATION_TYPES_PER_VIEW_KEY] = PLUGINS[PLUGIN_COORDINATION_TYPES_PER_VIEW_KEY] || {};
PLUGINS[PLUGIN_FILE_TYPES_KEY] = PLUGINS[PLUGIN_FILE_TYPES_KEY] || {};
PLUGINS[PLUGIN_FILE_TYPE_DATA_TYPE_MAPPING_KEY] = PLUGINS[PLUGIN_FILE_TYPE_DATA_TYPE_MAPPING_KEY] || {};
PLUGINS[PLUGIN_CONVENIENCE_FILE_TYPES_KEY] = PLUGINS[PLUGIN_CONVENIENCE_FILE_TYPES_KEY] || {};
function registerPluginCoordinationType(typeName, defaultValue) {
  PLUGINS[PLUGIN_COORDINATION_TYPES_KEY][typeName] = defaultValue;
}
function registerPluginViewType(viewType, viewSubscriberReactComponent, coordinationTypes) {
  PLUGINS[PLUGIN_VIEW_TYPES_KEY][viewType] = viewSubscriberReactComponent;
  const pluginTypesPerView = PLUGINS[PLUGIN_COORDINATION_TYPES_PER_VIEW_KEY];
  if (Array.isArray(pluginTypesPerView[viewType])) {
    coordinationTypes.forEach((coordinationType) => {
      if (!pluginTypesPerView[viewType].includes(coordinationType)) {
        pluginTypesPerView[viewType].push(coordinationType);
      }
    });
  } else {
    pluginTypesPerView[viewType] = coordinationTypes;
  }
}
function registerPluginFileType(fileTypeName, dataTypeName, dataLoaderClass, dataSourceClass) {
  PLUGINS[PLUGIN_FILE_TYPES_KEY][fileTypeName] = [dataSourceClass, dataLoaderClass];
  PLUGINS[PLUGIN_FILE_TYPE_DATA_TYPE_MAPPING_KEY][fileTypeName] = dataTypeName;
}
function getPluginViewTypes() {
  return Object.keys(PLUGINS[PLUGIN_VIEW_TYPES_KEY]);
}
function getPluginViewType(viewType) {
  return PLUGINS[PLUGIN_VIEW_TYPES_KEY][viewType];
}
function getPluginCoordinationTypes() {
  return Object.keys(PLUGINS[PLUGIN_COORDINATION_TYPES_KEY]);
}
function getPluginCoordinationTypeDefaults() {
  return PLUGINS[PLUGIN_COORDINATION_TYPES_KEY];
}
function getPluginCoordinationTypesForViewType(viewType) {
  if (Array.isArray(PLUGINS[PLUGIN_COORDINATION_TYPES_PER_VIEW_KEY][viewType])) {
    return PLUGINS[PLUGIN_COORDINATION_TYPES_PER_VIEW_KEY][viewType];
  }
  return [];
}
function getPluginFileTypes() {
  return Object.keys(PLUGINS[PLUGIN_FILE_TYPES_KEY]);
}
function getDataTypeForPluginFileType(fileType) {
  return PLUGINS[PLUGIN_FILE_TYPE_DATA_TYPE_MAPPING_KEY][fileType];
}
function getLoaderClassesForPluginFileType(fileType) {
  return PLUGINS[PLUGIN_FILE_TYPES_KEY][fileType];
}
function getFileTypes() {
  return [
    ...Object.values(FileType),
    ...getPluginFileTypes()
  ];
}
function getCoordinationTypes() {
  return [
    ...Object.values(CoordinationType),
    ...getPluginCoordinationTypes()
  ];
}
function getDefaultCoordinationValues() {
  return __spreadValues(__spreadValues({}, DEFAULT_COORDINATION_VALUES), getPluginCoordinationTypeDefaults());
}
function getComponentCoordinationTypes() {
  return __spreadValues(__spreadValues({}, COMPONENT_COORDINATION_TYPES), fromEntries(getPluginViewTypes().map((viewType) => [
    viewType,
    getPluginCoordinationTypesForViewType(viewType)
  ])));
}
function getFileTypeDataTypeMapping() {
  return __spreadValues(__spreadValues({}, FILE_TYPE_DATA_TYPE_MAPPING), fromEntries(getPluginFileTypes().map((fileType) => [
    fileType,
    getDataTypeForPluginFileType(fileType)
  ])));
}
function getConvenienceFileTypes() {
  return __spreadValues({}, PLUGINS[PLUGIN_CONVENIENCE_FILE_TYPES_KEY]);
}

// src/components/TitleInfo.js
import React3, { useState as useState2 } from "react";
import { makeStyles as makeStyles2 } from "@material-ui/core/styles";
import CloudDownloadIcon from "@material-ui/icons/CloudDownload";
import MenuItem from "@material-ui/core/MenuItem";
import IconButton2 from "@material-ui/core/IconButton";
import Link from "@material-ui/core/Link";
import ArrowDropDownIcon from "@material-ui/icons/ArrowDropDown";
import ArrowDropUpIcon from "@material-ui/icons/ArrowDropUp";
import SettingsIcon from "@material-ui/icons/Settings";
import CloseIcon from "@material-ui/icons/Close";

// src/components/classNames.js
var TOOLTIP_ANCESTOR = "tooltip-ancestor";
var CARD = `card card-body my-2 ${TOOLTIP_ANCESTOR}`;
var PRIMARY_CARD = `${CARD} bg-primary`;
var SECONDARY_CARD = `${CARD} bg-secondary`;
var BLACK_CARD = `${CARD} bg-black`;
var SCROLL_CARD = `${PRIMARY_CARD} scroll`;
var VITESSCE_CONTAINER = "vitessce-container";

// src/components/LoadingIndicator.js
import React from "react";
import CircularProgress from "@material-ui/core/CircularProgress";
function LoadingIndicator() {
  return /* @__PURE__ */ React.createElement("div", {
    className: "loading-indicator-backdrop"
  }, /* @__PURE__ */ React.createElement("div", {
    className: "loading-indicator-container"
  }, /* @__PURE__ */ React.createElement(CircularProgress, null)));
}

// src/components/shared-mui/components.js
import React2, { useRef as useRef3 } from "react";
import Paper from "@material-ui/core/Paper";
import Popper from "@material-ui/core/Popper";
import IconButton from "@material-ui/core/IconButton";
import MenuList from "@material-ui/core/MenuList";
import ClickAwayListener from "@material-ui/core/ClickAwayListener";
import Fade from "@material-ui/core/Fade";

// src/components/hooks.js
import {
  useRef as useRef2,
  useState,
  useEffect,
  useCallback as useCallback2,
  useMemo as useMemo2
} from "react";
import debounce from "lodash/debounce";

// src/app/state/hooks.js
import { useRef, useCallback, useMemo } from "react";
import create from "zustand";
import createContext from "zustand/context";
import shallow from "zustand/shallow";
import isMatch from "lodash/isMatch";
var {
  Provider: ViewConfigProviderLocal,
  useStore: useViewConfigStoreLocal,
  useStoreApi: useViewConfigStoreApiLocal
} = createContext();
var ViewConfigProvider = ViewConfigProviderLocal;
var useViewConfigStore = useViewConfigStoreLocal;
var useViewConfigStoreApi = useViewConfigStoreApiLocal;
var {
  Provider: AuxiliaryProviderLocal,
  useStore: useAuxiliaryStoreLocal
} = createContext();
var AuxiliaryProvider = AuxiliaryProviderLocal;
var createViewConfigStore = () => create((set) => ({
  viewConfig: null,
  loaders: null,
  setViewConfig: (viewConfig) => set({ viewConfig }),
  setLoaders: (loaders) => set({ loaders }),
  setCoordinationValue: ({ parameter, scope, value }) => set((state) => ({
    viewConfig: __spreadProps(__spreadValues({}, state.viewConfig), {
      coordinationSpace: __spreadProps(__spreadValues({}, state.viewConfig.coordinationSpace), {
        [parameter]: __spreadProps(__spreadValues({}, state.viewConfig.coordinationSpace[parameter]), {
          [scope]: value
        })
      })
    })
  })),
  removeComponent: (uid) => set((state) => {
    const newLayout = state.viewConfig.layout.filter((c) => c.uid !== uid);
    return {
      viewConfig: __spreadProps(__spreadValues({}, state.viewConfig), {
        layout: newLayout
      })
    };
  }),
  changeLayout: (newComponentProps) => set((state) => {
    const newLayout = state.viewConfig.layout.slice();
    newComponentProps.forEach(([i, newProps]) => {
      newLayout[i] = __spreadValues(__spreadValues({}, newLayout[i]), newProps);
    });
    return {
      viewConfig: __spreadProps(__spreadValues({}, state.viewConfig), {
        layout: newLayout
      })
    };
  })
}));
var createAuxiliaryStore = () => create((set) => ({
  auxiliaryStore: null,
  setCoordinationValue: ({ parameter, scope, value }) => set((state) => ({
    auxiliaryStore: __spreadProps(__spreadValues({}, state.auxiliaryStore), {
      [parameter]: {
        [scope]: value
      }
    })
  }))
}));
var useHoverStore = create((set) => ({
  componentHover: null,
  setComponentHover: (componentHover) => set({ componentHover })
}));
var useWarnStore = create((set) => ({
  warning: null,
  setWarning: (warning) => set({ warning })
}));
var useViewInfoStore = create((set) => ({
  viewInfo: {},
  setComponentViewInfo: (uuid, viewInfo) => set((state) => ({
    viewInfo: __spreadProps(__spreadValues({}, state.viewInfo), {
      [uuid]: viewInfo
    })
  }))
}));
var useGridSizeStore = create((set) => ({
  resizeCount: {},
  incrementResizeCount: () => set((state) => ({
    resizeCount: state.resizeCount + 1
  }))
}));
function useCoordination(parameters, coordinationScopes) {
  const setCoordinationValue = useViewConfigStore((state) => state.setCoordinationValue);
  const values = useViewConfigStore((state) => {
    const { coordinationSpace } = state.viewConfig;
    return fromEntries(parameters.map((parameter) => {
      if (coordinationSpace && coordinationSpace[parameter]) {
        const value = coordinationSpace[parameter][coordinationScopes[parameter]];
        return [parameter, value];
      }
      return [parameter, void 0];
    }));
  }, shallow);
  const setters = useMemo(() => fromEntries(parameters.map((parameter) => {
    const setterName = `set${capitalize(parameter)}`;
    const setterFunc = (value) => setCoordinationValue({
      parameter,
      scope: coordinationScopes[parameter],
      value
    });
    return [setterName, setterFunc];
  })), [parameters, coordinationScopes]);
  return [values, setters];
}
function useDatasetUids(coordinationScopes) {
  const parameter = CoordinationType.DATASET;
  const datasetScopes = coordinationScopes[parameter];
  const datasetUids = useViewConfigStore((state) => {
    const { coordinationSpace } = state.viewConfig;
    const datasetScopesArr = Array.isArray(datasetScopes) ? datasetScopes : [datasetScopes];
    return fromEntries(datasetScopesArr.map((datasetScope) => {
      if (coordinationSpace && coordinationSpace[parameter]) {
        const value = coordinationSpace[parameter][datasetScope];
        return [datasetScope, value];
      }
      return [datasetScope, void 0];
    }));
  }, shallow);
  return datasetUids;
}
function useComplexCoordination(parameters, coordinationScopes, coordinationScopesBy, byType) {
  const setCoordinationValue = useViewConfigStore((state) => state.setCoordinationValue);
  const typeScopes = coordinationScopes[byType];
  const byTypeScopes = coordinationScopesBy[byType];
  const typeScopesArr = Array.isArray(typeScopes) ? typeScopes : [typeScopes];
  const values = useViewConfigStore((state) => {
    const { coordinationSpace } = state.viewConfig;
    return fromEntries(typeScopesArr.map((datasetScope) => {
      const datasetValues = fromEntries(parameters.map((parameter) => {
        if (coordinationSpace && coordinationSpace[parameter]) {
          let value;
          const parameterSpace = coordinationSpace[parameter];
          const parameterScopeGlobal = coordinationScopes[parameter];
          const parameterScopeByDataset = byTypeScopes == null ? void 0 : byTypeScopes[parameter];
          if (parameterScopeByDataset && parameterScopeByDataset[datasetScope]) {
            value = parameterSpace[parameterScopeByDataset[datasetScope]];
          } else if (parameterScopeGlobal) {
            value = parameterSpace[parameterScopeGlobal];
          } else {
            console.error(`coordination scope for ${parameter} was not found.`);
          }
          return [parameter, value];
        }
        return [parameter, void 0];
      }));
      return [datasetScope, datasetValues];
    }));
  }, shallow);
  const setters = useMemo(() => fromEntries(typeScopesArr.map((datasetScope) => {
    const datasetSetters = fromEntries(parameters.map((parameter) => {
      const setterName = `set${capitalize(parameter)}`;
      let setterFunc;
      const parameterScopeGlobal = coordinationScopes[parameter];
      const parameterScopeByDataset = byTypeScopes == null ? void 0 : byTypeScopes[parameter];
      if (parameterScopeByDataset && parameterScopeByDataset[datasetScope]) {
        setterFunc = (value) => setCoordinationValue({
          parameter,
          scope: parameterScopeByDataset[datasetScope],
          value
        });
      } else if (parameterScopeGlobal) {
        setterFunc = (value) => setCoordinationValue({
          parameter,
          scope: parameterScopeGlobal,
          value
        });
      } else {
        console.error(`coordination scope for ${parameter} was not found.`);
      }
      return [setterName, setterFunc];
    }));
    return [datasetScope, datasetSetters];
  })), [parameters, coordinationScopes]);
  return [values, setters];
}
function useMultiDatasetCoordination(parameters, coordinationScopes, coordinationScopesBy) {
  return useComplexCoordination(parameters, coordinationScopes, coordinationScopesBy, CoordinationType.DATASET);
}
function useLoaders() {
  return useViewConfigStore((state) => state.loaders);
}
function useMatchingLoader(loaders, dataset, dataType, viewCoordinationValues) {
  return useMemo(() => {
    if (!loaders[dataset]) {
      return null;
    }
    const loaderInternMap = loaders[dataset].loaders[dataType];
    if (!loaderInternMap) {
      return null;
    }
    const loaderKeys = Array.from(loaderInternMap.keys());
    const matchingKey = loaderKeys.find((fileCoordinationValues) => isMatch(fileCoordinationValues, viewCoordinationValues));
    if (!matchingKey) {
      return null;
    }
    return loaderInternMap.get(matchingKey);
  }, [loaders, dataset, dataType, viewCoordinationValues]);
}
function useLayout() {
  return useViewConfigStore((state) => {
    var _a;
    return (_a = state.viewConfig) == null ? void 0 : _a.layout;
  });
}
function useRemoveComponent() {
  return useViewConfigStore((state) => state.removeComponent);
}
function useChangeLayout() {
  return useViewConfigStore((state) => state.changeLayout);
}
function useSetLoaders() {
  return useViewConfigStore((state) => state.setLoaders);
}
function useSetViewConfig(viewConfigStoreApi) {
  const setViewConfigRef = useRef(viewConfigStoreApi.getState().setViewConfig);
  const setViewConfig = setViewConfigRef.current;
  return setViewConfig;
}
function useComponentHover() {
  return useHoverStore((state) => state.componentHover);
}
function useSetComponentHover() {
  return useHoverStore((state) => state.setComponentHover);
}
function useWarning() {
  return useWarnStore((state) => state.warning);
}
function useSetWarning() {
  return useWarnStore((state) => state.setWarning);
}
function useComponentViewInfo(uuid) {
  return useViewInfoStore(useCallback((state) => state.viewInfo[uuid], [uuid]));
}
function useSetComponentViewInfo(uuid) {
  const setViewInfoRef = useRef(useViewInfoStore.getState().setComponentViewInfo);
  const setComponentViewInfo = (viewInfo) => setViewInfoRef.current(uuid, viewInfo);
  return setComponentViewInfo;
}
function useEmitGridResize() {
  return useGridSizeStore((state) => state.incrementResizeCount);
}

// src/components/hooks.js
function useVitessceContainer(ref) {
  return useCallback2(() => {
    if (ref.current) {
      return ref.current.closest(`.${VITESSCE_CONTAINER}`);
    }
    return null;
  }, [ref]);
}
function useReady(supportedItems) {
  const items = supportedItems;
  const [waiting, setWaiting] = useState(items);
  const setItemIsReady = useCallback2((readyItem) => {
    setWaiting((waitingItems) => {
      const nextWaitingItems = waitingItems.filter((item) => item !== readyItem);
      console.log(`cleared ${readyItem}; waiting on ${nextWaitingItems.length}: ${JSON.stringify(nextWaitingItems)}`);
      return nextWaitingItems;
    });
  }, [setWaiting]);
  const setItemIsNotReady = useCallback2((notReadyItem) => {
    setWaiting((waitingItems) => {
      const nextWaitingItems = [...waitingItems, notReadyItem];
      console.log(`waiting on ${nextWaitingItems.length}: ${JSON.stringify(nextWaitingItems)}`);
      return nextWaitingItems;
    });
  }, [setWaiting]);
  const resetReadyItems = useCallback2(() => {
    setWaiting(items);
    console.log(`waiting on ${items.length}: ${JSON.stringify(items)}`);
  }, [setWaiting, items]);
  const isReady = waiting.length === 0;
  return [isReady, setItemIsReady, setItemIsNotReady, resetReadyItems];
}
function useUrls() {
  const [urls, setUrls] = useState([]);
  const addUrl = useCallback2((url, name2) => {
    if (url) {
      setUrls((prev) => [...prev, { url, name: name2 }]);
    }
  }, [setUrls]);
  const resetUrls = useCallback2(() => {
    setUrls([]);
  }, [setUrls]);
  return [urls, addUrl, resetUrls];
}
function useClosestVitessceContainerSize(ref) {
  const [height, setHeight] = useState();
  const [width, setWidth] = useState();
  useEffect(() => {
    function onWindowResize() {
      if (ref.current) {
        const {
          clientHeight: componentHeight,
          clientWidth: componentWidth
        } = ref.current.closest(".vitessce-container");
        setWidth(componentWidth);
        setHeight(componentHeight);
      }
    }
    const onResizeDebounced = debounce(onWindowResize, 100, { trailing: true });
    window.addEventListener("resize", onResizeDebounced);
    onWindowResize();
    return () => {
      window.removeEventListener("resize", onResizeDebounced);
    };
  }, [ref]);
  return [width, height];
}

// src/components/shared-mui/styles.js
import { makeStyles, createTheme } from "@material-ui/core/styles";
import { grey } from "@material-ui/core/colors";
var styles = makeStyles(() => ({
  paper: {
    maxHeight: 200,
    overflow: "auto"
  },
  container: {
    position: "relative",
    left: 0,
    top: 0
  },
  span: {
    width: "70px",
    textAlign: "center",
    paddingLeft: "2px",
    paddingRight: "2px"
  }
}));
var muiTheme = {
  dark: createTheme({
    palette: {
      type: "dark",
      primary: grey,
      secondary: grey,
      primaryBackground: "#222222",
      primaryBackgroundHighlight: "#000000",
      primaryBackgroundInput: "#D3D3D3",
      primaryBackgroundDim: "#333333",
      primaryBackgroundLight: "#757575",
      primaryForeground: "#D3D3D3",
      primaryForegroundDim: "#000000",
      primaryForegroundActive: "#9bb7d6",
      secondaryBackground: "#000000",
      secondaryBackgroundDim: "#444444",
      secondaryForeground: "#D3D3D3"
    },
    props: {
      MuiButtonBase: {
        disableRipple: true
      }
    }
  }),
  light: createTheme({
    palette: {
      type: "light",
      primary: grey,
      secondary: grey,
      primaryBackground: "#F1F1F1",
      primaryBackgroundHighlight: "#FFFFFF",
      primaryBackgroundInput: "#FFFFFF",
      primaryBackgroundDim: "#8A8A8A",
      primaryBackgroundLight: "#e0e0e0",
      primaryForeground: "#333333",
      primaryForegroundDim: "#808080",
      primaryForegroundActive: "#0074D9",
      secondaryBackground: "#F1F1F1",
      secondaryBackgroundDim: "#C0C0C0",
      secondaryForeground: "#222222"
    },
    props: {
      MuiButtonBase: {
        disableRipple: true
      }
    }
  })
};

// src/components/shared-mui/components.js
function PopperMenu(props) {
  const {
    buttonIcon,
    open,
    setOpen,
    children,
    buttonClassName,
    placement = "bottom-end"
  } = props;
  const classes = styles();
  const anchorRef = useRef3();
  const handleClick = () => {
    setOpen((prev) => !prev);
  };
  const handleClose = () => {
    setOpen(false);
  };
  const id = open ? "v-popover-menu" : void 0;
  const getTooltipContainer = useVitessceContainer(anchorRef);
  return /* @__PURE__ */ React2.createElement("div", {
    ref: anchorRef,
    className: classes.container
  }, /* @__PURE__ */ React2.createElement(IconButton, {
    "aria-describedby": id,
    onClick: handleClick,
    size: "small",
    className: buttonClassName
  }, buttonIcon), /* @__PURE__ */ React2.createElement(Popper, {
    id,
    open,
    anchorEl: anchorRef && anchorRef.current,
    container: getTooltipContainer,
    onClose: handleClose,
    placement,
    transition: true
  }, ({ TransitionProps }) => /* @__PURE__ */ React2.createElement(ClickAwayListener, {
    onClickAway: handleClose
  }, /* @__PURE__ */ React2.createElement(Fade, __spreadProps(__spreadValues({}, TransitionProps), {
    timeout: 100
  }), /* @__PURE__ */ React2.createElement(Paper, {
    elevation: 4,
    className: classes.paper
  }, /* @__PURE__ */ React2.createElement(MenuList, null, children))))));
}

// src/components/TitleInfo.js
var useStyles = makeStyles2((theme) => ({
  iconButton: {
    border: "none",
    marginLeft: 0,
    background: "none",
    color: theme.palette.primaryForeground,
    paddingLeft: "0.25em",
    paddingRight: "0.25em",
    borderRadius: "2px",
    "&:hover": {
      backgroundColor: theme.palette.primaryBackgroundLight
    },
    "&:first-child": {
      marginLeft: "0.25em"
    },
    "&:last-child": {
      marginRight: "0.25em"
    },
    "& svg": {
      width: "0.7em",
      height: "0.7em",
      verticalAlign: "middle",
      overflow: "visible"
    }
  },
  downloadLink: {
    color: theme.palette.primaryForeground
  }
}));
function SettingsIconWithArrow({ open }) {
  return /* @__PURE__ */ React3.createElement(React3.Fragment, null, /* @__PURE__ */ React3.createElement(SettingsIcon, null), open ? /* @__PURE__ */ React3.createElement(ArrowDropUpIcon, null) : /* @__PURE__ */ React3.createElement(ArrowDropDownIcon, null));
}
function PlotOptions(props) {
  const { options } = props;
  const [open, setOpen] = useState2(false);
  const classes = useStyles();
  return /* @__PURE__ */ React3.createElement(PopperMenu, {
    open,
    setOpen,
    buttonIcon: /* @__PURE__ */ React3.createElement(SettingsIconWithArrow, {
      open
    }),
    buttonClassName: classes.iconButton,
    placement: "bottom-end"
  }, options);
}
function CloudDownloadIconWithArrow({ open }) {
  return /* @__PURE__ */ React3.createElement(React3.Fragment, null, /* @__PURE__ */ React3.createElement(CloudDownloadIcon, null), open ? /* @__PURE__ */ React3.createElement(ArrowDropUpIcon, null) : /* @__PURE__ */ React3.createElement(ArrowDropDownIcon, null));
}
function DownloadOptions(props) {
  const { urls } = props;
  const [open, setOpen] = useState2(false);
  const classes = useStyles();
  return /* @__PURE__ */ React3.createElement(PopperMenu, {
    open,
    setOpen,
    buttonIcon: /* @__PURE__ */ React3.createElement(CloudDownloadIconWithArrow, {
      open
    }),
    buttonClassName: classes.iconButton,
    placement: "bottom-end"
  }, urls.map(({ url, name: name2 }) => /* @__PURE__ */ React3.createElement(MenuItem, {
    dense: true,
    key: url
  }, /* @__PURE__ */ React3.createElement(Link, {
    underline: "none",
    href: url,
    target: "_blank",
    rel: "noopener",
    className: classes.downloadLink
  }, "Download ", name2))));
}
function ClosePaneButton(props) {
  const { removeGridComponent } = props;
  const classes = useStyles();
  return /* @__PURE__ */ React3.createElement(IconButton2, {
    onClick: removeGridComponent,
    size: "small",
    className: classes.iconButton,
    title: "close"
  }, /* @__PURE__ */ React3.createElement(CloseIcon, null));
}
function TitleInfo(props) {
  const {
    title: title23,
    info,
    children,
    isScroll,
    isSpatial,
    removeGridComponent,
    urls,
    isReady,
    options
  } = props;
  const childClassName = isScroll ? SCROLL_CARD : isSpatial ? BLACK_CARD : SECONDARY_CARD;
  return /* @__PURE__ */ React3.createElement(React3.Fragment, null, /* @__PURE__ */ React3.createElement("div", {
    className: "title"
  }, /* @__PURE__ */ React3.createElement("div", {
    className: "title-left"
  }, title23), /* @__PURE__ */ React3.createElement("div", {
    className: "title-info",
    title: info
  }, info), /* @__PURE__ */ React3.createElement("div", {
    className: "title-buttons"
  }, options && /* @__PURE__ */ React3.createElement(PlotOptions, {
    options
  }), urls && urls.length > 0 && /* @__PURE__ */ React3.createElement(DownloadOptions, {
    urls
  }), /* @__PURE__ */ React3.createElement(ClosePaneButton, {
    removeGridComponent
  }))), /* @__PURE__ */ React3.createElement("div", {
    className: childClassName
  }, !isReady && /* @__PURE__ */ React3.createElement(LoadingIndicator, null), children));
}

// src/demo/view-configs/plugin-view-type.js
function MyPluginView(props) {
  const {
    spatialZoom,
    setSpatialZoom
  } = props;
  function handleClick() {
    setSpatialZoom(-10 + Math.random() * 10);
  }
  return /* @__PURE__ */ React4.createElement("div", null, /* @__PURE__ */ React4.createElement("p", null, "Zoom level: ", /* @__PURE__ */ React4.createElement("b", null, spatialZoom)), /* @__PURE__ */ React4.createElement("p", null, /* @__PURE__ */ React4.createElement("button", {
    onClick: handleClick
  }, "Try a random zoom level")));
}
function MyPluginViewSubscriber(props) {
  const {
    coordinationScopes,
    removeGridComponent,
    theme,
    title: title23 = "My plugin view"
  } = props;
  const [{
    spatialZoom
  }, {
    setSpatialZoom
  }] = useCoordination([
    CoordinationType.DATASET,
    CoordinationType.SPATIAL_ZOOM
  ], coordinationScopes);
  return /* @__PURE__ */ React4.createElement(TitleInfo, {
    title: title23,
    theme,
    removeGridComponent,
    isReady: true
  }, /* @__PURE__ */ React4.createElement(MyPluginView, {
    spatialZoom,
    setSpatialZoom
  }));
}
registerPluginViewType("myCustomZoomController", MyPluginViewSubscriber, [
  CoordinationType.DATASET,
  CoordinationType.SPATIAL_ZOOM
]);
var pluginViewType = {
  name: "Test plugin view types",
  version: "1.0.9",
  description: "Demonstration of a basic plugin view implementation.",
  public: false,
  datasets: [
    {
      uid: "plugin-test-dataset",
      name: "Plugin test dataset",
      files: [
        {
          type: "raster",
          fileType: "raster.json",
          url: "https://s3.amazonaws.com/vitessce-data/0.0.31/master_release/spraggins/spraggins.raster.json"
        }
      ]
    }
  ],
  initStrategy: "auto",
  coordinationSpace: {
    spatialZoom: {
      A: -6.5
    }
  },
  layout: [
    {
      component: "description",
      props: {
        title: "Description"
      },
      x: 10,
      y: 0,
      w: 2,
      h: 2
    },
    {
      component: "spatial",
      coordinationScopes: {
        spatialZoom: "A"
      },
      x: 2,
      y: 0,
      w: 8,
      h: 2
    },
    {
      component: "myCustomZoomController",
      coordinationScopes: {
        spatialZoom: "A"
      },
      x: 0,
      y: 0,
      w: 2,
      h: 2
    }
  ]
};

// src/demo/view-configs/plugin-coordination-type.js
import React5 from "react";
import Slider from "@material-ui/core/Slider";
function MyPluginSlider(props) {
  const {
    myCustomCoordinationType,
    setMyCustomCoordinationType
  } = props;
  function handleChange(event, newValue) {
    setMyCustomCoordinationType(newValue);
  }
  return /* @__PURE__ */ React5.createElement("div", null, /* @__PURE__ */ React5.createElement(Slider, {
    value: myCustomCoordinationType,
    onChange: handleChange,
    min: 0,
    max: 1,
    step: 5e-3
  }));
}
function MyPluginSliderSubscriber(props) {
  const {
    coordinationScopes,
    removeGridComponent,
    theme,
    title: title23 = "My plugin slider"
  } = props;
  const [{
    myCustomCoordinationType
  }, {
    setMyCustomCoordinationType
  }] = useCoordination([
    CoordinationType.DATASET,
    "myCustomCoordinationType"
  ], coordinationScopes);
  return /* @__PURE__ */ React5.createElement(TitleInfo, {
    title: title23,
    theme,
    removeGridComponent,
    isReady: true
  }, /* @__PURE__ */ React5.createElement(MyPluginSlider, {
    myCustomCoordinationType,
    setMyCustomCoordinationType
  }));
}
registerPluginCoordinationType("myCustomCoordinationType", 0.75);
registerPluginViewType("myCustomSlider", MyPluginSliderSubscriber, [
  CoordinationType.DATASET,
  "myCustomCoordinationType"
]);
var pluginCoordinationType = {
  name: "Test plugin views and coordination types",
  version: "1.0.9",
  description: "Demonstration of a plugin coordination type implementation. The left sliders should be coordinated, while the right sliders are independent.",
  public: false,
  datasets: [
    {
      uid: "plugin-test-dataset",
      name: "Plugin test dataset",
      files: []
    }
  ],
  initStrategy: "auto",
  coordinationSpace: {
    myCustomCoordinationType: {
      A: 0.5,
      B: 0.25,
      C: void 0
    }
  },
  layout: [
    {
      component: "description",
      props: {
        title: "Description"
      },
      x: 0,
      y: 0,
      w: 2,
      h: 2
    },
    {
      component: "myCustomSlider",
      coordinationScopes: {
        myCustomCoordinationType: "A"
      },
      x: 2,
      y: 0,
      w: 2,
      h: 1
    },
    {
      component: "myCustomSlider",
      coordinationScopes: {
        myCustomCoordinationType: "A"
      },
      x: 2,
      y: 1,
      w: 2,
      h: 1
    },
    {
      component: "myCustomSlider",
      coordinationScopes: {
        myCustomCoordinationType: "B"
      },
      x: 4,
      y: 0,
      w: 2,
      h: 1
    },
    {
      component: "myCustomSlider",
      x: 4,
      y: 1,
      w: 2,
      h: 1
    }
  ]
};

// src/demo/view-configs/plugin-file-type.js
import range from "lodash/range";

// src/loaders/JsonLoader.js
import Ajv from "ajv";

// src/loaders/AbstractLoader.js
import uuidv4 from "uuid/v4";
var AbstractLoader = class {
  constructor({
    type: type23,
    url,
    requestInit,
    options
  }) {
    this.type = type23;
    this.url = url;
    this.requestInit = requestInit;
    this.options = options;
    this.subscriptions = {};
  }
  load() {
    throw new Error("The load() method has not been implemented.");
  }
  subscribe(subscriber) {
    const token = uuidv4();
    this.subscriptions[token] = subscriber;
    return token;
  }
  unsubscribe(token) {
    delete this.subscriptions[token];
  }
  publish(data) {
    Object.values(this.subscriptions).forEach((subscriber) => {
      subscriber(data);
    });
  }
};

// src/loaders/AbstractTwoStepLoader.js
var AbstractTwoStepLoader = class extends AbstractLoader {
  constructor(dataSource, params) {
    super(params);
    this.dataSource = dataSource;
  }
};

// src/loaders/errors/AbstractLoaderError.js
var AbstractLoaderError = class {
  constructor(message) {
    this.message = message;
  }
  warnInConsole() {
    throw new Error("The warnInConsole() method has not been implemented.");
  }
};

// src/loaders/errors/LoaderValidationError.js
var LoaderValidationError = class extends AbstractLoaderError {
  constructor(datasetType, datasetFileType, datasetUrl, reason) {
    super(`Error while validating ${datasetType}.`);
    this.name = "LoaderValidationError";
    this.datasetType = datasetType;
    this.datasetFileType = datasetFileType;
    this.datasetUrl = datasetUrl;
    this.reason = reason;
  }
  warnInConsole() {
    const {
      datasetType,
      datasetUrl,
      reason
    } = this;
    console.warn(`${datasetType} from ${datasetUrl}: validation failed`, JSON.stringify(reason, null, 2));
  }
};

// src/loaders/errors/LoaderNotFoundError.js
var LoaderNotFoundError = class extends AbstractLoaderError {
  constructor(datasetType, datasetFileType, datasetUrl) {
    super(`Error finding loader for ${datasetType}.`);
    this.name = "LoaderNotFoundError";
    this.datasetType = datasetType;
    this.datasetFileType = datasetFileType;
    this.datasetUrl = datasetUrl;
  }
  warnInConsole() {
    const {
      datasetType,
      datasetFileType,
      datasetUrl
    } = this;
    if (datasetFileType && datasetUrl) {
      console.warn(`${datasetType} from ${datasetUrl}: unable to find loader for fileType ${datasetFileType}`);
    } else {
      console.warn(`${datasetType}: unable to find loader`);
    }
  }
};

// src/loaders/errors/DatasetNotFoundError.js
var DatasetNotFoundError = class extends AbstractLoaderError {
  constructor(datasetUid) {
    super(`Error finding dataset for ${datasetUid}. Please check that at least one dataset exists in the view config.`);
    this.name = "DatasetNotFoundError";
    this.datasetUid = datasetUid;
  }
  warnInConsole() {
    const {
      datasetUid
    } = this;
    if (datasetUid) {
      console.warn(`Unable to find dataset for ${datasetUid}`);
    } else {
      console.warn("No dataset uid specified.");
    }
  }
};

// src/loaders/LoaderResult.js
var LoaderResult = class {
  constructor(data, url, coordinationValues = null) {
    this.data = data;
    this.url = url;
    this.coordinationValues = coordinationValues;
  }
};

// src/schemas/cells.schema.json
var $schema = "http://json-schema.org/draft-07/schema#";
var $id = "https://github.com/vitessce/vitessce/#cells";
var title = "Vitessce cell data";
var type = "object";
var definitions = {
  coord: {
    type: "array",
    minItems: 2,
    maxItems: 2,
    items: { type: "number" }
  },
  positiveFloatValues: {
    type: "object",
    patternProperties: {
      ".": {
        type: "number",
        minimum: 0
      }
    }
  },
  stringValues: {
    type: "object",
    patternProperties: {
      ".": {
        type: "string"
      }
    }
  }
};
var patternProperties = {
  ".": {
    additionalProperties: false,
    required: [],
    properties: {
      mappings: {
        type: "object",
        patternProperties: {
          ".": { $ref: "#/definitions/coord" }
        }
      },
      xy: { $ref: "#/definitions/coord" },
      genes: { $ref: "#/definitions/positiveFloatValues" },
      factors: { $ref: "#/definitions/stringValues" },
      poly: {
        type: "array",
        items: { $ref: "#/definitions/coord" }
      }
    }
  }
};
var cells_schema_default = {
  $schema,
  $id,
  title,
  type,
  definitions,
  patternProperties
};

// src/schemas/molecules.schema.json
var $schema2 = "http://json-schema.org/draft-07/schema#";
var $id2 = "https://github.com/vitessce/vitessce/#molecules";
var title2 = "Vitessce molecule data";
var type2 = "object";
var definitions2 = {
  coord: {
    type: "array",
    maxItems: 2,
    minItems: 2,
    items: { type: "number" }
  }
};
var patternProperties2 = {
  ".": {
    type: "array",
    items: { $ref: "#/definitions/coord" }
  }
};
var molecules_schema_default = {
  $schema: $schema2,
  $id: $id2,
  title: title2,
  type: type2,
  definitions: definitions2,
  patternProperties: patternProperties2
};

// src/schemas/neighborhoods.schema.json
var $schema3 = "http://json-schema.org/draft-07/schema#";
var $id3 = "https://github.com/vitessce/vitessce/#neighborhoods";
var title3 = "Vitessce neighborhood data";
var type3 = "object";
var definitions3 = {
  coord: {
    type: "array",
    maxItems: 2,
    minItems: 2,
    items: { type: "number" }
  }
};
var patternProperties3 = {
  ".": {
    additionalProperties: false,
    required: ["poly"],
    properties: {
      poly: {
        type: "array",
        maxItems: 3,
        minItems: 3,
        items: { $ref: "#/definitions/coord" }
      }
    }
  }
};
var neighborhoods_schema_default = {
  $schema: $schema3,
  $id: $id3,
  title: title3,
  type: type3,
  definitions: definitions3,
  patternProperties: patternProperties3
};

// src/schemas/raster.schema.json
var $schema4 = "http://json-schema.org/draft-07/schema#";
var $id4 = "https://github.com/vitessce/vitessce/#raster";
var title4 = "Vitessce image data";
var type4 = "object";
var definitions4 = {
  transform: {
    type: "object",
    additionalProperties: false,
    oneOf: [{ required: ["scale", "translate"] }, { required: ["matrix"] }],
    properties: {
      scale: { type: "number" },
      translate: {
        type: "object",
        additionalProperties: false,
        required: ["y", "x"],
        properties: {
          y: { type: "number" },
          x: { type: "number" }
        }
      },
      matrix: {
        type: "array",
        items: { type: "number" },
        minItems: 16,
        maxItems: 16
      }
    }
  },
  dimensions: {
    type: "array",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["field", "type", "values"],
      properties: {
        field: { type: "string" },
        type: {
          type: "string",
          enum: ["quantitative", "nominal", "ordinal", "temporal"]
        },
        values: {
          type: ["array", "null"],
          items: { type: "string" }
        }
      }
    }
  },
  metadata: {
    type: "object",
    additionalProperties: false,
    anyOf: [{ required: ["dimensions", "isPyramid"] }, { required: ["transform"] }, { required: ["omeTiffOffsetsUrl"] }, { required: ["isBitmask"] }],
    properties: {
      dimensions: { $ref: "#/definitions/dimensions" },
      isPyramid: { type: "boolean" },
      transform: { $ref: "#/definitions/transform" },
      isBitmask: { type: "boolean" },
      omeTiffOffsetsUrl: { type: "string", format: "uri" }
    }
  },
  requestInit: {
    type: "object",
    additionalProperties: false,
    required: [],
    properties: {
      method: {
        type: "string"
      },
      headers: {
        type: "object"
      },
      body: {
        type: "string"
      },
      mode: {
        type: "string"
      },
      credentials: {
        type: "string"
      },
      cache: {
        type: "string"
      },
      redirect: {
        type: "string"
      },
      referrer: {
        type: "string"
      },
      integrity: {
        type: "string"
      }
    }
  },
  image: {
    type: "object",
    additionalProperties: false,
    required: ["name", "url", "type"],
    properties: {
      name: { type: "string" },
      url: { type: "string", format: "uri" },
      type: { type: "string" },
      metadata: { $ref: "#/definitions/metadata" },
      requestInit: { $ref: "#/definitions/requestInit" }
    }
  }
};
var additionalProperties = false;
var required = ["schemaVersion", "images"];
var properties = {
  schemaVersion: { type: "string" },
  usePhysicalSizeScaling: { type: "boolean", description: "Default is false: passing true in will infer scaling from the reported physcial size" },
  renderLayers: { type: "array", items: { type: "string" } },
  images: {
    type: "array",
    items: { $ref: "#/definitions/image" }
  }
};
var raster_schema_default = {
  $schema: $schema4,
  $id: $id4,
  title: title4,
  type: type4,
  definitions: definitions4,
  additionalProperties,
  required,
  properties
};

// src/schemas/cell-sets.schema.json
var $schema5 = "http://json-schema.org/draft-07/schema#";
var $id5 = "https://github.com/vitessce/vitessce/#cell-sets";
var title5 = "Vitessce cell sets data";
var type5 = "object";
var definitions5 = {
  stringArray: {
    type: "array",
    items: {
      type: "string"
    }
  },
  stringProbabilityTupleArray: {
    type: "array",
    items: {
      type: "array",
      additionalItems: false,
      items: [
        {
          type: "string"
        },
        {
          oneOf: [
            {
              type: "number",
              minimum: 0,
              maximum: 1
            },
            {
              type: "null"
            }
          ]
        }
      ]
    }
  },
  colorArray: {
    type: "array",
    items: {
      type: "integer",
      minimum: 0,
      maximum: 255
    },
    minItems: 3,
    maxItems: 3
  },
  treeNodeLeaf: {
    type: "object",
    additionalProperties: false,
    required: ["name"],
    properties: {
      name: {
        type: "string"
      },
      color: {
        $ref: "#/definitions/colorArray"
      },
      set: {
        $ref: "#/definitions/stringArray"
      }
    }
  },
  treeNodeNonLeaf: {
    type: "object",
    additionalProperties: false,
    required: ["name"],
    properties: {
      name: {
        type: "string"
      },
      color: {
        $ref: "#/definitions/colorArray"
      },
      children: {
        type: "array",
        items: {
          $ref: "#/definitions/treeNode"
        }
      }
    }
  },
  treeNode: {
    oneOf: [
      {
        $ref: "#/definitions/treeNodeNonLeaf"
      },
      {
        $ref: "#/definitions/treeNodeLeaf"
      }
    ]
  },
  "version0.1.2": {
    type: "object",
    additionalProperties: false,
    required: ["version", "datatype", "tree"],
    properties: {
      dataset: {
        type: "string"
      },
      version: {
        type: "string",
        enum: ["0.1.2"]
      },
      datatype: {
        type: "string",
        enum: ["cell"]
      },
      tree: {
        type: "array",
        items: {
          $ref: "#/definitions/treeNodeNonLeaf"
        }
      }
    }
  },
  treeNodeLeafProbabilistic: {
    type: "object",
    additionalProperties: false,
    required: ["name"],
    properties: {
      name: {
        type: "string"
      },
      color: {
        $ref: "#/definitions/colorArray"
      },
      set: {
        $ref: "#/definitions/stringProbabilityTupleArray"
      }
    }
  },
  treeNodeNonLeafProbabilistic: {
    type: "object",
    additionalProperties: false,
    required: ["name"],
    properties: {
      name: {
        type: "string"
      },
      color: {
        $ref: "#/definitions/colorArray"
      },
      children: {
        type: "array",
        items: {
          $ref: "#/definitions/treeNodeProbabilistic"
        }
      }
    }
  },
  treeNodeProbabilistic: {
    oneOf: [
      {
        $ref: "#/definitions/treeNodeNonLeafProbabilistic"
      },
      {
        $ref: "#/definitions/treeNodeLeafProbabilistic"
      }
    ]
  },
  "version0.1.3": {
    type: "object",
    additionalProperties: false,
    required: ["version", "datatype", "tree"],
    properties: {
      dataset: {
        type: "string"
      },
      version: {
        type: "string",
        enum: ["0.1.3"]
      },
      datatype: {
        type: "string",
        enum: ["cell"]
      },
      tree: {
        type: "array",
        items: {
          $ref: "#/definitions/treeNodeNonLeafProbabilistic"
        }
      }
    }
  }
};
var oneOf = [
  {
    $ref: "#/definitions/version0.1.2"
  },
  {
    $ref: "#/definitions/version0.1.3"
  }
];
var cell_sets_schema_default = {
  $schema: $schema5,
  $id: $id5,
  title: title5,
  type: type5,
  definitions: definitions5,
  oneOf
};

// src/loaders/JsonLoader.js
var fileTypeToSchema = {
  [FileType.CELLS_JSON]: cells_schema_default,
  [FileType.MOLECULES_JSON]: molecules_schema_default,
  [FileType.NEIGHBORHOODS_JSON]: neighborhoods_schema_default,
  [FileType.RASTER_JSON]: raster_schema_default,
  [FileType.CELL_SETS_JSON]: cell_sets_schema_default
};
var JsonLoader = class extends AbstractTwoStepLoader {
  constructor(dataSource, params) {
    super(dataSource, params);
    const { fileType } = params;
    this.schema = fileTypeToSchema[fileType];
  }
  load() {
    const {
      url,
      type: type23,
      fileType
    } = this;
    if (this.data) {
      return this.data;
    }
    this.data = this.dataSource.data.then((data) => {
      if (data instanceof AbstractLoaderError) {
        return Promise.reject(data);
      }
      const [valid, reason] = this.validate(data);
      if (valid) {
        return Promise.resolve(new LoaderResult(data, url));
      }
      return Promise.reject(new LoaderValidationError(type23, fileType, url, reason));
    });
    return this.data;
  }
  validate(data) {
    const { schema, fileType } = this;
    if (!schema) {
      throw Error(`No schema for ${fileType}`);
    }
    const validate = new Ajv().compile(schema);
    const valid = validate(data);
    let failureReason;
    if (!valid) {
      failureReason = validate.errors;
    }
    return [valid, failureReason];
  }
};

// src/loaders/errors/DataSourceFetchError.js
var DataSourceFetchError = class extends AbstractLoaderError {
  constructor(source, url, headers) {
    super(`${source} Error HTTP Status fetching from ${url}`);
    this.source = source;
    this.url = url;
    this.headers = headers;
  }
  warnInConsole() {
    const { source, url, headers } = this;
    console.warn(`${source} failed to fetch from ${url} with headers ${headers}`);
  }
};

// src/loaders/data-sources/JsonSource.js
var JsonSource = class {
  constructor({ url, requestInit }) {
    this.url = url;
    this.requestInit = requestInit;
  }
  get data() {
    if (this._data)
      return this._data;
    this._data = fetch(this.url, this.requestInit).then((response) => {
      if (!response.ok) {
        return Promise.reject(new DataSourceFetchError("JsonSource", this.url, response.headers));
      }
      return response.json();
    }).catch(() => Promise.reject(new DataSourceFetchError("JsonSource", this.url, {})));
    return this._data;
  }
};

// src/demo/view-configs/plugin-file-type.js
var numCells = 60;
var numGenes = 90;
var InMemoryCellsLoader = class extends JsonLoader {
  load() {
    return __async(this, null, function* () {
      const data = fromEntries(range(numCells).map((i) => [`cell_${i}`, {
        mappings: {
          random: [
            Math.random(),
            Math.random()
          ]
        },
        genes: {},
        xy: [
          Math.random(),
          Math.random()
        ]
      }]));
      return Promise.resolve(new LoaderResult(data, null));
    });
  }
};
var InMemoryMatrixLoader = class extends JsonLoader {
  load() {
    return __async(this, null, function* () {
      const data = {
        rows: range(numGenes).map((j) => `gene_${j}`),
        cols: range(numCells).map((j) => `cell_${j}`),
        matrix: range(numGenes).map((i) => range(numCells).map((j) => i + j + 1))
      };
      const { rows, cols, matrix } = data;
      const attrs = {
        rows: cols,
        cols: rows
      };
      const shape = [attrs.rows.length, attrs.cols.length];
      const normalizedMatrix = matrix.map((col) => {
        const [min, max] = [0, 1];
        const normalize = (d) => Math.floor((d - min) / (max - min) * 255);
        return col.map(normalize);
      });
      const tNormalizedMatrix = range(shape[0]).map((i) => range(shape[1]).map((j) => normalizedMatrix[j][i]));
      const normalizedFlatMatrix = tNormalizedMatrix.flat();
      const arr = { data: Uint8Array.from(normalizedFlatMatrix) };
      return Promise.resolve(new LoaderResult([attrs, arr], null));
    });
  }
};
registerPluginFileType("in-memory-cells", "cells", InMemoryCellsLoader, JsonSource);
registerPluginFileType("in-memory-matrix", "expression-matrix", InMemoryMatrixLoader, JsonSource);
var pluginFileType = {
  name: "Test plugin file types",
  version: "1.0.9",
  description: "Demonstration of a basic plugin file type implementation.",
  public: false,
  datasets: [
    {
      uid: "plugin-test-dataset",
      name: "Plugin test dataset",
      files: [
        {
          type: "expression-matrix",
          fileType: "in-memory-matrix",
          url: ""
        },
        {
          type: "cells",
          fileType: "in-memory-cells",
          url: ""
        }
      ]
    }
  ],
  initStrategy: "auto",
  coordinationSpace: {
    spatialZoom: {
      A: -6.5
    }
  },
  layout: [
    {
      component: "description",
      props: {
        title: "Description"
      },
      x: 0,
      y: 0,
      w: 2,
      h: 2
    },
    {
      component: "heatmap",
      x: 2,
      y: 0,
      w: 10,
      h: 2
    }
  ]
};

// src/app/api.js
var configsWithPlugins = __spreadProps(__spreadValues({}, configs), {
  "plugin-view-type": pluginViewType,
  "plugin-coordination-type": pluginCoordinationType,
  "plugin-file-type": pluginFileType
});

// src/app/Welcome.js
import React6 from "react";

// src/app/Warning.js
import React7 from "react";
function Warning(props) {
  const {
    title: title23,
    preformatted,
    unformatted,
    theme
  } = props;
  return /* @__PURE__ */ React7.createElement("div", {
    className: `vitessce-container vitessce-theme-${theme}`
  }, /* @__PURE__ */ React7.createElement("div", {
    className: "warning-layout container-fluid"
  }, /* @__PURE__ */ React7.createElement("div", {
    className: "row"
  }, /* @__PURE__ */ React7.createElement("div", {
    className: "col-12"
  }, /* @__PURE__ */ React7.createElement("div", {
    className: PRIMARY_CARD
  }, /* @__PURE__ */ React7.createElement("h1", null, title23), /* @__PURE__ */ React7.createElement("pre", null, preformatted), /* @__PURE__ */ React7.createElement("div", null, unformatted))))));
}

// src/app/Vitessce.js
import React14, { useEffect as useEffect7, useMemo as useMemo4 } from "react";
import {
  ThemeProvider,
  StylesProvider,
  createGenerateClassName
} from "@material-ui/core/styles";
import isEqual2 from "lodash/isEqual";

// src/app/VitessceGrid.js
import React9, {
  useEffect as useEffect3,
  useCallback as useCallback3
} from "react";

// src/app/vitessce-grid-layout/VitessceGridLayout.js
import React8 from "react";
import { Responsive, WidthProvider } from "react-grid-layout";
import isEqual from "lodash/isEqual";

// src/app/vitessce-grid-layout/layout-utils.js
import range2 from "lodash/range";
var COMPONENT_ID_PREFIX = "i";
function sum(a) {
  return a.reduce((x, y) => x + y, 0);
}
function makeGridLayout(colXs, colLayout) {
  const colWs = [];
  for (let i = 0; i < colXs.length; i++) {
    colWs.push(colXs[i + 1] - colXs[i]);
  }
  return Object.entries(colLayout).map(([id, spec]) => ({
    i: id,
    y: spec.y,
    h: spec.h || 1,
    x: colXs[spec.x],
    w: sum(colWs.slice(spec.x, spec.x + (spec.w || 1)))
  }));
}
function getMaxRows(layouts) {
  return Math.max(...Object.values(layouts).map((layout) => Math.max(...layout.map((xywh) => xywh.y + xywh.h))));
}
function resolveLayout(layout) {
  const cols = {};
  const layouts = {};
  const breakpoints = {};
  const components = {};
  const positions = {};
  ("components" in layout ? layout.components : layout).forEach((def) => {
    const id = def.uid;
    components[id] = {
      uid: def.uid,
      component: def.component,
      props: def.props || {},
      coordinationScopes: def.coordinationScopes || {},
      coordinationScopesBy: def.coordinationScopesBy || {}
    };
    positions[id] = {
      id,
      x: def.x,
      y: def.y,
      w: def.w,
      h: def.h
    };
  });
  if ("components" in layout) {
    Object.entries(layout.columns).forEach(([width, columnXs]) => {
      cols[width] = columnXs[columnXs.length - 1];
      layouts[width] = makeGridLayout(columnXs, positions);
      breakpoints[width] = width;
    });
  } else {
    const id = "ID";
    const columnCount = 12;
    cols[id] = columnCount;
    layouts[id] = makeGridLayout(range2(columnCount + 1), positions);
    breakpoints[id] = 1e3;
  }
  return {
    cols,
    layouts,
    breakpoints,
    components
  };
}

// src/app/vitessce-grid-layout/VitessceGridLayout.js
var ResponsiveGridLayout = WidthProvider(Responsive);
var ResponsiveHeightGridLayout = class extends ResponsiveGridLayout {
  componentDidUpdate(prevProps) {
    if (this.props.height !== prevProps.height) {
      this.onWindowResize();
    }
  }
};
function VitessceGridLayout(props) {
  const {
    layout,
    getComponent: getComponent2,
    padding: padding2,
    margin: margin2,
    draggableHandle,
    reactGridLayoutProps,
    rowHeight,
    theme,
    height,
    onRemoveComponent,
    onLayoutChange: onLayoutChangeProp
  } = props;
  const {
    cols: gridCols,
    layouts: gridLayouts,
    breakpoints: gridBreakpoints,
    components: gridComponents
  } = resolveLayout(layout);
  const maxRows = getMaxRows(gridLayouts);
  const style = /* @__PURE__ */ React8.createElement("style", null, `
        ${draggableHandle} {
          cursor: grab;
        }
        ${draggableHandle}:active {
          cursor: grabbing;
        }
     `);
  const onLayoutChange = (newLayout) => {
    if (newLayout.length === Object.entries(gridComponents).length) {
      const newComponentProps = [];
      newLayout.forEach((nextC) => {
        const id = nextC.i;
        const prevC = gridComponents[id];
        if (prevC) {
          const i = parseInt(id.substring(id.indexOf(COMPONENT_ID_PREFIX) + 1), 10);
          const nextProps = {
            x: nextC.x,
            y: nextC.y,
            w: nextC.w,
            h: nextC.h
          };
          const prevProps = {
            x: prevC.x,
            y: prevC.y,
            w: prevC.w,
            h: prevC.h
          };
          if (!isEqual(nextProps, prevProps)) {
            newComponentProps.push([i, nextProps]);
          }
        }
      });
      if (newComponentProps.length > 0) {
        onLayoutChangeProp(newComponentProps);
      }
    }
  };
  const layoutChildren = Object.values(gridComponents).map((v) => {
    const Component4 = getComponent2(v.component);
    const removeGridComponent = () => {
      onRemoveComponent(v.uid);
    };
    return /* @__PURE__ */ React8.createElement("div", {
      key: v.uid
    }, /* @__PURE__ */ React8.createElement(Component4, __spreadProps(__spreadValues({}, v.props), {
      uuid: v.uid,
      coordinationScopes: v.coordinationScopes,
      coordinationScopesBy: v.coordinationScopesBy,
      theme,
      removeGridComponent
    })));
  });
  return gridLayouts && gridComponents && gridBreakpoints && gridCols && /* @__PURE__ */ React8.createElement(React8.Fragment, null, style, /* @__PURE__ */ React8.createElement(ResponsiveHeightGridLayout, __spreadValues({
    className: "layout",
    cols: gridCols,
    layouts: gridLayouts,
    breakpoints: gridBreakpoints,
    height,
    rowHeight: rowHeight || (window.innerHeight - 2 * padding2 - (maxRows - 1) * margin2) / maxRows,
    containerPadding: [padding2, padding2],
    margin: [margin2, margin2],
    draggableHandle,
    onLayoutChange
  }, reactGridLayoutProps), layoutChildren));
}
VitessceGridLayout.defaultProps = {
  padding: 10,
  margin: 10
};

// src/app/vitessce-grid-utils.js
import {
  useState as useState3,
  useEffect as useEffect2,
  useRef as useRef4
} from "react";
import { InternMap } from "internmap";

// src/loaders/types.js
var fileTypeToLoaderAndSource = {};
function getSourceAndLoaderFromFileType(type23) {
  if (fileTypeToLoaderAndSource[type23]) {
    return fileTypeToLoaderAndSource[type23];
  }
  const pluginFileType2 = getLoaderClassesForPluginFileType(type23);
  if (pluginFileType2) {
    return pluginFileType2;
  }
  return [JsonSource, JsonLoader];
}

// src/app/vitessce-grid-utils.js
function getNumRows(layout) {
  let max = 0;
  let bottomY;
  for (let i = 0, len = layout.length; i < len; i++) {
    bottomY = layout[i].y + layout[i].h;
    if (bottomY > max)
      max = bottomY;
  }
  return max;
}
function getRowHeight(containerHeight, numRows, margin2, padding2) {
  const effectiveContainerHeight = containerHeight - 2 * padding2 - (numRows - 1) * margin2;
  return effectiveContainerHeight / numRows;
}
function useRowHeight(config, initialRowHeight, height, margin2, padding2) {
  const [containerHeight, setContainerHeight] = useState3(height);
  const [rowHeight, setRowHeight] = useState3(initialRowHeight);
  const containerRef = useRef4();
  useEffect2(() => {
    const numRows = getNumRows(config.layout);
    const newRowHeight = getRowHeight(containerHeight, numRows, margin2, padding2);
    setRowHeight(newRowHeight);
  }, [containerHeight, config, margin2, padding2]);
  useEffect2(() => {
    if (height !== null && height !== void 0) {
      setContainerHeight(height);
    }
  }, [height]);
  useEffect2(() => {
    if (height !== null && height !== void 0) {
      return () => {
      };
    }
    function onWindowResize() {
      if (!containerRef.current)
        return;
      const containerRect = containerRef.current.getBoundingClientRect();
      setContainerHeight(containerRect.height);
    }
    window.addEventListener("resize", onWindowResize);
    onWindowResize();
    return () => {
      window.removeEventListener("resize", onWindowResize);
    };
  }, [containerRef, height]);
  return [rowHeight, containerRef];
}
function createLoaders(datasets, configDescription) {
  const result = {};
  const dataSources = {};
  const fileTypeDataTypeMapping = getFileTypeDataTypeMapping();
  datasets.forEach((dataset) => {
    const datasetLoaders = {
      name: dataset.name,
      description: dataset.description || configDescription,
      loaders: {}
    };
    dataset.files.forEach((file) => {
      const {
        url,
        options,
        requestInit,
        fileType,
        coordinationValues = {}
      } = file;
      const dataType = fileTypeDataTypeMapping[fileType];
      const [DataSourceClass, LoaderClass] = getSourceAndLoaderFromFileType(fileType);
      const fileId = url || JSON.stringify(options);
      if (!(fileId in dataSources)) {
        dataSources[fileId] = new DataSourceClass({ url, requestInit });
      }
      const loader = new LoaderClass(dataSources[fileId], file);
      if (datasetLoaders.loaders[dataType]) {
        datasetLoaders.loaders[dataType].set(coordinationValues, loader);
      } else {
        datasetLoaders.loaders[dataType] = new InternMap([
          [coordinationValues, loader]
        ], JSON.stringify);
      }
    });
    result[dataset.uid] = datasetLoaders;
  });
  return result;
}

// src/app/VitessceGrid.js
var padding = 10;
var margin = 5;
function VitessceGrid(props) {
  const {
    rowHeight: initialRowHeight,
    config,
    getComponent: getComponent2,
    theme,
    height
  } = props;
  const [rowHeight, containerRef] = useRowHeight(config, initialRowHeight, height, margin, padding);
  const onResize = useEmitGridResize();
  const [componentWidth] = useClosestVitessceContainerSize(containerRef);
  useEffect3(() => {
    onResize();
  }, [rowHeight, onResize]);
  const viewConfigStoreApi = useViewConfigStoreApi();
  const setViewConfig = useSetViewConfig(viewConfigStoreApi);
  const setLoaders = useSetLoaders();
  const removeComponent = useRemoveComponent();
  const changeLayout = useChangeLayout();
  const layout = useLayout();
  const changeLayoutPostMount = useCallback3(() => componentWidth > 0 ? changeLayout : () => {
  }, [changeLayout, componentWidth]);
  useEffect3(() => {
    if (config) {
      setViewConfig(config);
      const loaders = createLoaders(config.datasets, config.description);
      setLoaders(loaders);
    } else {
      setLoaders({});
    }
  }, [config, setViewConfig, setLoaders]);
  return /* @__PURE__ */ React9.createElement("div", {
    ref: containerRef,
    className: `vitessce-container vitessce-theme-${theme}`
  }, layout && /* @__PURE__ */ React9.createElement(VitessceGridLayout, {
    layout,
    height,
    rowHeight,
    theme,
    getComponent: getComponent2,
    draggableHandle: ".title",
    margin,
    padding,
    onRemoveComponent: removeComponent,
    onLayoutChange: changeLayoutPostMount,
    reactGridLayoutProps: {
      onResize,
      onResizeStop: onResize
    }
  }));
}

// src/app/CallbackPublisher.js
import { useEffect as useEffect4 } from "react";

// src/app/view-config-versions.js
import Ajv2 from "ajv";

// src/schemas/config-0.1.0.schema.json
var $schema6 = "http://json-schema.org/draft-07/schema#";
var $id6 = "https://github.com/vitessce/vitessce/#dataset";
var title6 = "Vitessce data set";
var type6 = "object";
var definitions6 = {
  components: {
    type: "array",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["component", "x", "y"],
      properties: {
        component: { type: "string" },
        props: { type: "object" },
        x: { type: "integer" },
        y: { type: "integer" },
        w: { type: "integer" },
        h: { type: "integer" }
      }
    }
  },
  requestInit: {
    type: "object",
    additionalProperties: false,
    required: [],
    properties: {
      method: {
        type: "string"
      },
      headers: {
        type: "object"
      },
      body: {
        type: "string"
      },
      mode: {
        type: "string"
      },
      credentials: {
        type: "string"
      },
      cache: {
        type: "string"
      },
      redirect: {
        type: "string"
      },
      referrer: {
        type: "string"
      },
      integrity: {
        type: "string"
      }
    }
  }
};
var additionalProperties2 = false;
var required2 = ["version", "name", "layers"];
var properties2 = {
  name: { type: "string" },
  public: { type: "boolean" },
  description: { type: "string" },
  layers: {
    type: "array",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["name", "type", "fileType", "url"],
      properties: {
        name: { type: "string" },
        type: { type: "string" },
        fileType: { type: "string" },
        url: { type: "string" },
        requestInit: { $ref: "#/definitions/requestInit" }
      }
    }
  },
  staticLayout: { $ref: "#/definitions/components" },
  version: {
    type: "string",
    enum: ["0.1.0"]
  }
};
var config_0_1_0_schema_default = {
  $schema: $schema6,
  $id: $id6,
  title: title6,
  type: type6,
  definitions: definitions6,
  additionalProperties: additionalProperties2,
  required: required2,
  properties: properties2
};

// src/schemas/config-1.0.0.schema.json
var $schema7 = "http://json-schema.org/draft-07/schema#";
var $id7 = "https://github.com/vitessce/vitessce/#dataset";
var title7 = "Vitessce data set";
var type7 = "object";
var definitions7 = {
  components: {
    description: "The layout array defines the views, or components, rendered in the grid.",
    type: "array",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["component", "x", "y"],
      properties: {
        component: {
          type: "string",
          description: "Specify a component using a name defined in the component registry."
        },
        props: {
          type: "object",
          description: "Extra prop values for the component."
        },
        x: { type: "integer" },
        y: { type: "integer" },
        w: { type: "integer" },
        h: { type: "integer" },
        coordinationScopes: {
          type: "object",
          description: "Component-level coordination scope mappings define which coordination object values a particular component can read and write, for each coordination type.",
          additionalProperties: false,
          required: [],
          properties: {
            dataset: { type: "string" },
            embeddingType: { type: "string" },
            embeddingZoom: { type: "string" },
            embeddingRotation: { type: "string" },
            embeddingTargetX: { type: "string" },
            embeddingTargetY: { type: "string" },
            embeddingTargetZ: { type: "string" },
            embeddingCellSetPolygonsVisible: { type: "string" },
            embeddingCellSetLabelsVisible: { type: "string" },
            embeddingCellSetLabelSize: { type: "string" },
            embeddingCellRadius: { type: "string" },
            spatialZoom: { type: "string" },
            spatialRotation: { type: "string" },
            spatialTargetX: { type: "string" },
            spatialTargetY: { type: "string" },
            spatialTargetZ: { type: "string" },
            heatmapZoomX: { type: "string" },
            heatmapZoomY: { type: "string" },
            heatmapTargetX: { type: "string" },
            heatmapTargetY: { type: "string" },
            cellFilter: { type: "string" },
            cellHighlight: { type: "string" },
            cellSetSelection: { type: "string" },
            cellSetHighlight: { type: "string" },
            cellSetColor: { type: "string" },
            geneFilter: { type: "string" },
            geneHighlight: { type: "string" },
            geneSelection: { type: "string" },
            geneExpressionTransform: { type: "string" },
            geneExpressionColormap: { type: "string" },
            geneExpressionColormapRange: { type: "string" },
            cellColorEncoding: { type: "string" },
            spatialLayers: { type: "string" },
            genomicZoomX: { type: "string" },
            genomicZoomY: { type: "string" },
            genomicTargetX: { type: "string" },
            genomicTargetY: { type: "string" },
            additionalCellSets: { type: "string" },
            moleculeHighlight: { type: "string" }
          }
        }
      }
    }
  },
  annDataCellSets: {
    type: "array",
    description: "Array of cell set configuration, following closely the conventions of the tabular schema",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["groupName", "setName"],
      properties: {
        groupName: {
          type: "string",
          description: "The display name for the set, like 'Cell Type' or 'Louvain.'"
        },
        setName: {
          type: "string",
          description: "The location in the AnnData store for the set, like 'obs/louvain' or 'obs/celltype.'"
        }
      }
    }
  },
  annDataCells: {
    type: "object",
    description: "The properties of this object are the configuration for how to layout scatterplots and spatial information",
    minProperties: 1,
    additionalProperties: false,
    required: [],
    properties: {
      xy: {
        type: "string",
        description: "The location in the AnnData store of cell centroids, like 'obsm/X_centroids.'"
      },
      poly: {
        type: "string",
        description: "The location in the AnnData store of cell polygon outlines, like 'obsm/X_polygons.'"
      },
      factors: {
        type: "array",
        description: "List of locations in the AnnData store of cell sets, like 'obs/louvain'",
        items: {
          type: "string"
        }
      },
      mappings: {
        patternProperties: {
          ".": {
            type: "object",
            description: "An object containing key-values for mappings like { UMAP: { key: 'obsm/X_umap', dims: [0, 1] } }.",
            additionalProperties: false,
            required: ["key"],
            properties: {
              key: {
                type: "string",
                description: "Where to look in the AnnData store for this mapping, like 'obsm/X_umap.'"
              },
              dims: {
                type: "array",
                description: "Which indices of the obsm object to take for a scatterplot, allowing for, for example, different PCs from obsm/X_pca",
                minItems: 2,
                maxItems: 2,
                items: { type: "number" }
              }
            }
          }
        }
      }
    }
  },
  annDataExpressionMatrix: {
    type: "object",
    description: "The properties of this object are the configuration for how to fetch the cell x genes matrix",
    additionalProperties: false,
    required: ["matrix"],
    properties: {
      matrix: {
        type: "string",
        description: "The location in the AnnData store of the cell x gene matrix, like 'obsm/hvg_subset.' or 'X'"
      },
      geneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the genes if using a subset of the data, like 'var.highly_variable.' if the matrix comes from 'obsm/hvg_subset.'"
      },
      matrixGeneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the matrix data (used in heatmap and histogram), like 'var.highly_variable.''"
      }
    }
  },
  requestInit: {
    type: "object",
    description: "The properties of this object correspond to the parameters of the JavaScript fetch() function.",
    additionalProperties: false,
    required: [],
    properties: {
      method: {
        type: "string"
      },
      headers: {
        type: "object"
      },
      body: {
        type: "string"
      },
      mode: {
        type: "string"
      },
      credentials: {
        type: "string"
      },
      cache: {
        type: "string"
      },
      redirect: {
        type: "string"
      },
      referrer: {
        type: "string"
      },
      integrity: {
        type: "string"
      }
    }
  },
  rasterLayer: {
    description: "The properties of this object are the rendering settings for the raster layer.",
    additionalProperties: false,
    required: ["channels", "colormap", "index", "opacity", "type"],
    properties: {
      channels: {
        type: "array",
        items: {
          type: "object",
          additionalProperties: false,
          required: ["selection"],
          properties: {
            color: {
              type: "array",
              items: { type: "number" },
              description: "The color to use when rendering this channel under the null colormap."
            },
            selection: {
              type: "object",
              description: "Determines the channel selection, e.g. some Z and time slice."
            },
            slider: {
              type: "array",
              items: { type: "number" },
              description: "Determines the range for color mapping."
            },
            visible: {
              type: "boolean",
              description: "Determines whether this channel of the layer will be rendered in the spatial component."
            }
          }
        }
      },
      colormap: {
        oneOf: [
          {
            type: "string",
            description: "The name of the colormap to use for this layer."
          },
          {
            type: "null",
            description: "Use the solid color definitions."
          }
        ]
      },
      transparentColor: {
        oneOf: [
          {
            type: "array",
            minItems: 3,
            maxItems: 3,
            items: {
              type: "number",
              description: "One of R G or B (0 - 255)."
            },
            description: "Determines the color to be set to opacity 0"
          },
          {
            type: "null",
            description: "No selection."
          }
        ]
      },
      index: {
        type: "number",
        description: "The index of the layer among the array of layers available in the image file."
      },
      modelMatrix: {
        oneOf: [
          {
            type: "array",
            minItems: 16,
            maxItems: 16,
            description: "transformation matrix for this layer"
          },
          {
            type: "null",
            description: "Use no transformation."
          }
        ]
      },
      opacity: {
        type: "number"
      },
      domainType: {
        type: "string",
        enum: ["Full", "Min/Max"],
        description: "Determines the extent of the channel slider input element in the layer controller."
      },
      type: {
        type: "string",
        enum: ["raster"]
      }
    }
  },
  moleculesLayer: {
    description: "The properties of this object are the rendering settings for the molecules layer.",
    additionalProperties: false,
    required: ["visible", "radius", "opacity", "type"],
    properties: {
      visible: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      },
      type: {
        type: "string",
        enum: ["molecules"]
      }
    }
  },
  cellsLayer: {
    description: "The properties of this object are the rendering settings for the cells layer.",
    additionalProperties: false,
    required: ["visible", "stroked", "radius", "opacity", "type"],
    properties: {
      visible: {
        type: "boolean"
      },
      stroked: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      },
      type: {
        type: "string",
        enum: ["cells"]
      }
    }
  },
  neighborhoodsLayer: {
    description: "The properties of this object are the rendering settings for the neighborhoods layer.",
    additionalProperties: false,
    required: ["visible", "type"],
    properties: {
      visible: {
        type: "boolean"
      },
      type: {
        type: "string",
        enum: ["neighborhoods"]
      }
    }
  },
  spatialLayers: {
    type: "array",
    description: "Array of Spatial Layers",
    items: {
      oneOf: [
        {
          $ref: "#/definitions/rasterLayer"
        },
        {
          $ref: "#/definitions/cellsLayer"
        },
        {
          $ref: "#/definitions/moleculesLayer"
        },
        {
          $ref: "#/definitions/neighborhoodsLayer"
        }
      ]
    }
  }
};
var additionalProperties3 = false;
var required3 = ["version", "name", "datasets", "layout", "initStrategy"];
var properties3 = {
  name: { type: "string" },
  public: { type: "boolean" },
  description: { type: "string" },
  datasets: {
    type: "array",
    description: "The datasets array defines groups of files, where the files within each dataset reference the same entities (cells, genes, cell sets, etc).",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["uid", "files"],
      properties: {
        uid: { type: "string" },
        name: { type: "string" },
        description: { type: "string" },
        files: {
          type: "array",
          items: {
            type: "object",
            additionalProperties: false,
            required: ["type", "fileType"],
            properties: {
              name: { type: "string" },
              type: { type: "string" },
              fileType: { type: "string" },
              url: { type: "string" },
              options: { oneOf: [{ $ref: "#/definitions/annDataCellSets" }, { $ref: "https://github.com/vitessce/vitessce/#raster" }, { $ref: "#/definitions/annDataCells" }, { $ref: "#/definitions/annDataExpressionMatrix" }] },
              requestInit: { $ref: "#/definitions/requestInit" }
            }
          }
        }
      }
    }
  },
  coordinationSpace: {
    type: "object",
    description: "The coordination space stores the values for each scope of each coordination object.",
    additionalProperties: false,
    required: [],
    properties: {
      dataset: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetZ: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingType: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingCellSetPolygonsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingCellSetLabelsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingCellSetLabelSize: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingCellRadius: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      spatialZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      spatialTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetZ: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      spatialLayers: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/spatialLayers" }
            ]
          }
        }
      },
      heatmapZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      cellFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cells will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      cellHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      cellSetSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto cell set initialization is enabled, cell set selections will be automatically initialized."
              },
              { type: "array" }
            ]
          }
        }
      },
      cellSetHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell sets will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      cellSetColor: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, cell set colors will be automatically initialized."
              },
              {
                type: "array",
                items: {
                  type: "object",
                  additionalProperties: false,
                  required: ["path", "color"],
                  properties: {
                    path: {
                      type: "array",
                      items: { type: "string" }
                    },
                    color: {
                      type: "array",
                      items: { type: "number" }
                    }
                  }
                }
              }
            ]
          }
        }
      },
      cellColorEncoding: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      geneFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      geneHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      geneSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      geneExpressionTransform: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "string", pattern: "log1p" }
            ]
          }
        }
      },
      geneExpressionColormap: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      geneExpressionColormapRange: {
        type: "object",
        patternProperties: {
          ".": { type: "array", items: { type: "number" } }
        }
      },
      genomicZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      additionalCellSets: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              {
                $ref: "https://github.com/vitessce/vitessce/#cell-sets"
              }
            ]
          }
        }
      },
      moleculeHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no molecule will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      }
    }
  },
  layout: { $ref: "#/definitions/components" },
  initStrategy: {
    type: "string",
    enum: ["none", "auto"],
    description: "The initialization strategy determines how missing coordination objects and coordination scope mappings are initially filled in."
  },
  version: {
    type: "string",
    enum: ["1.0.0"],
    description: "The schema version for the view config."
  }
};
var config_1_0_0_schema_default = {
  $schema: $schema7,
  $id: $id7,
  title: title7,
  type: type7,
  definitions: definitions7,
  additionalProperties: additionalProperties3,
  required: required3,
  properties: properties3
};

// src/schemas/config-1.0.1.schema.json
var $schema8 = "http://json-schema.org/draft-07/schema#";
var $id8 = "https://github.com/vitessce/vitessce/#dataset";
var title8 = "Vitessce data set";
var type8 = "object";
var definitions8 = {
  components: {
    description: "The layout array defines the views, or components, rendered in the grid.",
    type: "array",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["component", "x", "y"],
      properties: {
        component: {
          type: "string",
          description: "Specify a component using a name defined in the component registry."
        },
        props: {
          type: "object",
          description: "Extra prop values for the component."
        },
        x: { type: "integer" },
        y: { type: "integer" },
        w: { type: "integer" },
        h: { type: "integer" },
        coordinationScopes: {
          type: "object",
          description: "Component-level coordination scope mappings define which coordination object values a particular component can read and write, for each coordination type.",
          additionalProperties: false,
          required: [],
          properties: {
            dataset: { type: "string" },
            embeddingType: { type: "string" },
            embeddingZoom: { type: "string" },
            embeddingRotation: { type: "string" },
            embeddingTargetX: { type: "string" },
            embeddingTargetY: { type: "string" },
            embeddingTargetZ: { type: "string" },
            embeddingCellSetPolygonsVisible: { type: "string" },
            embeddingCellSetLabelsVisible: { type: "string" },
            embeddingCellSetLabelSize: { type: "string" },
            embeddingCellRadius: { type: "string" },
            spatialZoom: { type: "string" },
            spatialRotation: { type: "string" },
            spatialTargetX: { type: "string" },
            spatialTargetY: { type: "string" },
            spatialTargetZ: { type: "string" },
            spatialRotationX: { type: "string" },
            spatialRotationY: { type: "string" },
            spatialRotationZ: { type: "string" },
            spatialRotationOrbit: { type: "string" },
            spatialOrbitAxis: { type: "string" },
            spatialAxisFixed: { type: "string" },
            heatmapZoomX: { type: "string" },
            heatmapZoomY: { type: "string" },
            heatmapTargetX: { type: "string" },
            heatmapTargetY: { type: "string" },
            cellFilter: { type: "string" },
            cellHighlight: { type: "string" },
            cellSetSelection: { type: "string" },
            cellSetHighlight: { type: "string" },
            cellSetColor: { type: "string" },
            geneFilter: { type: "string" },
            geneHighlight: { type: "string" },
            geneSelection: { type: "string" },
            geneExpressionTransform: { type: "string" },
            geneExpressionColormap: { type: "string" },
            geneExpressionColormapRange: { type: "string" },
            cellColorEncoding: { type: "string" },
            spatialRasterLayers: { type: "string" },
            spatialCellsLayer: { type: "string" },
            spatialMoleculesLayer: { type: "string" },
            spatialNeighborhoodsLayer: { type: "string" },
            genomicZoomX: { type: "string" },
            genomicZoomY: { type: "string" },
            genomicTargetX: { type: "string" },
            genomicTargetY: { type: "string" },
            additionalCellSets: { type: "string" },
            moleculeHighlight: { type: "string" }
          }
        }
      }
    }
  },
  annDataCellSets: {
    type: "array",
    description: "Array of cell set configuration, following closely the conventions of the tabular schema",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["groupName", "setName"],
      properties: {
        groupName: {
          type: "string",
          description: "The display name for the set, like 'Cell Type' or 'Louvain.'"
        },
        setName: {
          type: "string",
          description: "The location in the AnnData store for the set, like 'obs/louvain' or 'obs/celltype.'"
        }
      }
    }
  },
  annDataCells: {
    type: "object",
    description: "The properties of this object are the configuration for how to layout scatterplots and spatial information",
    minProperties: 1,
    additionalProperties: false,
    required: [],
    properties: {
      xy: {
        type: "string",
        description: "The location in the AnnData store of cell centroids, like 'obsm/X_centroids.'"
      },
      poly: {
        type: "string",
        description: "The location in the AnnData store of cell polygon outlines, like 'obsm/X_polygons.'"
      },
      factors: {
        type: "array",
        description: "List of locations in the AnnData store of cell sets, like 'obs/louvain'",
        items: {
          type: "string"
        }
      },
      mappings: {
        patternProperties: {
          ".": {
            type: "object",
            description: "An object containing key-values for mappings like { UMAP: { key: 'obsm/X_umap', dims: [0, 1] } }.",
            additionalProperties: false,
            required: ["key"],
            properties: {
              key: {
                type: "string",
                description: "Where to look in the AnnData store for this mapping, like 'obsm/X_umap.'"
              },
              dims: {
                type: "array",
                description: "Which indices of the obsm object to take for a scatterplot, allowing for, for example, different PCs from obsm/X_pca",
                minItems: 2,
                maxItems: 2,
                items: { type: "number" }
              }
            }
          }
        }
      }
    }
  },
  annDataExpressionMatrix: {
    type: "object",
    description: "The properties of this object are the configuration for how to fetch the cell x genes matrix",
    additionalProperties: false,
    required: ["matrix"],
    properties: {
      matrix: {
        type: "string",
        description: "The location in the AnnData store of the cell x gene matrix, like 'obsm/hvg_subset.' or 'X'"
      },
      geneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the genes if using a subset of the data, like 'var.highly_variable.' if the matrix comes from 'obsm/hvg_subset.'"
      },
      matrixGeneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the matrix data (used in heatmap and histogram), like 'var.highly_variable.''"
      }
    }
  },
  requestInit: {
    type: "object",
    description: "The properties of this object correspond to the parameters of the JavaScript fetch() function.",
    additionalProperties: false,
    required: [],
    properties: {
      method: {
        type: "string"
      },
      headers: {
        type: "object"
      },
      body: {
        type: "string"
      },
      mode: {
        type: "string"
      },
      credentials: {
        type: "string"
      },
      cache: {
        type: "string"
      },
      redirect: {
        type: "string"
      },
      referrer: {
        type: "string"
      },
      integrity: {
        type: "string"
      }
    }
  },
  rasterLayer: {
    description: "The properties of this object are the rendering settings for the raster layer.",
    additionalProperties: false,
    required: ["channels", "colormap", "index", "opacity"],
    properties: {
      channels: {
        type: "array",
        items: {
          type: "object",
          additionalProperties: false,
          required: ["selection"],
          properties: {
            color: {
              type: "array",
              items: { type: "number" },
              description: "The color to use when rendering this channel under the null colormap."
            },
            selection: {
              type: "object",
              description: "Determines the channel selection, e.g. some Z and time slice."
            },
            slider: {
              type: "array",
              items: { type: "number" },
              description: "Determines the range for color mapping."
            },
            visible: {
              type: "boolean",
              description: "Determines whether this channel of the layer will be rendered in the spatial component."
            }
          }
        }
      },
      colormap: {
        oneOf: [
          {
            type: "string",
            description: "The name of the colormap to use for this layer."
          },
          {
            type: "null",
            description: "Use the solid color definitions."
          }
        ]
      },
      transparentColor: {
        oneOf: [
          {
            type: "array",
            minItems: 3,
            maxItems: 3,
            items: {
              type: "number",
              description: "One of R G or B (0 - 255)."
            },
            description: "Determines the color to be set to opacity 0"
          },
          {
            type: "null",
            description: "No selection."
          }
        ]
      },
      index: {
        type: "number",
        description: "The index of the layer among the array of layers available in the image file."
      },
      opacity: {
        type: "number"
      },
      modelMatrix: {
        oneOf: [
          {
            type: "array",
            minItems: 16,
            maxItems: 16,
            description: "transformation matrix for this layer"
          },
          {
            type: "null",
            description: "Use no transformation."
          }
        ]
      },
      domainType: {
        type: "string",
        enum: ["Full", "Min/Max"],
        description: "Determines the extent of the channel slider input element in the layer controller."
      },
      resolution: {
        type: "number",
        description: "Resolution of 3D volumetric rendering"
      },
      xSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      renderingMode: {
        type: "string",
        description: "Rendering mode of 3D volumetric rendering"
      },
      ySlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      zSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      type: {
        type: "string"
      },
      use3d: {
        type: "boolean"
      },
      visible: {
        type: "boolean",
        description: "Determines whether this entire layer will be rendered in the spatial component."
      }
    }
  },
  moleculesLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the molecules layer.",
    additionalProperties: false,
    required: ["visible", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  cellsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the cells layer.",
    additionalProperties: false,
    required: ["visible", "stroked", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      stroked: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  neighborhoodsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the neighborhoods layer.",
    additionalProperties: false,
    required: ["visible"],
    properties: {
      visible: {
        type: "boolean"
      }
    }
  },
  spatialRasterLayers: {
    type: "array",
    description: "Array of Spatial Layers",
    items: {
      $ref: "#/definitions/rasterLayer"
    }
  }
};
var additionalProperties4 = false;
var required4 = ["version", "name", "datasets", "layout", "initStrategy"];
var properties4 = {
  name: { type: "string" },
  public: { type: "boolean" },
  description: { type: "string" },
  datasets: {
    type: "array",
    description: "The datasets array defines groups of files, where the files within each dataset reference the same entities (cells, genes, cell sets, etc).",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["uid", "files"],
      properties: {
        uid: { type: "string" },
        name: { type: "string" },
        description: { type: "string" },
        files: {
          type: "array",
          items: {
            type: "object",
            additionalProperties: false,
            required: ["type", "fileType"],
            properties: {
              name: { type: "string" },
              type: { type: "string" },
              fileType: { type: "string" },
              url: { type: "string" },
              options: { oneOf: [{ $ref: "#/definitions/annDataCellSets" }, { $ref: "https://github.com/vitessce/vitessce/#raster" }, { $ref: "#/definitions/annDataCells" }, { $ref: "#/definitions/annDataExpressionMatrix" }] },
              requestInit: { $ref: "#/definitions/requestInit" }
            }
          }
        }
      }
    }
  },
  coordinationSpace: {
    type: "object",
    description: "The coordination space stores the values for each scope of each coordination object.",
    additionalProperties: false,
    required: [],
    properties: {
      dataset: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetZ: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingType: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingCellSetPolygonsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingCellSetLabelsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingCellSetLabelSize: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingCellRadius: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      spatialZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      spatialTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationOrbit: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialOrbitAxis: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "string" }
            ]
          }
        }
      },
      spatialAxisFixed: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "Whether or not to have a fixed axis for the camera. Only useful for 3D viewing."
              },
              { type: "boolean" }
            ]
          }
        }
      },
      spatialRasterLayers: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/spatialRasterLayers" }
            ]
          }
        }
      },
      spatialCellsLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/cellsLayer" }
            ]
          }
        }
      },
      spatialNeighborhoodsLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/neighborhoodsLayer" }
            ]
          }
        }
      },
      spatialMoleculesLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/moleculesLayer" }
            ]
          }
        }
      },
      heatmapZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      cellFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cells will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      cellHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      cellSetSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto cell set initialization is enabled, cell set selections will be automatically initialized."
              },
              { type: "array" }
            ]
          }
        }
      },
      cellSetHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell sets will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      cellSetColor: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, cell set colors will be automatically initialized."
              },
              {
                type: "array",
                items: {
                  type: "object",
                  additionalProperties: false,
                  required: ["path", "color"],
                  properties: {
                    path: {
                      type: "array",
                      items: { type: "string" }
                    },
                    color: {
                      type: "array",
                      items: { type: "number" }
                    }
                  }
                }
              }
            ]
          }
        }
      },
      cellColorEncoding: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      geneFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      geneHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      geneSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      geneExpressionTransform: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "string", pattern: "log1p" }
            ]
          }
        }
      },
      geneExpressionColormap: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      geneExpressionColormapRange: {
        type: "object",
        patternProperties: {
          ".": { type: "array", items: { type: "number" } }
        }
      },
      genomicZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      additionalCellSets: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              {
                $ref: "https://github.com/vitessce/vitessce/#cell-sets"
              }
            ]
          }
        }
      },
      moleculeHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no molecule will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      }
    }
  },
  layout: { $ref: "#/definitions/components" },
  initStrategy: {
    type: "string",
    enum: ["none", "auto"],
    description: "The initialization strategy determines how missing coordination objects and coordination scope mappings are initially filled in."
  },
  version: {
    type: "string",
    enum: ["1.0.1"],
    description: "The schema version for the view config."
  }
};
var config_1_0_1_schema_default = {
  $schema: $schema8,
  $id: $id8,
  title: title8,
  type: type8,
  definitions: definitions8,
  additionalProperties: additionalProperties4,
  required: required4,
  properties: properties4
};

// src/schemas/config-1.0.2.schema.json
var $schema9 = "http://json-schema.org/draft-07/schema#";
var $id9 = "https://github.com/vitessce/vitessce/#dataset";
var title9 = "Vitessce data set";
var type9 = "object";
var definitions9 = {
  components: {
    description: "The layout array defines the views, or components, rendered in the grid.",
    type: "array",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["component", "x", "y"],
      properties: {
        component: {
          type: "string",
          description: "Specify a component using a name defined in the component registry."
        },
        props: {
          type: "object",
          description: "Extra prop values for the component."
        },
        x: { type: "integer" },
        y: { type: "integer" },
        w: { type: "integer" },
        h: { type: "integer" },
        coordinationScopes: {
          type: "object",
          description: "Component-level coordination scope mappings define which coordination object values a particular component can read and write, for each coordination type.",
          additionalProperties: false,
          required: [],
          properties: {
            dataset: { type: "string" },
            embeddingType: { type: "string" },
            embeddingZoom: { type: "string" },
            embeddingRotation: { type: "string" },
            embeddingTargetX: { type: "string" },
            embeddingTargetY: { type: "string" },
            embeddingTargetZ: { type: "string" },
            embeddingCellSetPolygonsVisible: { type: "string" },
            embeddingCellSetLabelsVisible: { type: "string" },
            embeddingCellSetLabelSize: { type: "string" },
            embeddingCellRadius: { type: "string" },
            spatialZoom: { type: "string" },
            spatialRotation: { type: "string" },
            spatialTargetX: { type: "string" },
            spatialTargetY: { type: "string" },
            spatialTargetZ: { type: "string" },
            spatialRotationX: { type: "string" },
            spatialRotationY: { type: "string" },
            spatialRotationZ: { type: "string" },
            spatialRotationOrbit: { type: "string" },
            spatialOrbitAxis: { type: "string" },
            spatialAxisFixed: { type: "string" },
            heatmapZoomX: { type: "string" },
            heatmapZoomY: { type: "string" },
            heatmapTargetX: { type: "string" },
            heatmapTargetY: { type: "string" },
            cellFilter: { type: "string" },
            cellHighlight: { type: "string" },
            cellSetSelection: { type: "string" },
            cellSetHighlight: { type: "string" },
            cellSetColor: { type: "string" },
            geneFilter: { type: "string" },
            geneHighlight: { type: "string" },
            geneSelection: { type: "string" },
            geneExpressionTransform: { type: "string" },
            geneExpressionColormap: { type: "string" },
            geneExpressionColormapRange: { type: "string" },
            cellColorEncoding: { type: "string" },
            spatialRasterLayers: { type: "string" },
            spatialCellsLayer: { type: "string" },
            spatialMoleculesLayer: { type: "string" },
            spatialNeighborhoodsLayer: { type: "string" },
            genomicZoomX: { type: "string" },
            genomicZoomY: { type: "string" },
            genomicTargetX: { type: "string" },
            genomicTargetY: { type: "string" },
            additionalCellSets: { type: "string" },
            moleculeHighlight: { type: "string" }
          }
        }
      }
    }
  },
  annDataCellSets: {
    type: "array",
    description: "Array of cell set configuration, following closely the conventions of the tabular schema",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["groupName", "setName"],
      properties: {
        groupName: {
          type: "string",
          description: "The display name for the set, like 'Cell Type' or 'Louvain.'"
        },
        setName: {
          type: "string",
          description: "The location in the AnnData store for the set, like 'obs/louvain' or 'obs/celltype.'"
        }
      }
    }
  },
  annDataCells: {
    type: "object",
    description: "The properties of this object are the configuration for how to layout scatterplots and spatial information",
    minProperties: 1,
    additionalProperties: false,
    required: [],
    properties: {
      xy: {
        type: "string",
        description: "The location in the AnnData store of cell centroids, like 'obsm/X_centroids.'"
      },
      poly: {
        type: "string",
        description: "The location in the AnnData store of cell polygon outlines, like 'obsm/X_polygons.'"
      },
      factors: {
        type: "array",
        description: "List of locations in the AnnData store of cell sets, like 'obs/louvain'",
        items: {
          type: "string"
        }
      },
      mappings: {
        patternProperties: {
          ".": {
            type: "object",
            description: "An object containing key-values for mappings like { UMAP: { key: 'obsm/X_umap', dims: [0, 1] } }.",
            additionalProperties: false,
            required: ["key"],
            properties: {
              key: {
                type: "string",
                description: "Where to look in the AnnData store for this mapping, like 'obsm/X_umap.'"
              },
              dims: {
                type: "array",
                description: "Which indices of the obsm object to take for a scatterplot, allowing for, for example, different PCs from obsm/X_pca",
                minItems: 2,
                maxItems: 2,
                items: { type: "number" }
              }
            }
          }
        }
      }
    }
  },
  annDataExpressionMatrix: {
    type: "object",
    description: "The properties of this object are the configuration for how to fetch the cell x genes matrix",
    additionalProperties: false,
    required: ["matrix"],
    properties: {
      matrix: {
        type: "string",
        description: "The location in the AnnData store of the cell x gene matrix, like 'obsm/hvg_subset.' or 'X'"
      },
      geneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the genes if using a subset of the data, like 'var.highly_variable.' if the matrix comes from 'obsm/hvg_subset.'"
      },
      matrixGeneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the matrix data (used in heatmap and histogram), like 'var.highly_variable.''"
      }
    }
  },
  requestInit: {
    type: "object",
    description: "The properties of this object correspond to the parameters of the JavaScript fetch() function.",
    additionalProperties: false,
    required: [],
    properties: {
      method: {
        type: "string"
      },
      headers: {
        type: "object"
      },
      body: {
        type: "string"
      },
      mode: {
        type: "string"
      },
      credentials: {
        type: "string"
      },
      cache: {
        type: "string"
      },
      redirect: {
        type: "string"
      },
      referrer: {
        type: "string"
      },
      integrity: {
        type: "string"
      }
    }
  },
  rasterLayer: {
    description: "The properties of this object are the rendering settings for the raster layer.",
    additionalProperties: false,
    required: ["channels", "colormap", "index", "opacity"],
    properties: {
      channels: {
        type: "array",
        items: {
          type: "object",
          additionalProperties: false,
          required: ["selection"],
          properties: {
            color: {
              type: "array",
              items: { type: "number" },
              description: "The color to use when rendering this channel under the null colormap."
            },
            selection: {
              type: "object",
              description: "Determines the channel selection, e.g. some Z and time slice."
            },
            slider: {
              type: "array",
              items: { type: "number" },
              description: "Determines the range for color mapping."
            },
            visible: {
              type: "boolean",
              description: "Determines whether this channel of the layer will be rendered in the spatial component."
            }
          }
        }
      },
      colormap: {
        oneOf: [
          {
            type: "string",
            description: "The name of the colormap to use for this layer."
          },
          {
            type: "null",
            description: "Use the solid color definitions."
          }
        ]
      },
      transparentColor: {
        oneOf: [
          {
            type: "array",
            minItems: 3,
            maxItems: 3,
            items: {
              type: "number",
              description: "One of R G or B (0 - 255)."
            },
            description: "Determines the color to be set to opacity 0"
          },
          {
            type: "null",
            description: "No selection."
          }
        ]
      },
      index: {
        type: "number",
        description: "The index of the layer among the array of layers available in the image file."
      },
      opacity: {
        type: "number"
      },
      modelMatrix: {
        oneOf: [
          {
            type: "array",
            minItems: 16,
            maxItems: 16,
            description: "transformation matrix for this layer"
          },
          {
            type: "null",
            description: "Use no transformation."
          }
        ]
      },
      domainType: {
        type: "string",
        enum: ["Full", "Min/Max"],
        description: "Determines the extent of the channel slider input element in the layer controller."
      },
      resolution: {
        type: "number",
        description: "Resolution of 3D volumetric rendering"
      },
      xSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      renderingMode: {
        type: "string",
        description: "Rendering mode of 3D volumetric rendering"
      },
      ySlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      zSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      type: {
        type: "string",
        enum: ["raster", "bitmask"]
      },
      use3d: {
        type: "boolean"
      },
      visible: {
        type: "boolean",
        description: "Determines whether this entire layer will be rendered in the spatial component."
      }
    }
  },
  moleculesLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the molecules layer.",
    additionalProperties: false,
    required: ["visible", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  cellsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the cells layer.",
    additionalProperties: false,
    required: ["visible", "stroked", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      stroked: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  neighborhoodsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the neighborhoods layer.",
    additionalProperties: false,
    required: ["visible"],
    properties: {
      visible: {
        type: "boolean"
      }
    }
  },
  spatialRasterLayers: {
    type: "array",
    description: "Array of Spatial Layers",
    items: {
      $ref: "#/definitions/rasterLayer"
    }
  }
};
var additionalProperties5 = false;
var required5 = ["version", "name", "datasets", "layout", "initStrategy"];
var properties5 = {
  name: { type: "string" },
  public: { type: "boolean" },
  description: { type: "string" },
  datasets: {
    type: "array",
    description: "The datasets array defines groups of files, where the files within each dataset reference the same entities (cells, genes, cell sets, etc).",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["uid", "files"],
      properties: {
        uid: { type: "string" },
        name: { type: "string" },
        description: { type: "string" },
        files: {
          type: "array",
          items: {
            type: "object",
            additionalProperties: false,
            required: ["type", "fileType"],
            properties: {
              name: { type: "string" },
              type: { type: "string" },
              fileType: { type: "string" },
              url: { type: "string" },
              options: { oneOf: [{ $ref: "#/definitions/annDataCellSets" }, { $ref: "https://github.com/vitessce/vitessce/#raster" }, { $ref: "#/definitions/annDataCells" }, { $ref: "#/definitions/annDataExpressionMatrix" }] },
              requestInit: { $ref: "#/definitions/requestInit" }
            }
          }
        }
      }
    }
  },
  coordinationSpace: {
    type: "object",
    description: "The coordination space stores the values for each scope of each coordination object.",
    additionalProperties: false,
    required: [],
    properties: {
      dataset: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetZ: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingType: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingCellSetPolygonsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingCellSetLabelsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingCellSetLabelSize: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingCellRadius: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      spatialZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      spatialTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationOrbit: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialOrbitAxis: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "string" }
            ]
          }
        }
      },
      spatialAxisFixed: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "Whether or not to have a fixed axis for the camera. Only useful for 3D viewing."
              },
              { type: "boolean" }
            ]
          }
        }
      },
      spatialRasterLayers: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/spatialRasterLayers" }
            ]
          }
        }
      },
      spatialCellsLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/cellsLayer" }
            ]
          }
        }
      },
      spatialNeighborhoodsLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/neighborhoodsLayer" }
            ]
          }
        }
      },
      spatialMoleculesLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/moleculesLayer" }
            ]
          }
        }
      },
      heatmapZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      cellFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cells will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      cellHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      cellSetSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto cell set initialization is enabled, cell set selections will be automatically initialized."
              },
              { type: "array" }
            ]
          }
        }
      },
      cellSetHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell sets will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      cellSetColor: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, cell set colors will be automatically initialized."
              },
              {
                type: "array",
                items: {
                  type: "object",
                  additionalProperties: false,
                  required: ["path", "color"],
                  properties: {
                    path: {
                      type: "array",
                      items: { type: "string" }
                    },
                    color: {
                      type: "array",
                      items: { type: "number" }
                    }
                  }
                }
              }
            ]
          }
        }
      },
      cellColorEncoding: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      geneFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      geneHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      geneSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      geneExpressionTransform: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "string", pattern: "log1p" }
            ]
          }
        }
      },
      geneExpressionColormap: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      geneExpressionColormapRange: {
        type: "object",
        patternProperties: {
          ".": { type: "array", items: { type: "number" } }
        }
      },
      genomicZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      additionalCellSets: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              {
                $ref: "https://github.com/vitessce/vitessce/#cell-sets"
              }
            ]
          }
        }
      },
      moleculeHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no molecule will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      }
    }
  },
  layout: { $ref: "#/definitions/components" },
  initStrategy: {
    type: "string",
    enum: ["none", "auto"],
    description: "The initialization strategy determines how missing coordination objects and coordination scope mappings are initially filled in."
  },
  version: {
    type: "string",
    enum: ["1.0.2"],
    description: "The schema version for the view config."
  }
};
var config_1_0_2_schema_default = {
  $schema: $schema9,
  $id: $id9,
  title: title9,
  type: type9,
  definitions: definitions9,
  additionalProperties: additionalProperties5,
  required: required5,
  properties: properties5
};

// src/schemas/config-1.0.3.schema.json
var $schema10 = "http://json-schema.org/draft-07/schema#";
var $id10 = "https://github.com/vitessce/vitessce/#dataset";
var title10 = "Vitessce data set";
var type10 = "object";
var definitions10 = {
  components: {
    description: "The layout array defines the views, or components, rendered in the grid.",
    type: "array",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["component", "x", "y"],
      properties: {
        component: {
          type: "string",
          description: "Specify a component using a name defined in the component registry."
        },
        props: {
          type: "object",
          description: "Extra prop values for the component."
        },
        x: { type: "integer" },
        y: { type: "integer" },
        w: { type: "integer" },
        h: { type: "integer" },
        coordinationScopes: {
          type: "object",
          description: "Component-level coordination scope mappings define which coordination object values a particular component can read and write, for each coordination type.",
          additionalProperties: false,
          required: [],
          properties: {
            dataset: { type: "string" },
            embeddingType: { type: "string" },
            embeddingZoom: { type: "string" },
            embeddingRotation: { type: "string" },
            embeddingTargetX: { type: "string" },
            embeddingTargetY: { type: "string" },
            embeddingTargetZ: { type: "string" },
            embeddingCellSetPolygonsVisible: { type: "string" },
            embeddingCellSetLabelsVisible: { type: "string" },
            embeddingCellSetLabelSize: { type: "string" },
            embeddingCellRadius: { type: "string" },
            spatialZoom: { type: "string" },
            spatialRotation: { type: "string" },
            spatialTargetX: { type: "string" },
            spatialTargetY: { type: "string" },
            spatialTargetZ: { type: "string" },
            spatialRotationX: { type: "string" },
            spatialRotationY: { type: "string" },
            spatialRotationZ: { type: "string" },
            spatialRotationOrbit: { type: "string" },
            spatialOrbitAxis: { type: "string" },
            spatialAxisFixed: { type: "string" },
            heatmapZoomX: { type: "string" },
            heatmapZoomY: { type: "string" },
            heatmapTargetX: { type: "string" },
            heatmapTargetY: { type: "string" },
            cellFilter: { type: "string" },
            cellHighlight: { type: "string" },
            cellSetSelection: { type: "string" },
            cellSetHighlight: { type: "string" },
            cellSetColor: { type: "string" },
            geneFilter: { type: "string" },
            geneHighlight: { type: "string" },
            geneSelection: { type: "string" },
            geneExpressionTransform: { type: "string" },
            geneExpressionColormap: { type: "string" },
            geneExpressionColormapRange: { type: "string" },
            cellColorEncoding: { type: "string" },
            spatialRasterLayers: { type: "string" },
            spatialCellsLayer: { type: "string" },
            spatialMoleculesLayer: { type: "string" },
            spatialNeighborhoodsLayer: { type: "string" },
            genomicZoomX: { type: "string" },
            genomicZoomY: { type: "string" },
            genomicTargetX: { type: "string" },
            genomicTargetY: { type: "string" },
            additionalCellSets: { type: "string" },
            moleculeHighlight: { type: "string" }
          }
        }
      }
    }
  },
  annDataCellSets: {
    type: "array",
    description: "Array of cell set configuration, following closely the conventions of the tabular schema",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["groupName", "setName"],
      properties: {
        groupName: {
          type: "string",
          description: "The display name for the set, like 'Cell Type' or 'Louvain.'"
        },
        setName: {
          type: "string",
          description: "The location in the AnnData store for the set, like 'obs/louvain' or 'obs/celltype.'"
        }
      }
    }
  },
  annDataCells: {
    type: "object",
    description: "The properties of this object are the configuration for how to layout scatterplots and spatial information",
    minProperties: 1,
    additionalProperties: false,
    required: [],
    properties: {
      xy: {
        type: "string",
        description: "The location in the AnnData store of cell centroids, like 'obsm/X_centroids.'"
      },
      poly: {
        type: "string",
        description: "The location in the AnnData store of cell polygon outlines, like 'obsm/X_polygons.'"
      },
      factors: {
        type: "array",
        description: "List of locations in the AnnData store of cell sets, like 'obs/louvain'",
        items: {
          type: "string"
        }
      },
      mappings: {
        patternProperties: {
          ".": {
            type: "object",
            description: "An object containing key-values for mappings like { UMAP: { key: 'obsm/X_umap', dims: [0, 1] } }.",
            additionalProperties: false,
            required: ["key"],
            properties: {
              key: {
                type: "string",
                description: "Where to look in the AnnData store for this mapping, like 'obsm/X_umap.'"
              },
              dims: {
                type: "array",
                description: "Which indices of the obsm object to take for a scatterplot, allowing for, for example, different PCs from obsm/X_pca",
                minItems: 2,
                maxItems: 2,
                items: { type: "number" }
              }
            }
          }
        }
      }
    }
  },
  annDataExpressionMatrix: {
    type: "object",
    description: "The properties of this object are the configuration for how to fetch the cell x genes matrix",
    additionalProperties: false,
    required: ["matrix"],
    properties: {
      matrix: {
        type: "string",
        description: "The location in the AnnData store of the cell x gene matrix, like 'obsm/hvg_subset.' or 'X'"
      },
      geneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the genes if using a subset of the data, like 'var.highly_variable.' if the matrix comes from 'obsm/hvg_subset.'"
      },
      matrixGeneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the matrix data (used in heatmap and histogram), like 'var.highly_variable.''"
      }
    }
  },
  requestInit: {
    type: "object",
    description: "The properties of this object correspond to the parameters of the JavaScript fetch() function.",
    additionalProperties: false,
    required: [],
    properties: {
      method: {
        type: "string"
      },
      headers: {
        type: "object"
      },
      body: {
        type: "string"
      },
      mode: {
        type: "string"
      },
      credentials: {
        type: "string"
      },
      cache: {
        type: "string"
      },
      redirect: {
        type: "string"
      },
      referrer: {
        type: "string"
      },
      integrity: {
        type: "string"
      }
    }
  },
  rasterLayer: {
    description: "The properties of this object are the rendering settings for the raster layer.",
    additionalProperties: false,
    required: ["channels", "colormap", "index", "opacity"],
    properties: {
      channels: {
        type: "array",
        items: {
          type: "object",
          additionalProperties: false,
          required: ["selection"],
          properties: {
            color: {
              type: "array",
              items: { type: "number" },
              description: "The color to use when rendering this channel under the null colormap."
            },
            selection: {
              type: "object",
              description: "Determines the channel selection, e.g. some Z and time slice."
            },
            slider: {
              type: "array",
              items: { type: "number" },
              description: "Determines the range for color mapping."
            },
            visible: {
              type: "boolean",
              description: "Determines whether this channel of the layer will be rendered in the spatial component."
            }
          }
        }
      },
      colormap: {
        oneOf: [
          {
            type: "string",
            description: "The name of the colormap to use for this layer."
          },
          {
            type: "null",
            description: "Use the solid color definitions."
          }
        ]
      },
      transparentColor: {
        oneOf: [
          {
            type: "array",
            minItems: 3,
            maxItems: 3,
            items: {
              type: "number",
              description: "One of R G or B (0 - 255)."
            },
            description: "Determines the color to be set to opacity 0"
          },
          {
            type: "null",
            description: "No selection."
          }
        ]
      },
      index: {
        type: "number",
        description: "The index of the layer among the array of layers available in the image file."
      },
      opacity: {
        type: "number"
      },
      modelMatrix: {
        oneOf: [
          {
            type: "array",
            minItems: 16,
            maxItems: 16,
            description: "transformation matrix for this layer"
          },
          {
            type: "null",
            description: "Use no transformation."
          }
        ]
      },
      domainType: {
        type: "string",
        enum: ["Full", "Min/Max"],
        description: "Determines the extent of the channel slider input element in the layer controller."
      },
      resolution: {
        type: "number",
        description: "Resolution of 3D volumetric rendering"
      },
      xSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      renderingMode: {
        type: "string",
        description: "Rendering mode of 3D volumetric rendering"
      },
      ySlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      zSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      type: {
        type: "string",
        enum: ["raster", "bitmask"]
      },
      use3d: {
        type: "boolean"
      },
      visible: {
        type: "boolean",
        description: "Determines whether this entire layer will be rendered in the spatial component."
      }
    }
  },
  moleculesLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the molecules layer.",
    additionalProperties: false,
    required: ["visible", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  cellsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the cells layer.",
    additionalProperties: false,
    required: ["visible", "stroked", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      stroked: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  neighborhoodsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the neighborhoods layer.",
    additionalProperties: false,
    required: ["visible"],
    properties: {
      visible: {
        type: "boolean"
      }
    }
  },
  spatialRasterLayers: {
    type: "array",
    description: "Array of Spatial Layers",
    items: {
      $ref: "#/definitions/rasterLayer"
    }
  }
};
var additionalProperties6 = false;
var required6 = ["version", "name", "datasets", "layout", "initStrategy"];
var properties6 = {
  name: { type: "string" },
  public: { type: "boolean" },
  description: { type: "string" },
  datasets: {
    type: "array",
    description: "The datasets array defines groups of files, where the files within each dataset reference the same entities (cells, genes, cell sets, etc).",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["uid", "files"],
      properties: {
        uid: { type: "string" },
        name: { type: "string" },
        description: { type: "string" },
        files: {
          type: "array",
          items: {
            type: "object",
            additionalProperties: false,
            required: ["type", "fileType"],
            properties: {
              name: { type: "string" },
              type: { type: "string" },
              fileType: { type: "string" },
              url: { type: "string" },
              options: { oneOf: [{ $ref: "#/definitions/annDataCellSets" }, { $ref: "https://github.com/vitessce/vitessce/#raster" }, { $ref: "#/definitions/annDataCells" }, { $ref: "#/definitions/annDataExpressionMatrix" }] },
              requestInit: { $ref: "#/definitions/requestInit" }
            }
          }
        }
      }
    }
  },
  coordinationSpace: {
    type: "object",
    description: "The coordination space stores the values for each scope of each coordination object.",
    additionalProperties: false,
    required: [],
    properties: {
      dataset: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetZ: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingType: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingCellSetPolygonsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingCellSetLabelsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingCellSetLabelSize: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingCellRadius: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      spatialZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      spatialTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationOrbit: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialOrbitAxis: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "string" }
            ]
          }
        }
      },
      spatialAxisFixed: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "Whether or not to have a fixed axis for the camera. Only useful for 3D viewing."
              },
              { type: "boolean" }
            ]
          }
        }
      },
      spatialRasterLayers: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/spatialRasterLayers" }
            ]
          }
        }
      },
      spatialCellsLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/cellsLayer" }
            ]
          }
        }
      },
      spatialNeighborhoodsLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/neighborhoodsLayer" }
            ]
          }
        }
      },
      spatialMoleculesLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/moleculesLayer" }
            ]
          }
        }
      },
      heatmapZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      cellFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cells will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      cellHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      cellSetSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto cell set initialization is enabled, cell set selections will be automatically initialized."
              },
              { type: "array" }
            ]
          }
        }
      },
      cellSetHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell sets will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      cellSetColor: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, cell set colors will be automatically initialized."
              },
              {
                type: "array",
                items: {
                  type: "object",
                  additionalProperties: false,
                  required: ["path", "color"],
                  properties: {
                    path: {
                      type: "array",
                      items: { type: "string" }
                    },
                    color: {
                      type: "array",
                      items: { type: "number" }
                    }
                  }
                }
              }
            ]
          }
        }
      },
      cellColorEncoding: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      geneFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      geneHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      geneSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      geneExpressionTransform: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "string", pattern: "log1p" }
            ]
          }
        }
      },
      geneExpressionColormap: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      geneExpressionColormapRange: {
        type: "object",
        patternProperties: {
          ".": { type: "array", items: { type: "number" } }
        }
      },
      genomicZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      additionalCellSets: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              {
                $ref: "https://github.com/vitessce/vitessce/#cell-sets"
              }
            ]
          }
        }
      },
      moleculeHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no molecule will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      }
    }
  },
  layout: { $ref: "#/definitions/components" },
  initStrategy: {
    type: "string",
    enum: ["none", "auto"],
    description: "The initialization strategy determines how missing coordination objects and coordination scope mappings are initially filled in."
  },
  version: {
    type: "string",
    enum: ["1.0.3"],
    description: "The schema version for the view config."
  }
};
var config_1_0_3_schema_default = {
  $schema: $schema10,
  $id: $id10,
  title: title10,
  type: type10,
  definitions: definitions10,
  additionalProperties: additionalProperties6,
  required: required6,
  properties: properties6
};

// src/schemas/config-1.0.4.schema.json
var $schema11 = "http://json-schema.org/draft-07/schema#";
var $id11 = "https://github.com/vitessce/vitessce/#dataset";
var title11 = "Vitessce data set";
var type11 = "object";
var definitions11 = {
  components: {
    description: "The layout array defines the views, or components, rendered in the grid.",
    type: "array",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["component", "x", "y"],
      properties: {
        component: {
          type: "string",
          description: "Specify a component using a name defined in the component registry."
        },
        props: {
          type: "object",
          description: "Extra prop values for the component."
        },
        x: { type: "integer" },
        y: { type: "integer" },
        w: { type: "integer" },
        h: { type: "integer" },
        coordinationScopes: {
          type: "object",
          description: "Component-level coordination scope mappings define which coordination object values a particular component can read and write, for each coordination type.",
          additionalProperties: false,
          required: [],
          properties: {
            dataset: { type: "string" },
            embeddingType: { type: "string" },
            embeddingZoom: { type: "string" },
            embeddingRotation: { type: "string" },
            embeddingTargetX: { type: "string" },
            embeddingTargetY: { type: "string" },
            embeddingTargetZ: { type: "string" },
            embeddingCellSetPolygonsVisible: { type: "string" },
            embeddingCellSetLabelsVisible: { type: "string" },
            embeddingCellSetLabelSize: { type: "string" },
            embeddingCellRadius: { type: "string" },
            embeddingCellOpacity: { type: "string" },
            embeddingCellRadiusMode: { type: "string" },
            embeddingCellOpacityMode: { type: "string" },
            spatialZoom: { type: "string" },
            spatialRotation: { type: "string" },
            spatialTargetX: { type: "string" },
            spatialTargetY: { type: "string" },
            spatialTargetZ: { type: "string" },
            spatialRotationX: { type: "string" },
            spatialRotationY: { type: "string" },
            spatialRotationZ: { type: "string" },
            spatialRotationOrbit: { type: "string" },
            spatialOrbitAxis: { type: "string" },
            spatialAxisFixed: { type: "string" },
            heatmapZoomX: { type: "string" },
            heatmapZoomY: { type: "string" },
            heatmapTargetX: { type: "string" },
            heatmapTargetY: { type: "string" },
            cellFilter: { type: "string" },
            cellHighlight: { type: "string" },
            cellSetSelection: { type: "string" },
            cellSetHighlight: { type: "string" },
            cellSetColor: { type: "string" },
            geneFilter: { type: "string" },
            geneHighlight: { type: "string" },
            geneSelection: { type: "string" },
            geneExpressionTransform: { type: "string" },
            geneExpressionColormap: { type: "string" },
            geneExpressionColormapRange: { type: "string" },
            cellColorEncoding: { type: "string" },
            spatialRasterLayers: { type: "string" },
            spatialCellsLayer: { type: "string" },
            spatialMoleculesLayer: { type: "string" },
            spatialNeighborhoodsLayer: { type: "string" },
            genomicZoomX: { type: "string" },
            genomicZoomY: { type: "string" },
            genomicTargetX: { type: "string" },
            genomicTargetY: { type: "string" },
            additionalCellSets: { type: "string" },
            moleculeHighlight: { type: "string" }
          }
        }
      }
    }
  },
  annDataCellSets: {
    type: "array",
    description: "Array of cell set configuration, following closely the conventions of the tabular schema",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["groupName", "setName"],
      properties: {
        groupName: {
          type: "string",
          description: "The display name for the set, like 'Cell Type' or 'Louvain.'"
        },
        setName: {
          type: "string",
          description: "The location in the AnnData store for the set, like 'obs/louvain' or 'obs/celltype.'"
        }
      }
    }
  },
  annDataCells: {
    type: "object",
    description: "The properties of this object are the configuration for how to layout scatterplots and spatial information",
    minProperties: 1,
    additionalProperties: false,
    required: [],
    properties: {
      xy: {
        type: "string",
        description: "The location in the AnnData store of cell centroids, like 'obsm/X_centroids.'"
      },
      poly: {
        type: "string",
        description: "The location in the AnnData store of cell polygon outlines, like 'obsm/X_polygons.'"
      },
      factors: {
        type: "array",
        description: "List of locations in the AnnData store of cell sets, like 'obs/louvain'",
        items: {
          type: "string"
        }
      },
      mappings: {
        patternProperties: {
          ".": {
            type: "object",
            description: "An object containing key-values for mappings like { UMAP: { key: 'obsm/X_umap', dims: [0, 1] } }.",
            additionalProperties: false,
            required: ["key"],
            properties: {
              key: {
                type: "string",
                description: "Where to look in the AnnData store for this mapping, like 'obsm/X_umap.'"
              },
              dims: {
                type: "array",
                description: "Which indices of the obsm object to take for a scatterplot, allowing for, for example, different PCs from obsm/X_pca",
                minItems: 2,
                maxItems: 2,
                items: { type: "number" }
              }
            }
          }
        }
      }
    }
  },
  annDataExpressionMatrix: {
    type: "object",
    description: "The properties of this object are the configuration for how to fetch the cell x genes matrix",
    additionalProperties: false,
    required: ["matrix"],
    properties: {
      matrix: {
        type: "string",
        description: "The location in the AnnData store of the cell x gene matrix, like 'obsm/hvg_subset.' or 'X'"
      },
      geneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the genes if using a subset of the data, like 'var.highly_variable.' if the matrix comes from 'obsm/hvg_subset.'"
      },
      matrixGeneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the matrix data (used in heatmap and histogram), like 'var.highly_variable.''"
      }
    }
  },
  requestInit: {
    type: "object",
    description: "The properties of this object correspond to the parameters of the JavaScript fetch() function.",
    additionalProperties: false,
    required: [],
    properties: {
      method: {
        type: "string"
      },
      headers: {
        type: "object"
      },
      body: {
        type: "string"
      },
      mode: {
        type: "string"
      },
      credentials: {
        type: "string"
      },
      cache: {
        type: "string"
      },
      redirect: {
        type: "string"
      },
      referrer: {
        type: "string"
      },
      integrity: {
        type: "string"
      }
    }
  },
  rasterLayer: {
    description: "The properties of this object are the rendering settings for the raster layer.",
    additionalProperties: false,
    required: ["channels", "colormap", "index", "opacity"],
    properties: {
      channels: {
        type: "array",
        items: {
          type: "object",
          additionalProperties: false,
          required: ["selection"],
          properties: {
            color: {
              type: "array",
              items: { type: "number" },
              description: "The color to use when rendering this channel under the null colormap."
            },
            selection: {
              type: "object",
              description: "Determines the channel selection, e.g. some Z and time slice."
            },
            slider: {
              type: "array",
              items: { type: "number" },
              description: "Determines the range for color mapping."
            },
            visible: {
              type: "boolean",
              description: "Determines whether this channel of the layer will be rendered in the spatial component."
            }
          }
        }
      },
      colormap: {
        oneOf: [
          {
            type: "string",
            description: "The name of the colormap to use for this layer."
          },
          {
            type: "null",
            description: "Use the solid color definitions."
          }
        ]
      },
      transparentColor: {
        oneOf: [
          {
            type: "array",
            minItems: 3,
            maxItems: 3,
            items: {
              type: "number",
              description: "One of R G or B (0 - 255)."
            },
            description: "Determines the color to be set to opacity 0"
          },
          {
            type: "null",
            description: "No selection."
          }
        ]
      },
      index: {
        type: "number",
        description: "The index of the layer among the array of layers available in the image file."
      },
      opacity: {
        type: "number"
      },
      modelMatrix: {
        oneOf: [
          {
            type: "array",
            minItems: 16,
            maxItems: 16,
            description: "transformation matrix for this layer"
          },
          {
            type: "null",
            description: "Use no transformation."
          }
        ]
      },
      domainType: {
        type: "string",
        enum: ["Full", "Min/Max"],
        description: "Determines the extent of the channel slider input element in the layer controller."
      },
      resolution: {
        type: "number",
        description: "Resolution of 3D volumetric rendering"
      },
      xSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      renderingMode: {
        type: "string",
        description: "Rendering mode of 3D volumetric rendering"
      },
      ySlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      zSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      type: {
        type: "string",
        enum: ["raster", "bitmask"]
      },
      use3d: {
        type: "boolean"
      },
      visible: {
        type: "boolean",
        description: "Determines whether this entire layer will be rendered in the spatial component."
      }
    }
  },
  moleculesLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the molecules layer.",
    additionalProperties: false,
    required: ["visible", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  cellsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the cells layer.",
    additionalProperties: false,
    required: ["visible", "stroked", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      stroked: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  neighborhoodsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the neighborhoods layer.",
    additionalProperties: false,
    required: ["visible"],
    properties: {
      visible: {
        type: "boolean"
      }
    }
  },
  spatialRasterLayers: {
    type: "array",
    description: "Array of Spatial Layers",
    items: {
      $ref: "#/definitions/rasterLayer"
    }
  }
};
var additionalProperties7 = false;
var required7 = ["version", "name", "datasets", "layout", "initStrategy"];
var properties7 = {
  name: { type: "string" },
  public: { type: "boolean" },
  description: { type: "string" },
  datasets: {
    type: "array",
    description: "The datasets array defines groups of files, where the files within each dataset reference the same entities (cells, genes, cell sets, etc).",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["uid", "files"],
      properties: {
        uid: { type: "string" },
        name: { type: "string" },
        description: { type: "string" },
        files: {
          type: "array",
          items: {
            type: "object",
            additionalProperties: false,
            required: ["type", "fileType"],
            properties: {
              name: { type: "string" },
              type: { type: "string" },
              fileType: { type: "string" },
              url: { type: "string" },
              options: { oneOf: [{ $ref: "#/definitions/annDataCellSets" }, { $ref: "https://github.com/vitessce/vitessce/#raster" }, { $ref: "#/definitions/annDataCells" }, { $ref: "#/definitions/annDataExpressionMatrix" }] },
              requestInit: { $ref: "#/definitions/requestInit" }
            }
          }
        }
      }
    }
  },
  coordinationSpace: {
    type: "object",
    description: "The coordination space stores the values for each scope of each coordination object.",
    additionalProperties: false,
    required: [],
    properties: {
      dataset: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetZ: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingType: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingCellSetPolygonsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingCellSetLabelsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingCellSetLabelSize: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingCellRadius: {
        type: "object",
        patternProperties: {
          ".": {
            type: "number",
            description: "The cell radius value, used when embeddingCellRadiusMode is absolute or relative."
          }
        }
      },
      embeddingCellOpacity: {
        type: "object",
        patternProperties: {
          ".": {
            type: "number",
            description: "The cell opacity value, used when embeddingCellOpacityMode is static."
          }
        }
      },
      embeddingCellRadiusMode: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["manual", "auto"],
            description: "Should data points representing cells be assigned a static (manual) or dynamic (auto, based on zoom level and data extent) radius?"
          }
        }
      },
      embeddingCellOpacityMode: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["manual", "auto"],
            description: "Should data points representing cells be assigned a static (manual) or dynamic (auto, based on zoom level and data extent) opacity?"
          }
        }
      },
      spatialZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      spatialTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationOrbit: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialOrbitAxis: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "string" }
            ]
          }
        }
      },
      spatialAxisFixed: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "Whether or not to have a fixed axis for the camera. Only useful for 3D viewing."
              },
              { type: "boolean" }
            ]
          }
        }
      },
      spatialRasterLayers: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/spatialRasterLayers" }
            ]
          }
        }
      },
      spatialCellsLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/cellsLayer" }
            ]
          }
        }
      },
      spatialNeighborhoodsLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/neighborhoodsLayer" }
            ]
          }
        }
      },
      spatialMoleculesLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/moleculesLayer" }
            ]
          }
        }
      },
      heatmapZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      cellFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cells will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      cellHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      cellSetSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto cell set initialization is enabled, cell set selections will be automatically initialized."
              },
              { type: "array" }
            ]
          }
        }
      },
      cellSetHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell sets will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      cellSetColor: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, cell set colors will be automatically initialized."
              },
              {
                type: "array",
                items: {
                  type: "object",
                  additionalProperties: false,
                  required: ["path", "color"],
                  properties: {
                    path: {
                      type: "array",
                      items: { type: "string" }
                    },
                    color: {
                      type: "array",
                      items: { type: "number" }
                    }
                  }
                }
              }
            ]
          }
        }
      },
      cellColorEncoding: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["geneSelection", "cellSetSelection"],
            description: "How should data points representing cells be colored?"
          }
        }
      },
      geneFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      geneHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      geneSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      geneExpressionTransform: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "string", pattern: "log1p" }
            ]
          }
        }
      },
      geneExpressionColormap: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      geneExpressionColormapRange: {
        type: "object",
        patternProperties: {
          ".": { type: "array", items: { type: "number" } }
        }
      },
      genomicZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      additionalCellSets: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              {
                $ref: "https://github.com/vitessce/vitessce/#cell-sets"
              }
            ]
          }
        }
      },
      moleculeHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no molecule will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      }
    }
  },
  layout: { $ref: "#/definitions/components" },
  initStrategy: {
    type: "string",
    enum: ["none", "auto"],
    description: "The initialization strategy determines how missing coordination objects and coordination scope mappings are initially filled in."
  },
  version: {
    type: "string",
    enum: ["1.0.4"],
    description: "The schema version for the view config."
  }
};
var config_1_0_4_schema_default = {
  $schema: $schema11,
  $id: $id11,
  title: title11,
  type: type11,
  definitions: definitions11,
  additionalProperties: additionalProperties7,
  required: required7,
  properties: properties7
};

// src/schemas/config-1.0.5.schema.json
var $schema12 = "http://json-schema.org/draft-07/schema#";
var $id12 = "https://github.com/vitessce/vitessce/#dataset";
var title12 = "Vitessce data set";
var type12 = "object";
var definitions12 = {
  components: {
    description: "The layout array defines the views, or components, rendered in the grid.",
    type: "array",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["component", "x", "y"],
      properties: {
        component: {
          type: "string",
          description: "Specify a component using a name defined in the component registry."
        },
        props: {
          type: "object",
          description: "Extra prop values for the component."
        },
        x: { type: "integer" },
        y: { type: "integer" },
        w: { type: "integer" },
        h: { type: "integer" },
        coordinationScopes: {
          type: "object",
          description: "Component-level coordination scope mappings define which coordination object values a particular component can read and write, for each coordination type.",
          additionalProperties: false,
          required: [],
          properties: {
            dataset: { type: "string" },
            embeddingType: { type: "string" },
            embeddingZoom: { type: "string" },
            embeddingRotation: { type: "string" },
            embeddingTargetX: { type: "string" },
            embeddingTargetY: { type: "string" },
            embeddingTargetZ: { type: "string" },
            embeddingCellSetPolygonsVisible: { type: "string" },
            embeddingCellSetLabelsVisible: { type: "string" },
            embeddingCellSetLabelSize: { type: "string" },
            embeddingCellRadius: { type: "string" },
            embeddingCellOpacity: { type: "string" },
            embeddingCellRadiusMode: { type: "string" },
            embeddingCellOpacityMode: { type: "string" },
            spatialZoom: { type: "string" },
            spatialRotation: { type: "string" },
            spatialTargetX: { type: "string" },
            spatialTargetY: { type: "string" },
            spatialTargetZ: { type: "string" },
            spatialRotationX: { type: "string" },
            spatialRotationY: { type: "string" },
            spatialRotationZ: { type: "string" },
            spatialRotationOrbit: { type: "string" },
            spatialOrbitAxis: { type: "string" },
            spatialAxisFixed: { type: "string" },
            heatmapZoomX: { type: "string" },
            heatmapZoomY: { type: "string" },
            heatmapTargetX: { type: "string" },
            heatmapTargetY: { type: "string" },
            cellFilter: { type: "string" },
            cellHighlight: { type: "string" },
            cellSetSelection: { type: "string" },
            cellSetHighlight: { type: "string" },
            cellSetColor: { type: "string" },
            geneFilter: { type: "string" },
            geneHighlight: { type: "string" },
            geneSelection: { type: "string" },
            geneExpressionTransform: { type: "string" },
            geneExpressionColormap: { type: "string" },
            geneExpressionColormapRange: { type: "string" },
            cellColorEncoding: { type: "string" },
            spatialRasterLayers: { type: "string" },
            spatialCellsLayer: { type: "string" },
            spatialMoleculesLayer: { type: "string" },
            spatialNeighborhoodsLayer: { type: "string" },
            genomicZoomX: { type: "string" },
            genomicZoomY: { type: "string" },
            genomicTargetX: { type: "string" },
            genomicTargetY: { type: "string" },
            additionalCellSets: { type: "string" },
            moleculeHighlight: { type: "string" }
          }
        }
      }
    }
  },
  annDataCellSets: {
    type: "array",
    description: "Array of cell set configuration, following closely the conventions of the tabular schema",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["groupName", "setName"],
      properties: {
        groupName: {
          type: "string",
          description: "The display name for the set, like 'Cell Type' or 'Louvain.'"
        },
        setName: {
          oneOf: [
            {
              type: "string",
              description: "The location in the AnnData store for the set, like 'obs/louvain' or 'obs/celltype.'"
            },
            {
              type: "array",
              items: { type: "string" },
              description: "An array of locations in the AnnData store for a hierarchy of set names, from coarse to fine levels."
            }
          ]
        }
      }
    }
  },
  annDataCells: {
    type: "object",
    description: "The properties of this object are the configuration for how to layout scatterplots and spatial information",
    minProperties: 1,
    additionalProperties: false,
    required: [],
    properties: {
      xy: {
        type: "string",
        description: "The location in the AnnData store of cell centroids, like 'obsm/X_centroids.'"
      },
      poly: {
        type: "string",
        description: "The location in the AnnData store of cell polygon outlines, like 'obsm/X_polygons.'"
      },
      factors: {
        type: "array",
        description: "List of locations in the AnnData store of cell sets, like 'obs/louvain'",
        items: {
          type: "string"
        }
      },
      mappings: {
        patternProperties: {
          ".": {
            type: "object",
            description: "An object containing key-values for mappings like { UMAP: { key: 'obsm/X_umap', dims: [0, 1] } }.",
            additionalProperties: false,
            required: ["key"],
            properties: {
              key: {
                type: "string",
                description: "Where to look in the AnnData store for this mapping, like 'obsm/X_umap.'"
              },
              dims: {
                type: "array",
                description: "Which indices of the obsm object to take for a scatterplot, allowing for, for example, different PCs from obsm/X_pca",
                minItems: 2,
                maxItems: 2,
                items: { type: "number" }
              }
            }
          }
        }
      }
    }
  },
  annDataExpressionMatrix: {
    type: "object",
    description: "The properties of this object are the configuration for how to fetch the cell x genes matrix",
    additionalProperties: false,
    required: ["matrix"],
    properties: {
      matrix: {
        type: "string",
        description: "The location in the AnnData store of the cell x gene matrix, like 'obsm/hvg_subset.' or 'X'"
      },
      geneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the genes if using a subset of the data, like 'var.highly_variable.' if the matrix comes from 'obsm/hvg_subset.'"
      },
      matrixGeneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the matrix data (used in heatmap and histogram), like 'var.highly_variable.''"
      }
    }
  },
  requestInit: {
    type: "object",
    description: "The properties of this object correspond to the parameters of the JavaScript fetch() function.",
    additionalProperties: false,
    required: [],
    properties: {
      method: {
        type: "string"
      },
      headers: {
        type: "object"
      },
      body: {
        type: "string"
      },
      mode: {
        type: "string"
      },
      credentials: {
        type: "string"
      },
      cache: {
        type: "string"
      },
      redirect: {
        type: "string"
      },
      referrer: {
        type: "string"
      },
      integrity: {
        type: "string"
      }
    }
  },
  rasterLayer: {
    description: "The properties of this object are the rendering settings for the raster layer.",
    additionalProperties: false,
    required: ["channels", "colormap", "index", "opacity"],
    properties: {
      channels: {
        type: "array",
        items: {
          type: "object",
          additionalProperties: false,
          required: ["selection"],
          properties: {
            color: {
              type: "array",
              items: { type: "number" },
              description: "The color to use when rendering this channel under the null colormap."
            },
            selection: {
              type: "object",
              description: "Determines the channel selection, e.g. some Z and time slice."
            },
            slider: {
              type: "array",
              items: { type: "number" },
              description: "Determines the range for color mapping."
            },
            visible: {
              type: "boolean",
              description: "Determines whether this channel of the layer will be rendered in the spatial component."
            }
          }
        }
      },
      colormap: {
        oneOf: [
          {
            type: "string",
            description: "The name of the colormap to use for this layer."
          },
          {
            type: "null",
            description: "Use the solid color definitions."
          }
        ]
      },
      transparentColor: {
        oneOf: [
          {
            type: "array",
            minItems: 3,
            maxItems: 3,
            items: {
              type: "number",
              description: "One of R G or B (0 - 255)."
            },
            description: "Determines the color to be set to opacity 0"
          },
          {
            type: "null",
            description: "No selection."
          }
        ]
      },
      index: {
        type: "number",
        description: "The index of the layer among the array of layers available in the image file."
      },
      opacity: {
        type: "number"
      },
      modelMatrix: {
        oneOf: [
          {
            type: "array",
            minItems: 16,
            maxItems: 16,
            description: "transformation matrix for this layer"
          },
          {
            type: "null",
            description: "Use no transformation."
          }
        ]
      },
      domainType: {
        type: "string",
        enum: ["Full", "Min/Max"],
        description: "Determines the extent of the channel slider input element in the layer controller."
      },
      resolution: {
        type: "number",
        description: "Resolution of 3D volumetric rendering"
      },
      xSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      renderingMode: {
        type: "string",
        description: "Rendering mode of 3D volumetric rendering"
      },
      ySlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      zSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      type: {
        type: "string",
        enum: ["raster", "bitmask"]
      },
      use3d: {
        type: "boolean"
      },
      visible: {
        type: "boolean",
        description: "Determines whether this entire layer will be rendered in the spatial component."
      }
    }
  },
  moleculesLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the molecules layer.",
    additionalProperties: false,
    required: ["visible", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  cellsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the cells layer.",
    additionalProperties: false,
    required: ["visible", "stroked", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      stroked: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  neighborhoodsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the neighborhoods layer.",
    additionalProperties: false,
    required: ["visible"],
    properties: {
      visible: {
        type: "boolean"
      }
    }
  },
  spatialRasterLayers: {
    type: "array",
    description: "Array of Spatial Layers",
    items: {
      $ref: "#/definitions/rasterLayer"
    }
  }
};
var additionalProperties8 = false;
var required8 = ["version", "name", "datasets", "layout", "initStrategy"];
var properties8 = {
  name: { type: "string" },
  public: { type: "boolean" },
  description: { type: "string" },
  datasets: {
    type: "array",
    description: "The datasets array defines groups of files, where the files within each dataset reference the same entities (cells, genes, cell sets, etc).",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["uid", "files"],
      properties: {
        uid: { type: "string" },
        name: { type: "string" },
        description: { type: "string" },
        files: {
          type: "array",
          items: {
            type: "object",
            additionalProperties: false,
            required: ["type", "fileType"],
            properties: {
              name: { type: "string" },
              type: { type: "string" },
              fileType: { type: "string" },
              url: { type: "string" },
              options: { oneOf: [{ $ref: "#/definitions/annDataCellSets" }, { $ref: "https://github.com/vitessce/vitessce/#raster" }, { $ref: "#/definitions/annDataCells" }, { $ref: "#/definitions/annDataExpressionMatrix" }] },
              requestInit: { $ref: "#/definitions/requestInit" }
            }
          }
        }
      }
    }
  },
  coordinationSpace: {
    type: "object",
    description: "The coordination space stores the values for each scope of each coordination object.",
    additionalProperties: false,
    required: [],
    properties: {
      dataset: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetZ: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingType: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingCellSetPolygonsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingCellSetLabelsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingCellSetLabelSize: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingCellRadius: {
        type: "object",
        patternProperties: {
          ".": {
            type: "number",
            description: "The cell radius value, used when embeddingCellRadiusMode is absolute or relative."
          }
        }
      },
      embeddingCellOpacity: {
        type: "object",
        patternProperties: {
          ".": {
            type: "number",
            description: "The cell opacity value, used when embeddingCellOpacityMode is static."
          }
        }
      },
      embeddingCellRadiusMode: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["manual", "auto"],
            description: "Should data points representing cells be assigned a static (manual) or dynamic (auto, based on zoom level and data extent) radius?"
          }
        }
      },
      embeddingCellOpacityMode: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["manual", "auto"],
            description: "Should data points representing cells be assigned a static (manual) or dynamic (auto, based on zoom level and data extent) opacity?"
          }
        }
      },
      spatialZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      spatialTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationOrbit: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialOrbitAxis: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "string" }
            ]
          }
        }
      },
      spatialAxisFixed: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "Whether or not to have a fixed axis for the camera. Only useful for 3D viewing."
              },
              { type: "boolean" }
            ]
          }
        }
      },
      spatialRasterLayers: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/spatialRasterLayers" }
            ]
          }
        }
      },
      spatialCellsLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/cellsLayer" }
            ]
          }
        }
      },
      spatialNeighborhoodsLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/neighborhoodsLayer" }
            ]
          }
        }
      },
      spatialMoleculesLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/moleculesLayer" }
            ]
          }
        }
      },
      heatmapZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      cellFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cells will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      cellHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      cellSetSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto cell set initialization is enabled, cell set selections will be automatically initialized."
              },
              { type: "array" }
            ]
          }
        }
      },
      cellSetHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell sets will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      cellSetColor: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, cell set colors will be automatically initialized."
              },
              {
                type: "array",
                items: {
                  type: "object",
                  additionalProperties: false,
                  required: ["path", "color"],
                  properties: {
                    path: {
                      type: "array",
                      items: { type: "string" }
                    },
                    color: {
                      type: "array",
                      items: { type: "number" }
                    }
                  }
                }
              }
            ]
          }
        }
      },
      cellColorEncoding: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["geneSelection", "cellSetSelection"],
            description: "How should data points representing cells be colored?"
          }
        }
      },
      geneFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      geneHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      geneSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      geneExpressionTransform: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "string", pattern: "log1p" }
            ]
          }
        }
      },
      geneExpressionColormap: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      geneExpressionColormapRange: {
        type: "object",
        patternProperties: {
          ".": { type: "array", items: { type: "number" } }
        }
      },
      genomicZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      additionalCellSets: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              {
                $ref: "https://github.com/vitessce/vitessce/#cell-sets"
              }
            ]
          }
        }
      },
      moleculeHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no molecule will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      }
    }
  },
  layout: { $ref: "#/definitions/components" },
  initStrategy: {
    type: "string",
    enum: ["none", "auto"],
    description: "The initialization strategy determines how missing coordination objects and coordination scope mappings are initially filled in."
  },
  version: {
    type: "string",
    enum: ["1.0.5"],
    description: "The schema version for the view config."
  }
};
var config_1_0_5_schema_default = {
  $schema: $schema12,
  $id: $id12,
  title: title12,
  type: type12,
  definitions: definitions12,
  additionalProperties: additionalProperties8,
  required: required8,
  properties: properties8
};

// src/schemas/config-1.0.6.schema.json
var $schema13 = "http://json-schema.org/draft-07/schema#";
var $id13 = "https://github.com/vitessce/vitessce/#dataset";
var title13 = "Vitessce data set";
var type13 = "object";
var definitions13 = {
  components: {
    description: "The layout array defines the views, or components, rendered in the grid.",
    type: "array",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["component", "x", "y"],
      properties: {
        component: {
          type: "string",
          description: "Specify a component using a name defined in the component registry."
        },
        props: {
          type: "object",
          description: "Extra prop values for the component."
        },
        x: { type: "integer" },
        y: { type: "integer" },
        w: { type: "integer" },
        h: { type: "integer" },
        coordinationScopes: {
          type: "object",
          description: "Component-level coordination scope mappings define which coordination object values a particular component can read and write, for each coordination type.",
          additionalProperties: false,
          required: [],
          properties: {
            dataset: { type: "string" },
            embeddingType: { type: "string" },
            embeddingZoom: { type: "string" },
            embeddingRotation: { type: "string" },
            embeddingTargetX: { type: "string" },
            embeddingTargetY: { type: "string" },
            embeddingTargetZ: { type: "string" },
            embeddingCellSetPolygonsVisible: { type: "string" },
            embeddingCellSetLabelsVisible: { type: "string" },
            embeddingCellSetLabelSize: { type: "string" },
            embeddingCellRadius: { type: "string" },
            embeddingCellOpacity: { type: "string" },
            embeddingCellRadiusMode: { type: "string" },
            embeddingCellOpacityMode: { type: "string" },
            spatialZoom: { type: "string" },
            spatialRotation: { type: "string" },
            spatialTargetX: { type: "string" },
            spatialTargetY: { type: "string" },
            spatialTargetZ: { type: "string" },
            spatialRotationX: { type: "string" },
            spatialRotationY: { type: "string" },
            spatialRotationZ: { type: "string" },
            spatialRotationOrbit: { type: "string" },
            spatialOrbitAxis: { type: "string" },
            spatialAxisFixed: { type: "string" },
            heatmapZoomX: { type: "string" },
            heatmapZoomY: { type: "string" },
            heatmapTargetX: { type: "string" },
            heatmapTargetY: { type: "string" },
            cellFilter: { type: "string" },
            cellHighlight: { type: "string" },
            cellSetSelection: { type: "string" },
            cellSetHighlight: { type: "string" },
            cellSetColor: { type: "string" },
            geneFilter: { type: "string" },
            geneHighlight: { type: "string" },
            geneSelection: { type: "string" },
            geneExpressionTransform: { type: "string" },
            geneExpressionColormap: { type: "string" },
            geneExpressionColormapRange: { type: "string" },
            cellColorEncoding: { type: "string" },
            spatialRasterLayers: { type: "string" },
            spatialCellsLayer: { type: "string" },
            spatialMoleculesLayer: { type: "string" },
            spatialNeighborhoodsLayer: { type: "string" },
            genomicZoomX: { type: "string" },
            genomicZoomY: { type: "string" },
            genomicTargetX: { type: "string" },
            genomicTargetY: { type: "string" },
            additionalCellSets: { type: "string" },
            moleculeHighlight: { type: "string" }
          }
        }
      }
    }
  },
  annDataCellSets: {
    type: "array",
    description: "Array of cell set configuration, following closely the conventions of the tabular schema",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["groupName", "setName"],
      properties: {
        groupName: {
          type: "string",
          description: "The display name for the set, like 'Cell Type' or 'Louvain.'"
        },
        setName: {
          oneOf: [
            {
              type: "string",
              description: "The location in the AnnData store for the set, like 'obs/louvain' or 'obs/celltype.'"
            },
            {
              type: "array",
              items: { type: "string" },
              description: "An array of locations in the AnnData store for a hierarchy of set names, from coarse to fine levels."
            }
          ]
        },
        scoreName: {
          oneOf: [
            {
              type: "string",
              description: "The location in the AnnData store for the set confidence scores, like 'obs/celltype_prediction_score.'"
            }
          ]
        }
      }
    }
  },
  annDataCells: {
    type: "object",
    description: "The properties of this object are the configuration for how to layout scatterplots and spatial information",
    minProperties: 1,
    additionalProperties: false,
    required: [],
    properties: {
      xy: {
        type: "string",
        description: "The location in the AnnData store of cell centroids, like 'obsm/X_centroids.'"
      },
      poly: {
        type: "string",
        description: "The location in the AnnData store of cell polygon outlines, like 'obsm/X_polygons.'"
      },
      factors: {
        type: "array",
        description: "List of locations in the AnnData store of cell sets, like 'obs/louvain'",
        items: {
          type: "string"
        }
      },
      mappings: {
        patternProperties: {
          ".": {
            type: "object",
            description: "An object containing key-values for mappings like { UMAP: { key: 'obsm/X_umap', dims: [0, 1] } }.",
            additionalProperties: false,
            required: ["key"],
            properties: {
              key: {
                type: "string",
                description: "Where to look in the AnnData store for this mapping, like 'obsm/X_umap.'"
              },
              dims: {
                type: "array",
                description: "Which indices of the obsm object to take for a scatterplot, allowing for, for example, different PCs from obsm/X_pca",
                minItems: 2,
                maxItems: 2,
                items: { type: "number" }
              }
            }
          }
        }
      }
    }
  },
  annDataExpressionMatrix: {
    type: "object",
    description: "The properties of this object are the configuration for how to fetch the cell x genes matrix",
    additionalProperties: false,
    required: ["matrix"],
    properties: {
      matrix: {
        type: "string",
        description: "The location in the AnnData store of the cell x gene matrix, like 'obsm/hvg_subset.' or 'X'"
      },
      geneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the genes if using a subset of the data, like 'var.highly_variable.' if the matrix comes from 'obsm/hvg_subset.'"
      },
      matrixGeneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the matrix data (used in heatmap and histogram), like 'var.highly_variable.''"
      }
    }
  },
  requestInit: {
    type: "object",
    description: "The properties of this object correspond to the parameters of the JavaScript fetch() function.",
    additionalProperties: false,
    required: [],
    properties: {
      method: {
        type: "string"
      },
      headers: {
        type: "object"
      },
      body: {
        type: "string"
      },
      mode: {
        type: "string"
      },
      credentials: {
        type: "string"
      },
      cache: {
        type: "string"
      },
      redirect: {
        type: "string"
      },
      referrer: {
        type: "string"
      },
      integrity: {
        type: "string"
      }
    }
  },
  rasterLayer: {
    description: "The properties of this object are the rendering settings for the raster layer.",
    additionalProperties: false,
    required: ["channels", "colormap", "index", "opacity"],
    properties: {
      channels: {
        type: "array",
        items: {
          type: "object",
          additionalProperties: false,
          required: ["selection"],
          properties: {
            color: {
              type: "array",
              items: { type: "number" },
              description: "The color to use when rendering this channel under the null colormap."
            },
            selection: {
              type: "object",
              description: "Determines the channel selection, e.g. some Z and time slice."
            },
            slider: {
              type: "array",
              items: { type: "number" },
              description: "Determines the range for color mapping."
            },
            visible: {
              type: "boolean",
              description: "Determines whether this channel of the layer will be rendered in the spatial component."
            }
          }
        }
      },
      colormap: {
        oneOf: [
          {
            type: "string",
            description: "The name of the colormap to use for this layer."
          },
          {
            type: "null",
            description: "Use the solid color definitions."
          }
        ]
      },
      transparentColor: {
        oneOf: [
          {
            type: "array",
            minItems: 3,
            maxItems: 3,
            items: {
              type: "number",
              description: "One of R G or B (0 - 255)."
            },
            description: "Determines the color to be set to opacity 0"
          },
          {
            type: "null",
            description: "No selection."
          }
        ]
      },
      index: {
        type: "number",
        description: "The index of the layer among the array of layers available in the image file."
      },
      opacity: {
        type: "number"
      },
      modelMatrix: {
        oneOf: [
          {
            type: "array",
            minItems: 16,
            maxItems: 16,
            description: "transformation matrix for this layer"
          },
          {
            type: "null",
            description: "Use no transformation."
          }
        ]
      },
      domainType: {
        type: "string",
        enum: ["Full", "Min/Max"],
        description: "Determines the extent of the channel slider input element in the layer controller."
      },
      resolution: {
        type: "number",
        description: "Resolution of 3D volumetric rendering"
      },
      xSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      renderingMode: {
        type: "string",
        description: "Rendering mode of 3D volumetric rendering"
      },
      ySlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      zSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      type: {
        type: "string",
        enum: ["raster", "bitmask"]
      },
      use3d: {
        type: "boolean"
      },
      visible: {
        type: "boolean",
        description: "Determines whether this entire layer will be rendered in the spatial component."
      }
    }
  },
  moleculesLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the molecules layer.",
    additionalProperties: false,
    required: ["visible", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  cellsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the cells layer.",
    additionalProperties: false,
    required: ["visible", "stroked", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      stroked: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  neighborhoodsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the neighborhoods layer.",
    additionalProperties: false,
    required: ["visible"],
    properties: {
      visible: {
        type: "boolean"
      }
    }
  },
  spatialRasterLayers: {
    type: "array",
    description: "Array of Spatial Layers",
    items: {
      $ref: "#/definitions/rasterLayer"
    }
  }
};
var additionalProperties9 = false;
var required9 = ["version", "name", "datasets", "layout", "initStrategy"];
var properties9 = {
  name: { type: "string" },
  public: { type: "boolean" },
  description: { type: "string" },
  datasets: {
    type: "array",
    description: "The datasets array defines groups of files, where the files within each dataset reference the same entities (cells, genes, cell sets, etc).",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["uid", "files"],
      properties: {
        uid: { type: "string" },
        name: { type: "string" },
        description: { type: "string" },
        files: {
          type: "array",
          items: {
            type: "object",
            additionalProperties: false,
            required: ["type", "fileType"],
            properties: {
              name: { type: "string" },
              type: { type: "string" },
              fileType: { type: "string" },
              url: { type: "string" },
              options: { oneOf: [{ $ref: "#/definitions/annDataCellSets" }, { $ref: "https://github.com/vitessce/vitessce/#raster" }, { $ref: "#/definitions/annDataCells" }, { $ref: "#/definitions/annDataExpressionMatrix" }] },
              requestInit: { $ref: "#/definitions/requestInit" }
            }
          }
        }
      }
    }
  },
  coordinationSpace: {
    type: "object",
    description: "The coordination space stores the values for each scope of each coordination object.",
    additionalProperties: false,
    required: [],
    properties: {
      dataset: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetZ: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingType: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingCellSetPolygonsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingCellSetLabelsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingCellSetLabelSize: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingCellRadius: {
        type: "object",
        patternProperties: {
          ".": {
            type: "number",
            description: "The cell radius value, used when embeddingCellRadiusMode is absolute or relative."
          }
        }
      },
      embeddingCellOpacity: {
        type: "object",
        patternProperties: {
          ".": {
            type: "number",
            description: "The cell opacity value, used when embeddingCellOpacityMode is static."
          }
        }
      },
      embeddingCellRadiusMode: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["manual", "auto"],
            description: "Should data points representing cells be assigned a static (manual) or dynamic (auto, based on zoom level and data extent) radius?"
          }
        }
      },
      embeddingCellOpacityMode: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["manual", "auto"],
            description: "Should data points representing cells be assigned a static (manual) or dynamic (auto, based on zoom level and data extent) opacity?"
          }
        }
      },
      spatialZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      spatialTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationOrbit: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialOrbitAxis: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "string" }
            ]
          }
        }
      },
      spatialAxisFixed: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "Whether or not to have a fixed axis for the camera. Only useful for 3D viewing."
              },
              { type: "boolean" }
            ]
          }
        }
      },
      spatialRasterLayers: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/spatialRasterLayers" }
            ]
          }
        }
      },
      spatialCellsLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/cellsLayer" }
            ]
          }
        }
      },
      spatialNeighborhoodsLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/neighborhoodsLayer" }
            ]
          }
        }
      },
      spatialMoleculesLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/moleculesLayer" }
            ]
          }
        }
      },
      heatmapZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      cellFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cells will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      cellHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      cellSetSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto cell set initialization is enabled, cell set selections will be automatically initialized."
              },
              { type: "array" }
            ]
          }
        }
      },
      cellSetHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell sets will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      cellSetColor: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, cell set colors will be automatically initialized."
              },
              {
                type: "array",
                items: {
                  type: "object",
                  additionalProperties: false,
                  required: ["path", "color"],
                  properties: {
                    path: {
                      type: "array",
                      items: { type: "string" }
                    },
                    color: {
                      type: "array",
                      items: { type: "number" }
                    }
                  }
                }
              }
            ]
          }
        }
      },
      cellColorEncoding: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["geneSelection", "cellSetSelection"],
            description: "How should data points representing cells be colored?"
          }
        }
      },
      geneFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      geneHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      geneSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      geneExpressionTransform: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "string", pattern: "log1p" }
            ]
          }
        }
      },
      geneExpressionColormap: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      geneExpressionColormapRange: {
        type: "object",
        patternProperties: {
          ".": { type: "array", items: { type: "number" } }
        }
      },
      genomicZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      additionalCellSets: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              {
                $ref: "https://github.com/vitessce/vitessce/#cell-sets"
              }
            ]
          }
        }
      },
      moleculeHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no molecule will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      }
    }
  },
  layout: { $ref: "#/definitions/components" },
  initStrategy: {
    type: "string",
    enum: ["none", "auto"],
    description: "The initialization strategy determines how missing coordination objects and coordination scope mappings are initially filled in."
  },
  version: {
    type: "string",
    enum: ["1.0.6"],
    description: "The schema version for the view config."
  }
};
var config_1_0_6_schema_default = {
  $schema: $schema13,
  $id: $id13,
  title: title13,
  type: type13,
  definitions: definitions13,
  additionalProperties: additionalProperties9,
  required: required9,
  properties: properties9
};

// src/schemas/config-1.0.7.schema.json
var $schema14 = "http://json-schema.org/draft-07/schema#";
var $id14 = "https://github.com/vitessce/vitessce/#dataset";
var title14 = "Vitessce data set";
var type14 = "object";
var definitions14 = {
  components: {
    description: "The layout array defines the views, or components, rendered in the grid.",
    type: "array",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["component", "x", "y"],
      properties: {
        component: {
          type: "string",
          description: "Specify a component using a name defined in the component registry."
        },
        props: {
          type: "object",
          description: "Extra prop values for the component."
        },
        x: { type: "integer" },
        y: { type: "integer" },
        w: { type: "integer" },
        h: { type: "integer" },
        coordinationScopes: {
          type: "object",
          description: "Component-level coordination scope mappings define which coordination object values a particular component can read and write, for each coordination type.",
          additionalProperties: false,
          required: [],
          properties: {
            dataset: { type: "string" },
            embeddingType: { type: "string" },
            embeddingZoom: { type: "string" },
            embeddingRotation: { type: "string" },
            embeddingTargetX: { type: "string" },
            embeddingTargetY: { type: "string" },
            embeddingTargetZ: { type: "string" },
            embeddingCellSetPolygonsVisible: { type: "string" },
            embeddingCellSetLabelsVisible: { type: "string" },
            embeddingCellSetLabelSize: { type: "string" },
            embeddingCellRadius: { type: "string" },
            embeddingCellOpacity: { type: "string" },
            embeddingCellRadiusMode: { type: "string" },
            embeddingCellOpacityMode: { type: "string" },
            spatialZoom: { type: "string" },
            spatialRotation: { type: "string" },
            spatialTargetX: { type: "string" },
            spatialTargetY: { type: "string" },
            spatialTargetZ: { type: "string" },
            spatialRotationX: { type: "string" },
            spatialRotationY: { type: "string" },
            spatialRotationZ: { type: "string" },
            spatialRotationOrbit: { type: "string" },
            spatialOrbitAxis: { type: "string" },
            spatialAxisFixed: { type: "string" },
            heatmapZoomX: { type: "string" },
            heatmapZoomY: { type: "string" },
            heatmapTargetX: { type: "string" },
            heatmapTargetY: { type: "string" },
            cellFilter: { type: "string" },
            cellHighlight: { type: "string" },
            cellSetSelection: { type: "string" },
            cellSetHighlight: { type: "string" },
            cellSetColor: { type: "string" },
            geneFilter: { type: "string" },
            geneHighlight: { type: "string" },
            geneSelection: { type: "string" },
            geneExpressionTransform: { type: "string" },
            geneExpressionColormap: { type: "string" },
            geneExpressionColormapRange: { type: "string" },
            cellColorEncoding: { type: "string" },
            spatialRasterLayers: { type: "string" },
            spatialCellsLayer: { type: "string" },
            spatialMoleculesLayer: { type: "string" },
            spatialNeighborhoodsLayer: { type: "string" },
            genomicZoomX: { type: "string" },
            genomicZoomY: { type: "string" },
            genomicTargetX: { type: "string" },
            genomicTargetY: { type: "string" },
            additionalCellSets: { type: "string" },
            moleculeHighlight: { type: "string" }
          }
        }
      }
    }
  },
  annDataCellSets: {
    type: "array",
    description: "Array of cell set configuration, following closely the conventions of the tabular schema",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["groupName", "setName"],
      properties: {
        groupName: {
          type: "string",
          description: "The display name for the set, like 'Cell Type' or 'Louvain.'"
        },
        setName: {
          oneOf: [
            {
              type: "string",
              description: "The location in the AnnData store for the set, like 'obs/louvain' or 'obs/celltype.'"
            },
            {
              type: "array",
              items: { type: "string" },
              description: "An array of locations in the AnnData store for a hierarchy of set names, from coarse to fine levels."
            }
          ]
        },
        scoreName: {
          oneOf: [
            {
              type: "string",
              description: "The location in the AnnData store for the set confidence scores, like 'obs/celltype_prediction_score.'"
            }
          ]
        }
      }
    }
  },
  annDataCells: {
    type: "object",
    description: "The properties of this object are the configuration for how to layout scatterplots and spatial information",
    minProperties: 1,
    additionalProperties: false,
    required: [],
    properties: {
      xy: {
        type: "string",
        description: "The location in the AnnData store of cell centroids, like 'obsm/X_centroids.'"
      },
      poly: {
        type: "string",
        description: "The location in the AnnData store of cell polygon outlines, like 'obsm/X_polygons.'"
      },
      factors: {
        type: "array",
        description: "List of locations in the AnnData store of cell sets, like 'obs/louvain'",
        items: {
          type: "string"
        }
      },
      mappings: {
        patternProperties: {
          ".": {
            type: "object",
            description: "An object containing key-values for mappings like { UMAP: { key: 'obsm/X_umap', dims: [0, 1] } }.",
            additionalProperties: false,
            required: ["key"],
            properties: {
              key: {
                type: "string",
                description: "Where to look in the AnnData store for this mapping, like 'obsm/X_umap.'"
              },
              dims: {
                type: "array",
                description: "Which indices of the obsm object to take for a scatterplot, allowing for, for example, different PCs from obsm/X_pca",
                minItems: 2,
                maxItems: 2,
                items: { type: "number" }
              }
            }
          }
        }
      }
    }
  },
  annDataExpressionMatrix: {
    type: "object",
    description: "The properties of this object are the configuration for how to fetch the cell x genes matrix",
    additionalProperties: false,
    required: ["matrix"],
    properties: {
      matrix: {
        type: "string",
        description: "The location in the AnnData store of the cell x gene matrix, like 'obsm/hvg_subset.' or 'X'"
      },
      geneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the genes if using a subset of the data, like 'var.highly_variable.' if the matrix comes from 'obsm/hvg_subset.'"
      },
      matrixGeneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the matrix data (used in heatmap and histogram), like 'var.highly_variable.''"
      },
      geneAlias: {
        type: "string",
        description: "The location in the AnnData store of a different list of names for gene list component, other than the `var` index"
      }
    }
  },
  requestInit: {
    type: "object",
    description: "The properties of this object correspond to the parameters of the JavaScript fetch() function.",
    additionalProperties: false,
    required: [],
    properties: {
      method: {
        type: "string"
      },
      headers: {
        type: "object"
      },
      body: {
        type: "string"
      },
      mode: {
        type: "string"
      },
      credentials: {
        type: "string"
      },
      cache: {
        type: "string"
      },
      redirect: {
        type: "string"
      },
      referrer: {
        type: "string"
      },
      integrity: {
        type: "string"
      }
    }
  },
  rasterLayer: {
    description: "The properties of this object are the rendering settings for the raster layer.",
    additionalProperties: false,
    required: ["channels", "colormap", "index", "opacity"],
    properties: {
      channels: {
        type: "array",
        items: {
          type: "object",
          additionalProperties: false,
          required: ["selection"],
          properties: {
            color: {
              type: "array",
              items: { type: "number" },
              description: "The color to use when rendering this channel under the null colormap."
            },
            selection: {
              type: "object",
              description: "Determines the channel selection, e.g. some Z and time slice."
            },
            slider: {
              type: "array",
              items: { type: "number" },
              description: "Determines the range for color mapping."
            },
            visible: {
              type: "boolean",
              description: "Determines whether this channel of the layer will be rendered in the spatial component."
            }
          }
        }
      },
      colormap: {
        oneOf: [
          {
            type: "string",
            description: "The name of the colormap to use for this layer."
          },
          {
            type: "null",
            description: "Use the solid color definitions."
          }
        ]
      },
      transparentColor: {
        oneOf: [
          {
            type: "array",
            minItems: 3,
            maxItems: 3,
            items: {
              type: "number",
              description: "One of R G or B (0 - 255)."
            },
            description: "Determines the color to be set to opacity 0"
          },
          {
            type: "null",
            description: "No selection."
          }
        ]
      },
      index: {
        type: "number",
        description: "The index of the layer among the array of layers available in the image file."
      },
      opacity: {
        type: "number"
      },
      modelMatrix: {
        oneOf: [
          {
            type: "array",
            minItems: 16,
            maxItems: 16,
            description: "transformation matrix for this layer"
          },
          {
            type: "null",
            description: "Use no transformation."
          }
        ]
      },
      domainType: {
        type: "string",
        enum: ["Full", "Min/Max"],
        description: "Determines the extent of the channel slider input element in the layer controller."
      },
      resolution: {
        type: "number",
        description: "Resolution of 3D volumetric rendering"
      },
      xSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      renderingMode: {
        type: "string",
        description: "Rendering mode of 3D volumetric rendering"
      },
      ySlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      zSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      type: {
        type: "string",
        enum: ["raster", "bitmask"]
      },
      use3d: {
        type: "boolean"
      },
      visible: {
        type: "boolean",
        description: "Determines whether this entire layer will be rendered in the spatial component."
      }
    }
  },
  moleculesLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the molecules layer.",
    additionalProperties: false,
    required: ["visible", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  cellsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the cells layer.",
    additionalProperties: false,
    required: ["visible", "stroked", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      stroked: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  neighborhoodsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the neighborhoods layer.",
    additionalProperties: false,
    required: ["visible"],
    properties: {
      visible: {
        type: "boolean"
      }
    }
  },
  spatialRasterLayers: {
    type: "array",
    description: "Array of Spatial Layers",
    items: {
      $ref: "#/definitions/rasterLayer"
    }
  }
};
var additionalProperties10 = false;
var required10 = ["version", "name", "datasets", "layout", "initStrategy"];
var properties10 = {
  name: { type: "string" },
  public: { type: "boolean" },
  description: { type: "string" },
  datasets: {
    type: "array",
    description: "The datasets array defines groups of files, where the files within each dataset reference the same entities (cells, genes, cell sets, etc).",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["uid", "files"],
      properties: {
        uid: { type: "string" },
        name: { type: "string" },
        description: { type: "string" },
        files: {
          type: "array",
          items: {
            type: "object",
            additionalProperties: false,
            required: ["type", "fileType"],
            properties: {
              name: { type: "string" },
              type: { type: "string" },
              fileType: { type: "string" },
              url: { type: "string" },
              options: { oneOf: [{ $ref: "#/definitions/annDataCellSets" }, { $ref: "https://github.com/vitessce/vitessce/#raster" }, { $ref: "#/definitions/annDataCells" }, { $ref: "#/definitions/annDataExpressionMatrix" }] },
              requestInit: { $ref: "#/definitions/requestInit" }
            }
          }
        }
      }
    }
  },
  coordinationSpace: {
    type: "object",
    description: "The coordination space stores the values for each scope of each coordination object.",
    additionalProperties: false,
    required: [],
    properties: {
      dataset: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetZ: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingType: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingCellSetPolygonsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingCellSetLabelsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingCellSetLabelSize: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingCellRadius: {
        type: "object",
        patternProperties: {
          ".": {
            type: "number",
            description: "The cell radius value, used when embeddingCellRadiusMode is absolute or relative."
          }
        }
      },
      embeddingCellOpacity: {
        type: "object",
        patternProperties: {
          ".": {
            type: "number",
            description: "The cell opacity value, used when embeddingCellOpacityMode is static."
          }
        }
      },
      embeddingCellRadiusMode: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["manual", "auto"],
            description: "Should data points representing cells be assigned a static (manual) or dynamic (auto, based on zoom level and data extent) radius?"
          }
        }
      },
      embeddingCellOpacityMode: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["manual", "auto"],
            description: "Should data points representing cells be assigned a static (manual) or dynamic (auto, based on zoom level and data extent) opacity?"
          }
        }
      },
      spatialZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      spatialTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationOrbit: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialOrbitAxis: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "string" }
            ]
          }
        }
      },
      spatialAxisFixed: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "Whether or not to have a fixed axis for the camera. Only useful for 3D viewing."
              },
              { type: "boolean" }
            ]
          }
        }
      },
      spatialRasterLayers: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/spatialRasterLayers" }
            ]
          }
        }
      },
      spatialCellsLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/cellsLayer" }
            ]
          }
        }
      },
      spatialNeighborhoodsLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/neighborhoodsLayer" }
            ]
          }
        }
      },
      spatialMoleculesLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/moleculesLayer" }
            ]
          }
        }
      },
      heatmapZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      cellFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cells will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      cellHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      cellSetSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto cell set initialization is enabled, cell set selections will be automatically initialized."
              },
              { type: "array" }
            ]
          }
        }
      },
      cellSetHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell sets will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      cellSetColor: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, cell set colors will be automatically initialized."
              },
              {
                type: "array",
                items: {
                  type: "object",
                  additionalProperties: false,
                  required: ["path", "color"],
                  properties: {
                    path: {
                      type: "array",
                      items: { type: "string" }
                    },
                    color: {
                      type: "array",
                      items: { type: "number" }
                    }
                  }
                }
              }
            ]
          }
        }
      },
      cellColorEncoding: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["geneSelection", "cellSetSelection"],
            description: "How should data points representing cells be colored?"
          }
        }
      },
      geneFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      geneHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      geneSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      geneExpressionTransform: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "string", pattern: "log1p" }
            ]
          }
        }
      },
      geneExpressionColormap: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      geneExpressionColormapRange: {
        type: "object",
        patternProperties: {
          ".": { type: "array", items: { type: "number" } }
        }
      },
      genomicZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      additionalCellSets: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              {
                $ref: "https://github.com/vitessce/vitessce/#cell-sets"
              }
            ]
          }
        }
      },
      moleculeHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no molecule will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      }
    }
  },
  layout: { $ref: "#/definitions/components" },
  initStrategy: {
    type: "string",
    enum: ["none", "auto"],
    description: "The initialization strategy determines how missing coordination objects and coordination scope mappings are initially filled in."
  },
  version: {
    type: "string",
    enum: ["1.0.7"],
    description: "The schema version for the view config."
  }
};
var config_1_0_7_schema_default = {
  $schema: $schema14,
  $id: $id14,
  title: title14,
  type: type14,
  definitions: definitions14,
  additionalProperties: additionalProperties10,
  required: required10,
  properties: properties10
};

// src/schemas/config-1.0.8.schema.json
var $schema15 = "http://json-schema.org/draft-07/schema#";
var $id15 = "https://github.com/vitessce/vitessce/#dataset";
var title15 = "Vitessce data set";
var type15 = "object";
var definitions15 = {
  componentCoordinationScopeValue: {
    oneOf: [
      { type: "string" },
      {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      }
    ]
  },
  components: {
    description: "The layout array defines the views, or components, rendered in the grid.",
    type: "array",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["component", "x", "y"],
      properties: {
        component: {
          type: "string",
          description: "Specify a component using a name defined in the component registry."
        },
        props: {
          type: "object",
          description: "Extra prop values for the component."
        },
        x: { type: "integer" },
        y: { type: "integer" },
        w: { type: "integer" },
        h: { type: "integer" },
        coordinationScopes: {
          type: "object",
          description: "Component-level coordination scope mappings define which coordination object values a particular component can read and write, for each coordination type.",
          additionalProperties: false,
          required: [],
          properties: {
            dataset: {
              oneOf: [
                { type: "string" },
                { type: "array", items: { type: "string" } }
              ]
            },
            embeddingType: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingZoom: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingRotation: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingTargetX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingTargetY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingTargetZ: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingCellSetPolygonsVisible: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingCellSetLabelsVisible: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingCellSetLabelSize: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingCellRadius: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingCellOpacity: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingCellRadiusMode: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingCellOpacityMode: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialZoom: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRotation: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialTargetX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialTargetY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialTargetZ: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRotationX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRotationY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRotationZ: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRotationOrbit: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialOrbitAxis: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialAxisFixed: { $ref: "#/definitions/componentCoordinationScopeValue" },
            heatmapZoomX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            heatmapZoomY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            heatmapTargetX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            heatmapTargetY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            cellFilter: { $ref: "#/definitions/componentCoordinationScopeValue" },
            cellHighlight: { $ref: "#/definitions/componentCoordinationScopeValue" },
            cellSetSelection: { $ref: "#/definitions/componentCoordinationScopeValue" },
            cellSetHighlight: { $ref: "#/definitions/componentCoordinationScopeValue" },
            cellSetColor: { $ref: "#/definitions/componentCoordinationScopeValue" },
            geneFilter: { $ref: "#/definitions/componentCoordinationScopeValue" },
            geneHighlight: { $ref: "#/definitions/componentCoordinationScopeValue" },
            geneSelection: { $ref: "#/definitions/componentCoordinationScopeValue" },
            geneExpressionTransform: { $ref: "#/definitions/componentCoordinationScopeValue" },
            geneExpressionColormap: { $ref: "#/definitions/componentCoordinationScopeValue" },
            geneExpressionColormapRange: { $ref: "#/definitions/componentCoordinationScopeValue" },
            cellColorEncoding: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRasterLayers: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialCellsLayer: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialMoleculesLayer: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialNeighborhoodsLayer: { $ref: "#/definitions/componentCoordinationScopeValue" },
            genomicZoomX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            genomicZoomY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            genomicTargetX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            genomicTargetY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            additionalCellSets: { $ref: "#/definitions/componentCoordinationScopeValue" },
            moleculeHighlight: { $ref: "#/definitions/componentCoordinationScopeValue" }
          }
        }
      }
    }
  },
  annDataCellSets: {
    type: "array",
    description: "Array of cell set configuration, following closely the conventions of the tabular schema",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["groupName", "setName"],
      properties: {
        groupName: {
          type: "string",
          description: "The display name for the set, like 'Cell Type' or 'Louvain.'"
        },
        setName: {
          oneOf: [
            {
              type: "string",
              description: "The location in the AnnData store for the set, like 'obs/louvain' or 'obs/celltype.'"
            },
            {
              type: "array",
              items: { type: "string" },
              description: "An array of locations in the AnnData store for a hierarchy of set names, from coarse to fine levels."
            }
          ]
        },
        scoreName: {
          oneOf: [
            {
              type: "string",
              description: "The location in the AnnData store for the set confidence scores, like 'obs/celltype_prediction_score.'"
            }
          ]
        }
      }
    }
  },
  annDataCells: {
    type: "object",
    description: "The properties of this object are the configuration for how to layout scatterplots and spatial information",
    minProperties: 1,
    additionalProperties: false,
    required: [],
    properties: {
      xy: {
        type: "string",
        description: "The location in the AnnData store of cell centroids, like 'obsm/X_centroids.'"
      },
      poly: {
        type: "string",
        description: "The location in the AnnData store of cell polygon outlines, like 'obsm/X_polygons.'"
      },
      factors: {
        type: "array",
        description: "List of locations in the AnnData store of cell sets, like 'obs/louvain'",
        items: {
          type: "string"
        }
      },
      mappings: {
        patternProperties: {
          ".": {
            type: "object",
            description: "An object containing key-values for mappings like { UMAP: { key: 'obsm/X_umap', dims: [0, 1] } }.",
            additionalProperties: false,
            required: ["key"],
            properties: {
              key: {
                type: "string",
                description: "Where to look in the AnnData store for this mapping, like 'obsm/X_umap.'"
              },
              dims: {
                type: "array",
                description: "Which indices of the obsm object to take for a scatterplot, allowing for, for example, different PCs from obsm/X_pca",
                minItems: 2,
                maxItems: 2,
                items: { type: "number" }
              }
            }
          }
        }
      }
    }
  },
  annDataExpressionMatrix: {
    type: "object",
    description: "The properties of this object are the configuration for how to fetch the cell x genes matrix",
    additionalProperties: false,
    required: ["matrix"],
    properties: {
      matrix: {
        type: "string",
        description: "The location in the AnnData store of the cell x gene matrix, like 'obsm/hvg_subset.' or 'X'"
      },
      geneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the genes if using a subset of the data, like 'var.highly_variable.' if the matrix comes from 'obsm/hvg_subset.'"
      },
      matrixGeneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the matrix data (used in heatmap and histogram), like 'var.highly_variable.''"
      },
      geneAlias: {
        type: "string",
        description: "The location in the AnnData store of a different list of names for gene list component, other than the `var` index"
      }
    }
  },
  requestInit: {
    type: "object",
    description: "The properties of this object correspond to the parameters of the JavaScript fetch() function.",
    additionalProperties: false,
    required: [],
    properties: {
      method: {
        type: "string"
      },
      headers: {
        type: "object"
      },
      body: {
        type: "string"
      },
      mode: {
        type: "string"
      },
      credentials: {
        type: "string"
      },
      cache: {
        type: "string"
      },
      redirect: {
        type: "string"
      },
      referrer: {
        type: "string"
      },
      integrity: {
        type: "string"
      }
    }
  },
  rasterLayer: {
    description: "The properties of this object are the rendering settings for the raster layer.",
    additionalProperties: false,
    required: ["channels", "colormap", "index", "opacity"],
    properties: {
      channels: {
        type: "array",
        items: {
          type: "object",
          additionalProperties: false,
          required: ["selection"],
          properties: {
            color: {
              type: "array",
              items: { type: "number" },
              description: "The color to use when rendering this channel under the null colormap."
            },
            selection: {
              type: "object",
              description: "Determines the channel selection, e.g. some Z and time slice."
            },
            slider: {
              type: "array",
              items: { type: "number" },
              description: "Determines the range for color mapping."
            },
            visible: {
              type: "boolean",
              description: "Determines whether this channel of the layer will be rendered in the spatial component."
            }
          }
        }
      },
      colormap: {
        oneOf: [
          {
            type: "string",
            description: "The name of the colormap to use for this layer."
          },
          {
            type: "null",
            description: "Use the solid color definitions."
          }
        ]
      },
      transparentColor: {
        oneOf: [
          {
            type: "array",
            minItems: 3,
            maxItems: 3,
            items: {
              type: "number",
              description: "One of R G or B (0 - 255)."
            },
            description: "Determines the color to be set to opacity 0"
          },
          {
            type: "null",
            description: "No selection."
          }
        ]
      },
      index: {
        type: "number",
        description: "The index of the layer among the array of layers available in the image file."
      },
      opacity: {
        type: "number"
      },
      modelMatrix: {
        oneOf: [
          {
            type: "array",
            minItems: 16,
            maxItems: 16,
            description: "transformation matrix for this layer"
          },
          {
            type: "null",
            description: "Use no transformation."
          }
        ]
      },
      domainType: {
        type: "string",
        enum: ["Full", "Min/Max"],
        description: "Determines the extent of the channel slider input element in the layer controller."
      },
      resolution: {
        type: "number",
        description: "Resolution of 3D volumetric rendering"
      },
      xSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      renderingMode: {
        type: "string",
        description: "Rendering mode of 3D volumetric rendering"
      },
      ySlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      zSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      type: {
        type: "string",
        enum: ["raster", "bitmask"]
      },
      use3d: {
        type: "boolean"
      },
      visible: {
        type: "boolean",
        description: "Determines whether this entire layer will be rendered in the spatial component."
      }
    }
  },
  moleculesLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the molecules layer.",
    additionalProperties: false,
    required: ["visible", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  cellsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the cells layer.",
    additionalProperties: false,
    required: ["visible", "stroked", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      stroked: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  neighborhoodsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the neighborhoods layer.",
    additionalProperties: false,
    required: ["visible"],
    properties: {
      visible: {
        type: "boolean"
      }
    }
  },
  spatialRasterLayers: {
    type: "array",
    description: "Array of Spatial Layers",
    items: {
      $ref: "#/definitions/rasterLayer"
    }
  }
};
var additionalProperties11 = false;
var required11 = ["version", "name", "datasets", "layout", "initStrategy"];
var properties11 = {
  name: { type: "string" },
  public: { type: "boolean" },
  description: { type: "string" },
  datasets: {
    type: "array",
    description: "The datasets array defines groups of files, where the files within each dataset reference the same entities (cells, genes, cell sets, etc).",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["uid", "files"],
      properties: {
        uid: { type: "string" },
        name: { type: "string" },
        description: { type: "string" },
        files: {
          type: "array",
          items: {
            type: "object",
            additionalProperties: false,
            required: ["type", "fileType"],
            properties: {
              name: { type: "string" },
              type: { type: "string" },
              fileType: { type: "string" },
              url: { type: "string" },
              options: { oneOf: [{ $ref: "#/definitions/annDataCellSets" }, { $ref: "https://github.com/vitessce/vitessce/#raster" }, { $ref: "#/definitions/annDataCells" }, { $ref: "#/definitions/annDataExpressionMatrix" }] },
              requestInit: { $ref: "#/definitions/requestInit" }
            }
          }
        }
      }
    }
  },
  coordinationSpace: {
    type: "object",
    description: "The coordination space stores the values for each scope of each coordination object.",
    additionalProperties: false,
    required: [],
    properties: {
      dataset: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetZ: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingType: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingCellSetPolygonsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingCellSetLabelsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingCellSetLabelSize: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingCellRadius: {
        type: "object",
        patternProperties: {
          ".": {
            type: "number",
            description: "The cell radius value, used when embeddingCellRadiusMode is absolute or relative."
          }
        }
      },
      embeddingCellOpacity: {
        type: "object",
        patternProperties: {
          ".": {
            type: "number",
            description: "The cell opacity value, used when embeddingCellOpacityMode is static."
          }
        }
      },
      embeddingCellRadiusMode: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["manual", "auto"],
            description: "Should data points representing cells be assigned a static (manual) or dynamic (auto, based on zoom level and data extent) radius?"
          }
        }
      },
      embeddingCellOpacityMode: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["manual", "auto"],
            description: "Should data points representing cells be assigned a static (manual) or dynamic (auto, based on zoom level and data extent) opacity?"
          }
        }
      },
      spatialZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      spatialTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationOrbit: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialOrbitAxis: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "string" }
            ]
          }
        }
      },
      spatialAxisFixed: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "Whether or not to have a fixed axis for the camera. Only useful for 3D viewing."
              },
              { type: "boolean" }
            ]
          }
        }
      },
      spatialRasterLayers: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/spatialRasterLayers" }
            ]
          }
        }
      },
      spatialCellsLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/cellsLayer" }
            ]
          }
        }
      },
      spatialNeighborhoodsLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/neighborhoodsLayer" }
            ]
          }
        }
      },
      spatialMoleculesLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/moleculesLayer" }
            ]
          }
        }
      },
      heatmapZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      cellFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cells will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      cellHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      cellSetSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto cell set initialization is enabled, cell set selections will be automatically initialized."
              },
              { type: "array" }
            ]
          }
        }
      },
      cellSetHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell sets will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      cellSetColor: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, cell set colors will be automatically initialized."
              },
              {
                type: "array",
                items: {
                  type: "object",
                  additionalProperties: false,
                  required: ["path", "color"],
                  properties: {
                    path: {
                      type: "array",
                      items: { type: "string" }
                    },
                    color: {
                      type: "array",
                      items: { type: "number" }
                    }
                  }
                }
              }
            ]
          }
        }
      },
      cellColorEncoding: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["geneSelection", "cellSetSelection"],
            description: "How should data points representing cells be colored?"
          }
        }
      },
      geneFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      geneHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      geneSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      geneExpressionTransform: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "string", pattern: "log1p" }
            ]
          }
        }
      },
      geneExpressionColormap: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      geneExpressionColormapRange: {
        type: "object",
        patternProperties: {
          ".": { type: "array", items: { type: "number" } }
        }
      },
      genomicZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      additionalCellSets: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              {
                $ref: "https://github.com/vitessce/vitessce/#cell-sets"
              }
            ]
          }
        }
      },
      moleculeHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no molecule will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      }
    }
  },
  layout: { $ref: "#/definitions/components" },
  initStrategy: {
    type: "string",
    enum: ["none", "auto"],
    description: "The initialization strategy determines how missing coordination objects and coordination scope mappings are initially filled in."
  },
  version: {
    type: "string",
    enum: ["1.0.8"],
    description: "The schema version for the view config."
  }
};
var config_1_0_8_schema_default = {
  $schema: $schema15,
  $id: $id15,
  title: title15,
  type: type15,
  definitions: definitions15,
  additionalProperties: additionalProperties11,
  required: required11,
  properties: properties11
};

// src/schemas/config-1.0.9.schema.json
var $schema16 = "http://json-schema.org/draft-07/schema#";
var $id16 = "https://github.com/vitessce/vitessce/#dataset";
var title16 = "Vitessce data set";
var type16 = "object";
var definitions16 = {
  componentCoordinationScopeValue: {
    oneOf: [
      { type: "string" },
      {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      }
    ]
  },
  components: {
    description: "The layout array defines the views, or components, rendered in the grid.",
    type: "array",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["component", "x", "y"],
      properties: {
        component: {
          type: "string",
          description: "Specify a component using a name defined in the component registry."
        },
        props: {
          type: "object",
          description: "Extra prop values for the component."
        },
        x: { type: "integer" },
        y: { type: "integer" },
        w: { type: "integer" },
        h: { type: "integer" },
        coordinationScopes: {
          type: "object",
          description: "Component-level coordination scope mappings define which coordination object values a particular component can read and write, for each coordination type.",
          additionalProperties: true,
          required: [],
          properties: {
            dataset: {
              oneOf: [
                { type: "string" },
                { type: "array", items: { type: "string" } }
              ]
            },
            embeddingType: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingZoom: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingRotation: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingTargetX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingTargetY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingTargetZ: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingCellSetPolygonsVisible: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingCellSetLabelsVisible: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingCellSetLabelSize: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingCellRadius: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingCellOpacity: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingCellRadiusMode: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingCellOpacityMode: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialZoom: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRotation: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialTargetX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialTargetY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialTargetZ: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRotationX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRotationY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRotationZ: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRotationOrbit: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialOrbitAxis: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialAxisFixed: { $ref: "#/definitions/componentCoordinationScopeValue" },
            heatmapZoomX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            heatmapZoomY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            heatmapTargetX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            heatmapTargetY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            cellFilter: { $ref: "#/definitions/componentCoordinationScopeValue" },
            cellHighlight: { $ref: "#/definitions/componentCoordinationScopeValue" },
            cellSetSelection: { $ref: "#/definitions/componentCoordinationScopeValue" },
            cellSetHighlight: { $ref: "#/definitions/componentCoordinationScopeValue" },
            cellSetColor: { $ref: "#/definitions/componentCoordinationScopeValue" },
            geneFilter: { $ref: "#/definitions/componentCoordinationScopeValue" },
            geneHighlight: { $ref: "#/definitions/componentCoordinationScopeValue" },
            geneSelection: { $ref: "#/definitions/componentCoordinationScopeValue" },
            geneExpressionTransform: { $ref: "#/definitions/componentCoordinationScopeValue" },
            geneExpressionColormap: { $ref: "#/definitions/componentCoordinationScopeValue" },
            geneExpressionColormapRange: { $ref: "#/definitions/componentCoordinationScopeValue" },
            cellColorEncoding: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRasterLayers: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialCellsLayer: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialMoleculesLayer: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialNeighborhoodsLayer: { $ref: "#/definitions/componentCoordinationScopeValue" },
            genomicZoomX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            genomicZoomY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            genomicTargetX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            genomicTargetY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            additionalCellSets: { $ref: "#/definitions/componentCoordinationScopeValue" },
            moleculeHighlight: { $ref: "#/definitions/componentCoordinationScopeValue" }
          }
        }
      }
    }
  },
  annDataCellSets: {
    type: "array",
    description: "Array of cell set configuration, following closely the conventions of the tabular schema",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["groupName", "setName"],
      properties: {
        groupName: {
          type: "string",
          description: "The display name for the set, like 'Cell Type' or 'Louvain.'"
        },
        setName: {
          oneOf: [
            {
              type: "string",
              description: "The location in the AnnData store for the set, like 'obs/louvain' or 'obs/celltype.'"
            },
            {
              type: "array",
              items: { type: "string" },
              description: "An array of locations in the AnnData store for a hierarchy of set names, from coarse to fine levels."
            }
          ]
        },
        scoreName: {
          oneOf: [
            {
              type: "string",
              description: "The location in the AnnData store for the set confidence scores, like 'obs/celltype_prediction_score.'"
            }
          ]
        }
      }
    }
  },
  annDataCells: {
    type: "object",
    description: "The properties of this object are the configuration for how to layout scatterplots and spatial information",
    minProperties: 1,
    additionalProperties: false,
    required: [],
    properties: {
      xy: {
        type: "string",
        description: "The location in the AnnData store of cell centroids, like 'obsm/X_centroids.'"
      },
      poly: {
        type: "string",
        description: "The location in the AnnData store of cell polygon outlines, like 'obsm/X_polygons.'"
      },
      factors: {
        type: "array",
        description: "List of locations in the AnnData store of cell sets, like 'obs/louvain'",
        items: {
          type: "string"
        }
      },
      mappings: {
        patternProperties: {
          ".": {
            type: "object",
            description: "An object containing key-values for mappings like { UMAP: { key: 'obsm/X_umap', dims: [0, 1] } }.",
            additionalProperties: false,
            required: ["key"],
            properties: {
              key: {
                type: "string",
                description: "Where to look in the AnnData store for this mapping, like 'obsm/X_umap.'"
              },
              dims: {
                type: "array",
                description: "Which indices of the obsm object to take for a scatterplot, allowing for, for example, different PCs from obsm/X_pca",
                minItems: 2,
                maxItems: 2,
                items: { type: "number" }
              }
            }
          }
        }
      }
    }
  },
  annDataExpressionMatrix: {
    type: "object",
    description: "The properties of this object are the configuration for how to fetch the cell x genes matrix",
    additionalProperties: false,
    required: ["matrix"],
    properties: {
      matrix: {
        type: "string",
        description: "The location in the AnnData store of the cell x gene matrix, like 'obsm/hvg_subset.' or 'X'"
      },
      geneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the genes if using a subset of the data, like 'var.highly_variable.' if the matrix comes from 'obsm/hvg_subset.'"
      },
      matrixGeneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the matrix data (used in heatmap and histogram), like 'var.highly_variable.''"
      },
      geneAlias: {
        type: "string",
        description: "The location in the AnnData store of a different list of names for gene list component, other than the `var` index"
      }
    }
  },
  requestInit: {
    type: "object",
    description: "The properties of this object correspond to the parameters of the JavaScript fetch() function.",
    additionalProperties: false,
    required: [],
    properties: {
      method: {
        type: "string"
      },
      headers: {
        type: "object"
      },
      body: {
        type: "string"
      },
      mode: {
        type: "string"
      },
      credentials: {
        type: "string"
      },
      cache: {
        type: "string"
      },
      redirect: {
        type: "string"
      },
      referrer: {
        type: "string"
      },
      integrity: {
        type: "string"
      }
    }
  },
  rasterLayer: {
    description: "The properties of this object are the rendering settings for the raster layer.",
    additionalProperties: false,
    required: ["channels", "colormap", "index", "opacity"],
    properties: {
      channels: {
        type: "array",
        items: {
          type: "object",
          additionalProperties: false,
          required: ["selection"],
          properties: {
            color: {
              type: "array",
              items: { type: "number" },
              description: "The color to use when rendering this channel under the null colormap."
            },
            selection: {
              type: "object",
              description: "Determines the channel selection, e.g. some Z and time slice."
            },
            slider: {
              type: "array",
              items: { type: "number" },
              description: "Determines the range for color mapping."
            },
            visible: {
              type: "boolean",
              description: "Determines whether this channel of the layer will be rendered in the spatial component."
            }
          }
        }
      },
      colormap: {
        oneOf: [
          {
            type: "string",
            description: "The name of the colormap to use for this layer."
          },
          {
            type: "null",
            description: "Use the solid color definitions."
          }
        ]
      },
      transparentColor: {
        oneOf: [
          {
            type: "array",
            minItems: 3,
            maxItems: 3,
            items: {
              type: "number",
              description: "One of R G or B (0 - 255)."
            },
            description: "Determines the color to be set to opacity 0"
          },
          {
            type: "null",
            description: "No selection."
          }
        ]
      },
      index: {
        type: "number",
        description: "The index of the layer among the array of layers available in the image file."
      },
      opacity: {
        type: "number"
      },
      modelMatrix: {
        oneOf: [
          {
            type: "array",
            minItems: 16,
            maxItems: 16,
            description: "transformation matrix for this layer"
          },
          {
            type: "null",
            description: "Use no transformation."
          }
        ]
      },
      domainType: {
        type: "string",
        enum: ["Full", "Min/Max"],
        description: "Determines the extent of the channel slider input element in the layer controller."
      },
      resolution: {
        type: "number",
        description: "Resolution of 3D volumetric rendering"
      },
      xSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      renderingMode: {
        type: "string",
        description: "Rendering mode of 3D volumetric rendering"
      },
      ySlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      zSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      type: {
        type: "string",
        enum: ["raster", "bitmask"]
      },
      use3d: {
        type: "boolean"
      },
      visible: {
        type: "boolean",
        description: "Determines whether this entire layer will be rendered in the spatial component."
      }
    }
  },
  moleculesLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the molecules layer.",
    additionalProperties: false,
    required: ["visible", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  cellsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the cells layer.",
    additionalProperties: false,
    required: ["visible", "stroked", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      stroked: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  neighborhoodsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the neighborhoods layer.",
    additionalProperties: false,
    required: ["visible"],
    properties: {
      visible: {
        type: "boolean"
      }
    }
  },
  spatialRasterLayers: {
    type: "array",
    description: "Array of Spatial Layers",
    items: {
      $ref: "#/definitions/rasterLayer"
    }
  }
};
var additionalProperties12 = false;
var required12 = ["version", "name", "datasets", "layout", "initStrategy"];
var properties12 = {
  name: { type: "string" },
  public: { type: "boolean" },
  description: { type: "string" },
  datasets: {
    type: "array",
    description: "The datasets array defines groups of files, where the files within each dataset reference the same entities (cells, genes, cell sets, etc).",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["uid", "files"],
      properties: {
        uid: { type: "string" },
        name: { type: "string" },
        description: { type: "string" },
        files: {
          type: "array",
          items: {
            type: "object",
            additionalProperties: false,
            required: ["type", "fileType"],
            properties: {
              name: { type: "string" },
              type: { type: "string" },
              fileType: { type: "string" },
              url: { type: "string" },
              options: { oneOf: [{ $ref: "#/definitions/annDataCellSets" }, { $ref: "https://github.com/vitessce/vitessce/#raster" }, { $ref: "#/definitions/annDataCells" }, { $ref: "#/definitions/annDataExpressionMatrix" }] },
              requestInit: { $ref: "#/definitions/requestInit" }
            }
          }
        }
      }
    }
  },
  coordinationSpace: {
    type: "object",
    description: "The coordination space stores the values for each scope of each coordination object.",
    additionalProperties: true,
    required: [],
    properties: {
      dataset: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetZ: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingType: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingCellSetPolygonsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingCellSetLabelsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingCellSetLabelSize: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingCellRadius: {
        type: "object",
        patternProperties: {
          ".": {
            type: "number",
            description: "The cell radius value, used when embeddingCellRadiusMode is absolute or relative."
          }
        }
      },
      embeddingCellOpacity: {
        type: "object",
        patternProperties: {
          ".": {
            type: "number",
            description: "The cell opacity value, used when embeddingCellOpacityMode is static."
          }
        }
      },
      embeddingCellRadiusMode: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["manual", "auto"],
            description: "Should data points representing cells be assigned a static (manual) or dynamic (auto, based on zoom level and data extent) radius?"
          }
        }
      },
      embeddingCellOpacityMode: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["manual", "auto"],
            description: "Should data points representing cells be assigned a static (manual) or dynamic (auto, based on zoom level and data extent) opacity?"
          }
        }
      },
      spatialZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      spatialTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationOrbit: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialOrbitAxis: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "string" }
            ]
          }
        }
      },
      spatialAxisFixed: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "Whether or not to have a fixed axis for the camera. Only useful for 3D viewing."
              },
              { type: "boolean" }
            ]
          }
        }
      },
      spatialRasterLayers: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/spatialRasterLayers" }
            ]
          }
        }
      },
      spatialCellsLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/cellsLayer" }
            ]
          }
        }
      },
      spatialNeighborhoodsLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/neighborhoodsLayer" }
            ]
          }
        }
      },
      spatialMoleculesLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/moleculesLayer" }
            ]
          }
        }
      },
      heatmapZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      cellFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cells will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      cellHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      cellSetSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto cell set initialization is enabled, cell set selections will be automatically initialized."
              },
              { type: "array" }
            ]
          }
        }
      },
      cellSetHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell sets will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      cellSetColor: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, cell set colors will be automatically initialized."
              },
              {
                type: "array",
                items: {
                  type: "object",
                  additionalProperties: false,
                  required: ["path", "color"],
                  properties: {
                    path: {
                      type: "array",
                      items: { type: "string" }
                    },
                    color: {
                      type: "array",
                      items: { type: "number" }
                    }
                  }
                }
              }
            ]
          }
        }
      },
      cellColorEncoding: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["geneSelection", "cellSetSelection"],
            description: "How should data points representing cells be colored?"
          }
        }
      },
      geneFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      geneHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      geneSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      geneExpressionTransform: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "string", pattern: "log1p" }
            ]
          }
        }
      },
      geneExpressionColormap: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      geneExpressionColormapRange: {
        type: "object",
        patternProperties: {
          ".": { type: "array", items: { type: "number" } }
        }
      },
      genomicZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      additionalCellSets: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              {
                $ref: "https://github.com/vitessce/vitessce/#cell-sets"
              }
            ]
          }
        }
      },
      moleculeHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no molecule will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      }
    }
  },
  layout: { $ref: "#/definitions/components" },
  initStrategy: {
    type: "string",
    enum: ["none", "auto"],
    description: "The initialization strategy determines how missing coordination objects and coordination scope mappings are initially filled in."
  },
  version: {
    type: "string",
    enum: ["1.0.9"],
    description: "The schema version for the view config."
  }
};
var config_1_0_9_schema_default = {
  $schema: $schema16,
  $id: $id16,
  title: title16,
  type: type16,
  definitions: definitions16,
  additionalProperties: additionalProperties12,
  required: required12,
  properties: properties12
};

// src/schemas/config-1.0.10.schema.json
var $schema17 = "http://json-schema.org/draft-07/schema#";
var $id17 = "https://github.com/vitessce/vitessce/#dataset";
var title17 = "Vitessce data set";
var type17 = "object";
var definitions17 = {
  componentCoordinationScopeValue: {
    oneOf: [
      { type: "string" },
      {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      }
    ]
  },
  components: {
    description: "The layout array defines the views, or components, rendered in the grid.",
    type: "array",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["component", "x", "y"],
      properties: {
        uid: {
          type: "string",
          description: "A unique identifier for the view, to refer to it in getter and setter functions in object-oriented contexts."
        },
        component: {
          type: "string",
          description: "Specify a component using a name defined in the component registry."
        },
        props: {
          type: "object",
          description: "Extra prop values for the component."
        },
        x: { type: "integer" },
        y: { type: "integer" },
        w: { type: "integer" },
        h: { type: "integer" },
        coordinationScopes: {
          type: "object",
          description: "Component-level coordination scope mappings define which coordination object values a particular component can read and write, for each coordination type.",
          additionalProperties: true,
          required: [],
          properties: {
            dataset: {
              oneOf: [
                { type: "string" },
                { type: "array", items: { type: "string" } }
              ]
            },
            embeddingType: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingZoom: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingRotation: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingTargetX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingTargetY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingTargetZ: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingCellSetPolygonsVisible: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingCellSetLabelsVisible: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingCellSetLabelSize: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingCellRadius: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingCellOpacity: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingCellRadiusMode: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingCellOpacityMode: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialZoom: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRotation: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialTargetX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialTargetY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialTargetZ: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRotationX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRotationY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRotationZ: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRotationOrbit: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialOrbitAxis: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialAxisFixed: { $ref: "#/definitions/componentCoordinationScopeValue" },
            heatmapZoomX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            heatmapZoomY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            heatmapTargetX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            heatmapTargetY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            cellFilter: { $ref: "#/definitions/componentCoordinationScopeValue" },
            cellHighlight: { $ref: "#/definitions/componentCoordinationScopeValue" },
            cellSetSelection: { $ref: "#/definitions/componentCoordinationScopeValue" },
            cellSetHighlight: { $ref: "#/definitions/componentCoordinationScopeValue" },
            cellSetColor: { $ref: "#/definitions/componentCoordinationScopeValue" },
            geneFilter: { $ref: "#/definitions/componentCoordinationScopeValue" },
            geneHighlight: { $ref: "#/definitions/componentCoordinationScopeValue" },
            geneSelection: { $ref: "#/definitions/componentCoordinationScopeValue" },
            geneExpressionTransform: { $ref: "#/definitions/componentCoordinationScopeValue" },
            geneExpressionColormap: { $ref: "#/definitions/componentCoordinationScopeValue" },
            geneExpressionColormapRange: { $ref: "#/definitions/componentCoordinationScopeValue" },
            cellColorEncoding: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRasterLayers: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialCellsLayer: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialMoleculesLayer: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialNeighborhoodsLayer: { $ref: "#/definitions/componentCoordinationScopeValue" },
            genomicZoomX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            genomicZoomY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            genomicTargetX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            genomicTargetY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            additionalCellSets: { $ref: "#/definitions/componentCoordinationScopeValue" },
            moleculeHighlight: { $ref: "#/definitions/componentCoordinationScopeValue" }
          }
        }
      }
    }
  },
  annDataCellSets: {
    type: "array",
    description: "Array of cell set configuration, following closely the conventions of the tabular schema",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["groupName", "setName"],
      properties: {
        groupName: {
          type: "string",
          description: "The display name for the set, like 'Cell Type' or 'Louvain.'"
        },
        setName: {
          oneOf: [
            {
              type: "string",
              description: "The location in the AnnData store for the set, like 'obs/louvain' or 'obs/celltype.'"
            },
            {
              type: "array",
              items: { type: "string" },
              description: "An array of locations in the AnnData store for a hierarchy of set names, from coarse to fine levels."
            }
          ]
        },
        scoreName: {
          oneOf: [
            {
              type: "string",
              description: "The location in the AnnData store for the set confidence scores, like 'obs/celltype_prediction_score.'"
            }
          ]
        }
      }
    }
  },
  annDataCells: {
    type: "object",
    description: "The properties of this object are the configuration for how to layout scatterplots and spatial information",
    minProperties: 1,
    additionalProperties: false,
    required: [],
    properties: {
      xy: {
        type: "string",
        description: "The location in the AnnData store of cell centroids, like 'obsm/X_centroids.'"
      },
      poly: {
        type: "string",
        description: "The location in the AnnData store of cell polygon outlines, like 'obsm/X_polygons.'"
      },
      factors: {
        type: "array",
        description: "List of locations in the AnnData store of cell sets, like 'obs/louvain'",
        items: {
          type: "string"
        }
      },
      mappings: {
        patternProperties: {
          ".": {
            type: "object",
            description: "An object containing key-values for mappings like { UMAP: { key: 'obsm/X_umap', dims: [0, 1] } }.",
            additionalProperties: false,
            required: ["key"],
            properties: {
              key: {
                type: "string",
                description: "Where to look in the AnnData store for this mapping, like 'obsm/X_umap.'"
              },
              dims: {
                type: "array",
                description: "Which indices of the obsm object to take for a scatterplot, allowing for, for example, different PCs from obsm/X_pca",
                minItems: 2,
                maxItems: 2,
                items: { type: "number" }
              }
            }
          }
        }
      }
    }
  },
  annDataExpressionMatrix: {
    type: "object",
    description: "The properties of this object are the configuration for how to fetch the cell x genes matrix",
    additionalProperties: false,
    required: ["matrix"],
    properties: {
      matrix: {
        type: "string",
        description: "The location in the AnnData store of the cell x gene matrix, like 'obsm/hvg_subset.' or 'X'"
      },
      geneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the genes if using a subset of the data, like 'var.highly_variable.' if the matrix comes from 'obsm/hvg_subset.'"
      },
      matrixGeneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the matrix data (used in heatmap and histogram), like 'var.highly_variable.''"
      },
      geneAlias: {
        type: "string",
        description: "The location in the AnnData store of a different list of names for gene list component, other than the `var` index"
      }
    }
  },
  requestInit: {
    type: "object",
    description: "The properties of this object correspond to the parameters of the JavaScript fetch() function.",
    additionalProperties: false,
    required: [],
    properties: {
      method: {
        type: "string"
      },
      headers: {
        type: "object"
      },
      body: {
        type: "string"
      },
      mode: {
        type: "string"
      },
      credentials: {
        type: "string"
      },
      cache: {
        type: "string"
      },
      redirect: {
        type: "string"
      },
      referrer: {
        type: "string"
      },
      integrity: {
        type: "string"
      }
    }
  },
  rasterLayer: {
    description: "The properties of this object are the rendering settings for the raster layer.",
    additionalProperties: false,
    required: ["channels", "colormap", "index", "opacity"],
    properties: {
      channels: {
        type: "array",
        items: {
          type: "object",
          additionalProperties: false,
          required: ["selection"],
          properties: {
            color: {
              type: "array",
              items: { type: "number" },
              description: "The color to use when rendering this channel under the null colormap."
            },
            selection: {
              type: "object",
              description: "Determines the channel selection, e.g. some Z and time slice."
            },
            slider: {
              type: "array",
              items: { type: "number" },
              description: "Determines the range for color mapping."
            },
            visible: {
              type: "boolean",
              description: "Determines whether this channel of the layer will be rendered in the spatial component."
            }
          }
        }
      },
      colormap: {
        oneOf: [
          {
            type: "string",
            description: "The name of the colormap to use for this layer."
          },
          {
            type: "null",
            description: "Use the solid color definitions."
          }
        ]
      },
      transparentColor: {
        oneOf: [
          {
            type: "array",
            minItems: 3,
            maxItems: 3,
            items: {
              type: "number",
              description: "One of R G or B (0 - 255)."
            },
            description: "Determines the color to be set to opacity 0"
          },
          {
            type: "null",
            description: "No selection."
          }
        ]
      },
      index: {
        type: "number",
        description: "The index of the layer among the array of layers available in the image file."
      },
      opacity: {
        type: "number"
      },
      modelMatrix: {
        oneOf: [
          {
            type: "array",
            minItems: 16,
            maxItems: 16,
            description: "transformation matrix for this layer"
          },
          {
            type: "null",
            description: "Use no transformation."
          }
        ]
      },
      domainType: {
        type: "string",
        enum: ["Full", "Min/Max"],
        description: "Determines the extent of the channel slider input element in the layer controller."
      },
      resolution: {
        type: "number",
        description: "Resolution of 3D volumetric rendering"
      },
      xSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      renderingMode: {
        type: "string",
        description: "Rendering mode of 3D volumetric rendering"
      },
      ySlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      zSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      type: {
        type: "string",
        enum: ["raster", "bitmask"]
      },
      use3d: {
        type: "boolean"
      },
      visible: {
        type: "boolean",
        description: "Determines whether this entire layer will be rendered in the spatial component."
      }
    }
  },
  moleculesLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the molecules layer.",
    additionalProperties: false,
    required: ["visible", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  cellsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the cells layer.",
    additionalProperties: false,
    required: ["visible", "stroked", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      stroked: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  neighborhoodsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the neighborhoods layer.",
    additionalProperties: false,
    required: ["visible"],
    properties: {
      visible: {
        type: "boolean"
      }
    }
  },
  spatialRasterLayers: {
    type: "array",
    description: "Array of Spatial Layers",
    items: {
      $ref: "#/definitions/rasterLayer"
    }
  }
};
var additionalProperties13 = false;
var required13 = ["version", "name", "datasets", "layout", "initStrategy"];
var properties13 = {
  name: { type: "string" },
  public: { type: "boolean" },
  description: { type: "string" },
  datasets: {
    type: "array",
    description: "The datasets array defines groups of files, where the files within each dataset reference the same entities (cells, genes, cell sets, etc).",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["uid", "files"],
      properties: {
        uid: { type: "string" },
        name: { type: "string" },
        description: { type: "string" },
        files: {
          type: "array",
          items: {
            type: "object",
            additionalProperties: false,
            required: ["type", "fileType"],
            properties: {
              name: { type: "string" },
              type: { type: "string" },
              fileType: { type: "string" },
              url: { type: "string" },
              options: { oneOf: [{ $ref: "#/definitions/annDataCellSets" }, { $ref: "https://github.com/vitessce/vitessce/#raster" }, { $ref: "#/definitions/annDataCells" }, { $ref: "#/definitions/annDataExpressionMatrix" }] },
              requestInit: { $ref: "#/definitions/requestInit" }
            }
          }
        }
      }
    }
  },
  coordinationSpace: {
    type: "object",
    description: "The coordination space stores the values for each scope of each coordination object.",
    additionalProperties: true,
    required: [],
    properties: {
      dataset: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetZ: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingType: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingCellSetPolygonsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingCellSetLabelsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingCellSetLabelSize: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingCellRadius: {
        type: "object",
        patternProperties: {
          ".": {
            type: "number",
            description: "The cell radius value, used when embeddingCellRadiusMode is absolute or relative."
          }
        }
      },
      embeddingCellOpacity: {
        type: "object",
        patternProperties: {
          ".": {
            type: "number",
            description: "The cell opacity value, used when embeddingCellOpacityMode is static."
          }
        }
      },
      embeddingCellRadiusMode: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["manual", "auto"],
            description: "Should data points representing cells be assigned a static (manual) or dynamic (auto, based on zoom level and data extent) radius?"
          }
        }
      },
      embeddingCellOpacityMode: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["manual", "auto"],
            description: "Should data points representing cells be assigned a static (manual) or dynamic (auto, based on zoom level and data extent) opacity?"
          }
        }
      },
      spatialZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      spatialTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationOrbit: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialOrbitAxis: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "string" }
            ]
          }
        }
      },
      spatialAxisFixed: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "Whether or not to have a fixed axis for the camera. Only useful for 3D viewing."
              },
              { type: "boolean" }
            ]
          }
        }
      },
      spatialRasterLayers: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/spatialRasterLayers" }
            ]
          }
        }
      },
      spatialCellsLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/cellsLayer" }
            ]
          }
        }
      },
      spatialNeighborhoodsLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/neighborhoodsLayer" }
            ]
          }
        }
      },
      spatialMoleculesLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/moleculesLayer" }
            ]
          }
        }
      },
      heatmapZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      cellFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cells will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      cellHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      cellSetSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto cell set initialization is enabled, cell set selections will be automatically initialized."
              },
              { type: "array" }
            ]
          }
        }
      },
      cellSetHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell sets will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      cellSetColor: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, cell set colors will be automatically initialized."
              },
              {
                type: "array",
                items: {
                  type: "object",
                  additionalProperties: false,
                  required: ["path", "color"],
                  properties: {
                    path: {
                      type: "array",
                      items: { type: "string" }
                    },
                    color: {
                      type: "array",
                      items: { type: "number" }
                    }
                  }
                }
              }
            ]
          }
        }
      },
      cellColorEncoding: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["geneSelection", "cellSetSelection"],
            description: "How should data points representing cells be colored?"
          }
        }
      },
      geneFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      geneHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      geneSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      geneExpressionTransform: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "string", pattern: "log1p" }
            ]
          }
        }
      },
      geneExpressionColormap: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      geneExpressionColormapRange: {
        type: "object",
        patternProperties: {
          ".": { type: "array", items: { type: "number" } }
        }
      },
      genomicZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      additionalCellSets: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              {
                $ref: "https://github.com/vitessce/vitessce/#cell-sets"
              }
            ]
          }
        }
      },
      moleculeHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no molecule will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      }
    }
  },
  layout: { $ref: "#/definitions/components" },
  initStrategy: {
    type: "string",
    enum: ["none", "auto"],
    description: "The initialization strategy determines how missing coordination objects and coordination scope mappings are initially filled in."
  },
  version: {
    type: "string",
    enum: ["1.0.10"],
    description: "The schema version for the view config."
  }
};
var config_1_0_10_schema_default = {
  $schema: $schema17,
  $id: $id17,
  title: title17,
  type: type17,
  definitions: definitions17,
  additionalProperties: additionalProperties13,
  required: required13,
  properties: properties13
};

// src/schemas/config-1.0.11.schema.json
var $schema18 = "http://json-schema.org/draft-07/schema#";
var $id18 = "https://github.com/vitessce/vitessce/#dataset";
var title18 = "Vitessce data set";
var type18 = "object";
var definitions18 = {
  componentCoordinationScopeValue: {
    oneOf: [
      { type: "string" },
      {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      }
    ]
  },
  components: {
    description: "The layout array defines the views, or components, rendered in the grid.",
    type: "array",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["component", "x", "y"],
      properties: {
        uid: {
          type: "string",
          description: "A unique identifier for the view, to refer to it in getter and setter functions in object-oriented contexts."
        },
        component: {
          type: "string",
          description: "Specify a component using a name defined in the component registry."
        },
        props: {
          type: "object",
          description: "Extra prop values for the component."
        },
        x: { type: "integer" },
        y: { type: "integer" },
        w: { type: "integer" },
        h: { type: "integer" },
        coordinationScopes: {
          type: "object",
          description: "Component-level coordination scope mappings define which coordination object values a particular component can read and write, for each coordination type.",
          additionalProperties: true,
          required: [],
          properties: {
            dataset: {
              oneOf: [
                { type: "string" },
                { type: "array", items: { type: "string" } }
              ]
            },
            obsType: { $ref: "#/definitions/componentCoordinationScopeValue" },
            featureType: { $ref: "#/definitions/componentCoordinationScopeValue" },
            featureValueType: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingType: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingZoom: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingRotation: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingTargetX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingTargetY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingTargetZ: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingObsSetPolygonsVisible: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingObsSetLabelsVisible: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingObsSetLabelSize: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingObsRadius: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingObsOpacity: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingObsRadiusMode: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingObsOpacityMode: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialZoom: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRotation: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialTargetX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialTargetY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialTargetZ: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRotationX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRotationY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRotationZ: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRotationOrbit: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialOrbitAxis: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialAxisFixed: { $ref: "#/definitions/componentCoordinationScopeValue" },
            heatmapZoomX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            heatmapZoomY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            heatmapTargetX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            heatmapTargetY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            obsFilter: { $ref: "#/definitions/componentCoordinationScopeValue" },
            obsHighlight: { $ref: "#/definitions/componentCoordinationScopeValue" },
            obsSetSelection: { $ref: "#/definitions/componentCoordinationScopeValue" },
            obsSetHighlight: { $ref: "#/definitions/componentCoordinationScopeValue" },
            obsSetColor: { $ref: "#/definitions/componentCoordinationScopeValue" },
            featureFilter: { $ref: "#/definitions/componentCoordinationScopeValue" },
            featureHighlight: { $ref: "#/definitions/componentCoordinationScopeValue" },
            featureSelection: { $ref: "#/definitions/componentCoordinationScopeValue" },
            featureValueTransform: { $ref: "#/definitions/componentCoordinationScopeValue" },
            featureValueColormap: { $ref: "#/definitions/componentCoordinationScopeValue" },
            featureValueColormapRange: { $ref: "#/definitions/componentCoordinationScopeValue" },
            obsColorEncoding: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialImageLayer: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialSegmentationLayer: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialPointLayer: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialNeighborhoodLayer: { $ref: "#/definitions/componentCoordinationScopeValue" },
            genomicZoomX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            genomicZoomY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            genomicTargetX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            genomicTargetY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            additionalObsSets: { $ref: "#/definitions/componentCoordinationScopeValue" },
            moleculeHighlight: { $ref: "#/definitions/componentCoordinationScopeValue" }
          }
        }
      }
    }
  },
  annDataCellSets: {
    type: "array",
    description: "Array of cell set configuration, following closely the conventions of the tabular schema",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["groupName", "setName"],
      properties: {
        groupName: {
          type: "string",
          description: "The display name for the set, like 'Cell Type' or 'Louvain.'"
        },
        setName: {
          oneOf: [
            {
              type: "string",
              description: "The location in the AnnData store for the set, like 'obs/louvain' or 'obs/celltype.'"
            },
            {
              type: "array",
              items: { type: "string" },
              description: "An array of locations in the AnnData store for a hierarchy of set names, from coarse to fine levels."
            }
          ]
        },
        scoreName: {
          oneOf: [
            {
              type: "string",
              description: "The location in the AnnData store for the set confidence scores, like 'obs/celltype_prediction_score.'"
            }
          ]
        }
      }
    }
  },
  annDataCells: {
    type: "object",
    description: "The properties of this object are the configuration for how to layout scatterplots and spatial information",
    minProperties: 1,
    additionalProperties: false,
    required: [],
    properties: {
      xy: {
        type: "string",
        description: "The location in the AnnData store of cell centroids, like 'obsm/X_centroids.'"
      },
      poly: {
        type: "string",
        description: "The location in the AnnData store of cell polygon outlines, like 'obsm/X_polygons.'"
      },
      factors: {
        type: "array",
        description: "List of locations in the AnnData store of cell sets, like 'obs/louvain'",
        items: {
          type: "string"
        }
      },
      mappings: {
        patternProperties: {
          ".": {
            type: "object",
            description: "An object containing key-values for mappings like { UMAP: { key: 'obsm/X_umap', dims: [0, 1] } }.",
            additionalProperties: false,
            required: ["key"],
            properties: {
              key: {
                type: "string",
                description: "Where to look in the AnnData store for this mapping, like 'obsm/X_umap.'"
              },
              dims: {
                type: "array",
                description: "Which indices of the obsm object to take for a scatterplot, allowing for, for example, different PCs from obsm/X_pca",
                minItems: 2,
                maxItems: 2,
                items: { type: "number" }
              }
            }
          }
        }
      }
    }
  },
  annDataExpressionMatrix: {
    type: "object",
    description: "The properties of this object are the configuration for how to fetch the cell x genes matrix",
    additionalProperties: false,
    required: ["matrix"],
    properties: {
      matrix: {
        type: "string",
        description: "The location in the AnnData store of the cell x gene matrix, like 'obsm/hvg_subset.' or 'X'"
      },
      geneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the genes if using a subset of the data, like 'var.highly_variable.' if the matrix comes from 'obsm/hvg_subset.'"
      },
      matrixGeneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the matrix data (used in heatmap and histogram), like 'var.highly_variable.''"
      },
      geneAlias: {
        type: "string",
        description: "The location in the AnnData store of a different list of names for gene list component, other than the `var` index"
      }
    }
  },
  requestInit: {
    type: "object",
    description: "The properties of this object correspond to the parameters of the JavaScript fetch() function.",
    additionalProperties: false,
    required: [],
    properties: {
      method: {
        type: "string"
      },
      headers: {
        type: "object"
      },
      body: {
        type: "string"
      },
      mode: {
        type: "string"
      },
      credentials: {
        type: "string"
      },
      cache: {
        type: "string"
      },
      redirect: {
        type: "string"
      },
      referrer: {
        type: "string"
      },
      integrity: {
        type: "string"
      }
    }
  },
  rasterLayer: {
    description: "The properties of this object are the rendering settings for the raster layer.",
    additionalProperties: false,
    required: ["channels", "colormap", "index", "opacity"],
    properties: {
      channels: {
        type: "array",
        items: {
          type: "object",
          additionalProperties: false,
          required: ["selection"],
          properties: {
            color: {
              type: "array",
              items: { type: "number" },
              description: "The color to use when rendering this channel under the null colormap."
            },
            selection: {
              type: "object",
              description: "Determines the channel selection, e.g. some Z and time slice."
            },
            slider: {
              type: "array",
              items: { type: "number" },
              description: "Determines the range for color mapping."
            },
            visible: {
              type: "boolean",
              description: "Determines whether this channel of the layer will be rendered in the spatial component."
            }
          }
        }
      },
      colormap: {
        oneOf: [
          {
            type: "string",
            description: "The name of the colormap to use for this layer."
          },
          {
            type: "null",
            description: "Use the solid color definitions."
          }
        ]
      },
      transparentColor: {
        oneOf: [
          {
            type: "array",
            minItems: 3,
            maxItems: 3,
            items: {
              type: "number",
              description: "One of R G or B (0 - 255)."
            },
            description: "Determines the color to be set to opacity 0"
          },
          {
            type: "null",
            description: "No selection."
          }
        ]
      },
      index: {
        type: "number",
        description: "The index of the layer among the array of layers available in the image file."
      },
      opacity: {
        type: "number"
      },
      modelMatrix: {
        oneOf: [
          {
            type: "array",
            minItems: 16,
            maxItems: 16,
            description: "transformation matrix for this layer"
          },
          {
            type: "null",
            description: "Use no transformation."
          }
        ]
      },
      domainType: {
        type: "string",
        enum: ["Full", "Min/Max"],
        description: "Determines the extent of the channel slider input element in the layer controller."
      },
      resolution: {
        type: "number",
        description: "Resolution of 3D volumetric rendering"
      },
      xSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      renderingMode: {
        type: "string",
        description: "Rendering mode of 3D volumetric rendering"
      },
      ySlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      zSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      type: {
        type: "string",
        enum: ["raster", "bitmask"]
      },
      use3d: {
        type: "boolean"
      },
      visible: {
        type: "boolean",
        description: "Determines whether this entire layer will be rendered in the spatial component."
      }
    }
  },
  moleculesLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the molecules layer.",
    additionalProperties: false,
    required: ["visible", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  cellsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the cells layer.",
    additionalProperties: false,
    required: ["visible", "stroked", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      stroked: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  neighborhoodsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the neighborhoods layer.",
    additionalProperties: false,
    required: ["visible"],
    properties: {
      visible: {
        type: "boolean"
      }
    }
  },
  spatialImageLayer: {
    type: "array",
    description: "Array of Spatial Layers",
    items: {
      $ref: "#/definitions/rasterLayer"
    }
  }
};
var additionalProperties14 = false;
var required14 = ["version", "name", "datasets", "layout", "initStrategy"];
var properties14 = {
  name: { type: "string" },
  public: { type: "boolean" },
  description: { type: "string" },
  datasets: {
    type: "array",
    description: "The datasets array defines groups of files, where the files within each dataset reference the same entities (cells, genes, cell sets, etc).",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["uid", "files"],
      properties: {
        uid: { type: "string" },
        name: { type: "string" },
        description: { type: "string" },
        files: {
          type: "array",
          items: {
            type: "object",
            additionalProperties: false,
            required: ["type", "fileType"],
            properties: {
              name: { type: "string" },
              type: { type: "string" },
              fileType: { type: "string" },
              url: { type: "string" },
              options: { oneOf: [{ $ref: "#/definitions/annDataCellSets" }, { $ref: "https://github.com/vitessce/vitessce/#raster" }, { $ref: "#/definitions/annDataCells" }, { $ref: "#/definitions/annDataExpressionMatrix" }] },
              requestInit: { $ref: "#/definitions/requestInit" }
            }
          }
        }
      }
    }
  },
  coordinationSpace: {
    type: "object",
    description: "The coordination space stores the values for each scope of each coordination object.",
    additionalProperties: true,
    required: [],
    properties: {
      dataset: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      obsType: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      featureType: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      featureValueType: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetZ: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingType: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingObsSetPolygonsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingObsSetLabelsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingObsSetLabelSize: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingObsRadius: {
        type: "object",
        patternProperties: {
          ".": {
            type: "number",
            description: "The cell radius value, used when embeddingCellRadiusMode is absolute or relative."
          }
        }
      },
      embeddingObsOpacity: {
        type: "object",
        patternProperties: {
          ".": {
            type: "number",
            description: "The cell opacity value, used when embeddingCellOpacityMode is static."
          }
        }
      },
      embeddingObsRadiusMode: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["manual", "auto"],
            description: "Should data points representing cells be assigned a static (manual) or dynamic (auto, based on zoom level and data extent) radius?"
          }
        }
      },
      embeddingObsOpacityMode: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["manual", "auto"],
            description: "Should data points representing cells be assigned a static (manual) or dynamic (auto, based on zoom level and data extent) opacity?"
          }
        }
      },
      spatialZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      spatialTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationOrbit: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialOrbitAxis: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "string" }
            ]
          }
        }
      },
      spatialAxisFixed: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "Whether or not to have a fixed axis for the camera. Only useful for 3D viewing."
              },
              { type: "boolean" }
            ]
          }
        }
      },
      spatialImageLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/spatialImageLayer" }
            ]
          }
        }
      },
      spatialSegmentationLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/cellsLayer" }
            ]
          }
        }
      },
      spatialNeighborhoodLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/neighborhoodsLayer" }
            ]
          }
        }
      },
      spatialPointLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/moleculesLayer" }
            ]
          }
        }
      },
      heatmapZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      obsFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cells will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      obsHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      obsSetSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto cell set initialization is enabled, cell set selections will be automatically initialized."
              },
              { type: "array" }
            ]
          }
        }
      },
      obsSetHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell sets will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      obsSetColor: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, cell set colors will be automatically initialized."
              },
              {
                type: "array",
                items: {
                  type: "object",
                  additionalProperties: false,
                  required: ["path", "color"],
                  properties: {
                    path: {
                      type: "array",
                      items: { type: "string" }
                    },
                    color: {
                      type: "array",
                      items: { type: "number" }
                    }
                  }
                }
              }
            ]
          }
        }
      },
      obsColorEncoding: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["geneSelection", "cellSetSelection"],
            description: "How should data points representing cells be colored?"
          }
        }
      },
      featureFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      featureHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      featureSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      featureValueTransform: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "string", pattern: "log1p" }
            ]
          }
        }
      },
      featureValueColormap: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      featureValueColormapRange: {
        type: "object",
        patternProperties: {
          ".": { type: "array", items: { type: "number" } }
        }
      },
      genomicZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      additionalObsSets: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              {
                $ref: "https://github.com/vitessce/vitessce/#cell-sets"
              }
            ]
          }
        }
      },
      moleculeHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no molecule will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      }
    }
  },
  layout: { $ref: "#/definitions/components" },
  initStrategy: {
    type: "string",
    enum: ["none", "auto"],
    description: "The initialization strategy determines how missing coordination objects and coordination scope mappings are initially filled in."
  },
  version: {
    type: "string",
    enum: ["1.0.11"],
    description: "The schema version for the view config."
  }
};
var config_1_0_11_schema_default = {
  $schema: $schema18,
  $id: $id18,
  title: title18,
  type: type18,
  definitions: definitions18,
  additionalProperties: additionalProperties14,
  required: required14,
  properties: properties14
};

// src/schemas/config-1.0.12.schema.json
var $schema19 = "http://json-schema.org/draft-07/schema#";
var $id19 = "https://github.com/vitessce/vitessce/#dataset";
var title19 = "Vitessce data set";
var type19 = "object";
var definitions19 = {
  stringOrStringArray: {
    oneOf: [
      { type: "string" },
      { type: "array", items: { type: "string" } }
    ]
  },
  componentCoordinationScopeByValue: {
    type: "object",
    description: "Keys are coordination scopes for the coordinationScopesBy key, values are coordination scopes for the direct parent coordination type.",
    patternProperties: {
      ".": { $ref: "#/definitions/stringOrStringArray" }
    }
  },
  components: {
    description: "The layout array defines the views, or components, rendered in the grid.",
    type: "array",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["component", "x", "y"],
      properties: {
        uid: {
          type: "string",
          description: "A unique identifier for the view, to refer to it in getter and setter functions in object-oriented contexts."
        },
        component: {
          type: "string",
          description: "Specify a component using a name defined in the component registry."
        },
        props: {
          type: "object",
          description: "Extra prop values for the component."
        },
        x: { type: "integer" },
        y: { type: "integer" },
        w: { type: "integer" },
        h: { type: "integer" },
        coordinationScopes: {
          type: "object",
          description: "Component-level coordination scope mappings define which coordination object values a particular component can read and write, for each coordination type.",
          additionalProperties: true,
          required: [],
          properties: {
            dataset: { $ref: "#/definitions/stringOrStringArray" },
            obsType: { $ref: "#/definitions/stringOrStringArray" },
            featureType: { $ref: "#/definitions/stringOrStringArray" },
            featureValueType: { $ref: "#/definitions/stringOrStringArray" },
            embeddingType: { $ref: "#/definitions/stringOrStringArray" },
            embeddingZoom: { $ref: "#/definitions/stringOrStringArray" },
            embeddingRotation: { $ref: "#/definitions/stringOrStringArray" },
            embeddingTargetX: { $ref: "#/definitions/stringOrStringArray" },
            embeddingTargetY: { $ref: "#/definitions/stringOrStringArray" },
            embeddingTargetZ: { $ref: "#/definitions/stringOrStringArray" },
            embeddingObsSetPolygonsVisible: { $ref: "#/definitions/stringOrStringArray" },
            embeddingObsSetLabelsVisible: { $ref: "#/definitions/stringOrStringArray" },
            embeddingObsSetLabelSize: { $ref: "#/definitions/stringOrStringArray" },
            embeddingObsRadius: { $ref: "#/definitions/stringOrStringArray" },
            embeddingObsOpacity: { $ref: "#/definitions/stringOrStringArray" },
            embeddingObsRadiusMode: { $ref: "#/definitions/stringOrStringArray" },
            embeddingObsOpacityMode: { $ref: "#/definitions/stringOrStringArray" },
            spatialZoom: { $ref: "#/definitions/stringOrStringArray" },
            spatialRotation: { $ref: "#/definitions/stringOrStringArray" },
            spatialTargetX: { $ref: "#/definitions/stringOrStringArray" },
            spatialTargetY: { $ref: "#/definitions/stringOrStringArray" },
            spatialTargetZ: { $ref: "#/definitions/stringOrStringArray" },
            spatialRotationX: { $ref: "#/definitions/stringOrStringArray" },
            spatialRotationY: { $ref: "#/definitions/stringOrStringArray" },
            spatialRotationZ: { $ref: "#/definitions/stringOrStringArray" },
            spatialRotationOrbit: { $ref: "#/definitions/stringOrStringArray" },
            spatialOrbitAxis: { $ref: "#/definitions/stringOrStringArray" },
            spatialAxisFixed: { $ref: "#/definitions/stringOrStringArray" },
            heatmapZoomX: { $ref: "#/definitions/stringOrStringArray" },
            heatmapZoomY: { $ref: "#/definitions/stringOrStringArray" },
            heatmapTargetX: { $ref: "#/definitions/stringOrStringArray" },
            heatmapTargetY: { $ref: "#/definitions/stringOrStringArray" },
            obsFilter: { $ref: "#/definitions/stringOrStringArray" },
            obsHighlight: { $ref: "#/definitions/stringOrStringArray" },
            obsSetSelection: { $ref: "#/definitions/stringOrStringArray" },
            obsSetHighlight: { $ref: "#/definitions/stringOrStringArray" },
            obsSetColor: { $ref: "#/definitions/stringOrStringArray" },
            featureFilter: { $ref: "#/definitions/stringOrStringArray" },
            featureHighlight: { $ref: "#/definitions/stringOrStringArray" },
            featureSelection: { $ref: "#/definitions/stringOrStringArray" },
            featureValueTransform: { $ref: "#/definitions/stringOrStringArray" },
            featureValueColormap: { $ref: "#/definitions/stringOrStringArray" },
            featureValueColormapRange: { $ref: "#/definitions/stringOrStringArray" },
            obsColorEncoding: { $ref: "#/definitions/stringOrStringArray" },
            spatialImageLayer: { $ref: "#/definitions/stringOrStringArray" },
            spatialSegmentationLayer: { $ref: "#/definitions/stringOrStringArray" },
            spatialPointLayer: { $ref: "#/definitions/stringOrStringArray" },
            spatialNeighborhoodLayer: { $ref: "#/definitions/stringOrStringArray" },
            genomicZoomX: { $ref: "#/definitions/stringOrStringArray" },
            genomicZoomY: { $ref: "#/definitions/stringOrStringArray" },
            genomicTargetX: { $ref: "#/definitions/stringOrStringArray" },
            genomicTargetY: { $ref: "#/definitions/stringOrStringArray" },
            additionalObsSets: { $ref: "#/definitions/stringOrStringArray" },
            moleculeHighlight: { $ref: "#/definitions/stringOrStringArray" }
          }
        },
        coordinationScopesBy: {
          type: "object",
          description: "Component-level and coordination type-level coordination scope mappings. Keys are coordination types.",
          additionalProperties: true,
          required: [],
          patternProperties: {
            ".": {
              type: "object",
              description: "Coordination type-level coordination scope mappings. Keys are coordination types. Values are objects.",
              additionalProperties: true,
              required: [],
              patternProperties: {
                ".": {
                  $ref: "#/definitions/componentCoordinationScopeByValue"
                }
              }
            }
          }
        }
      }
    }
  },
  annDataCellSets: {
    type: "array",
    description: "Array of cell set configuration, following closely the conventions of the tabular schema",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["groupName", "setName"],
      properties: {
        groupName: {
          type: "string",
          description: "The display name for the set, like 'Cell Type' or 'Louvain.'"
        },
        setName: {
          oneOf: [
            {
              type: "string",
              description: "The location in the AnnData store for the set, like 'obs/louvain' or 'obs/celltype.'"
            },
            {
              type: "array",
              items: { type: "string" },
              description: "An array of locations in the AnnData store for a hierarchy of set names, from coarse to fine levels."
            }
          ]
        },
        scoreName: {
          oneOf: [
            {
              type: "string",
              description: "The location in the AnnData store for the set confidence scores, like 'obs/celltype_prediction_score.'"
            }
          ]
        }
      }
    }
  },
  annDataCells: {
    type: "object",
    description: "The properties of this object are the configuration for how to layout scatterplots and spatial information",
    minProperties: 1,
    additionalProperties: false,
    required: [],
    properties: {
      xy: {
        type: "string",
        description: "The location in the AnnData store of cell centroids, like 'obsm/X_centroids.'"
      },
      poly: {
        type: "string",
        description: "The location in the AnnData store of cell polygon outlines, like 'obsm/X_polygons.'"
      },
      factors: {
        type: "array",
        description: "List of locations in the AnnData store of cell sets, like 'obs/louvain'",
        items: {
          type: "string"
        }
      },
      mappings: {
        patternProperties: {
          ".": {
            type: "object",
            description: "An object containing key-values for mappings like { UMAP: { key: 'obsm/X_umap', dims: [0, 1] } }.",
            additionalProperties: false,
            required: ["key"],
            properties: {
              key: {
                type: "string",
                description: "Where to look in the AnnData store for this mapping, like 'obsm/X_umap.'"
              },
              dims: {
                type: "array",
                description: "Which indices of the obsm object to take for a scatterplot, allowing for, for example, different PCs from obsm/X_pca",
                minItems: 2,
                maxItems: 2,
                items: { type: "number" }
              }
            }
          }
        }
      }
    }
  },
  annDataExpressionMatrix: {
    type: "object",
    description: "The properties of this object are the configuration for how to fetch the cell x genes matrix",
    additionalProperties: false,
    required: ["matrix"],
    properties: {
      matrix: {
        type: "string",
        description: "The location in the AnnData store of the cell x gene matrix, like 'obsm/hvg_subset.' or 'X'"
      },
      geneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the genes if using a subset of the data, like 'var.highly_variable.' if the matrix comes from 'obsm/hvg_subset.'"
      },
      matrixGeneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the matrix data (used in heatmap and histogram), like 'var.highly_variable.''"
      },
      geneAlias: {
        type: "string",
        description: "The location in the AnnData store of a different list of names for gene list component, other than the `var` index"
      }
    }
  },
  requestInit: {
    type: "object",
    description: "The properties of this object correspond to the parameters of the JavaScript fetch() function.",
    additionalProperties: false,
    required: [],
    properties: {
      method: {
        type: "string"
      },
      headers: {
        type: "object"
      },
      body: {
        type: "string"
      },
      mode: {
        type: "string"
      },
      credentials: {
        type: "string"
      },
      cache: {
        type: "string"
      },
      redirect: {
        type: "string"
      },
      referrer: {
        type: "string"
      },
      integrity: {
        type: "string"
      }
    }
  },
  rasterLayer: {
    description: "The properties of this object are the rendering settings for the raster layer.",
    additionalProperties: false,
    required: ["channels", "colormap", "index", "opacity"],
    properties: {
      channels: {
        type: "array",
        items: {
          type: "object",
          additionalProperties: false,
          required: ["selection"],
          properties: {
            color: {
              type: "array",
              items: { type: "number" },
              description: "The color to use when rendering this channel under the null colormap."
            },
            selection: {
              type: "object",
              description: "Determines the channel selection, e.g. some Z and time slice."
            },
            slider: {
              type: "array",
              items: { type: "number" },
              description: "Determines the range for color mapping."
            },
            visible: {
              type: "boolean",
              description: "Determines whether this channel of the layer will be rendered in the spatial component."
            }
          }
        }
      },
      colormap: {
        oneOf: [
          {
            type: "string",
            description: "The name of the colormap to use for this layer."
          },
          {
            type: "null",
            description: "Use the solid color definitions."
          }
        ]
      },
      transparentColor: {
        oneOf: [
          {
            type: "array",
            minItems: 3,
            maxItems: 3,
            items: {
              type: "number",
              description: "One of R G or B (0 - 255)."
            },
            description: "Determines the color to be set to opacity 0"
          },
          {
            type: "null",
            description: "No selection."
          }
        ]
      },
      index: {
        type: "number",
        description: "The index of the layer among the array of layers available in the image file."
      },
      opacity: {
        type: "number"
      },
      modelMatrix: {
        oneOf: [
          {
            type: "array",
            minItems: 16,
            maxItems: 16,
            description: "transformation matrix for this layer"
          },
          {
            type: "null",
            description: "Use no transformation."
          }
        ]
      },
      domainType: {
        type: "string",
        enum: ["Full", "Min/Max"],
        description: "Determines the extent of the channel slider input element in the layer controller."
      },
      resolution: {
        type: "number",
        description: "Resolution of 3D volumetric rendering"
      },
      xSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      renderingMode: {
        type: "string",
        description: "Rendering mode of 3D volumetric rendering"
      },
      ySlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      zSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      type: {
        type: "string",
        enum: ["raster", "bitmask"]
      },
      use3d: {
        type: "boolean"
      },
      visible: {
        type: "boolean",
        description: "Determines whether this entire layer will be rendered in the spatial component."
      }
    }
  },
  moleculesLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the molecules layer.",
    additionalProperties: false,
    required: ["visible", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  cellsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the cells layer.",
    additionalProperties: false,
    required: ["visible", "stroked", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      stroked: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  neighborhoodsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the neighborhoods layer.",
    additionalProperties: false,
    required: ["visible"],
    properties: {
      visible: {
        type: "boolean"
      }
    }
  },
  spatialImageLayer: {
    type: "array",
    description: "Array of Spatial Layers",
    items: {
      $ref: "#/definitions/rasterLayer"
    }
  }
};
var additionalProperties15 = false;
var required15 = ["version", "name", "datasets", "layout", "initStrategy"];
var properties15 = {
  name: { type: "string" },
  public: { type: "boolean" },
  description: { type: "string" },
  datasets: {
    type: "array",
    description: "The datasets array defines groups of files, where the files within each dataset reference the same entities (cells, genes, cell sets, etc).",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["uid", "files"],
      properties: {
        uid: { type: "string" },
        name: { type: "string" },
        description: { type: "string" },
        files: {
          type: "array",
          items: {
            type: "object",
            additionalProperties: false,
            required: ["type", "fileType"],
            properties: {
              name: { type: "string" },
              type: { type: "string" },
              fileType: { type: "string" },
              url: { type: "string" },
              options: { oneOf: [{ $ref: "#/definitions/annDataCellSets" }, { $ref: "https://github.com/vitessce/vitessce/#raster" }, { $ref: "#/definitions/annDataCells" }, { $ref: "#/definitions/annDataExpressionMatrix" }] },
              requestInit: { $ref: "#/definitions/requestInit" }
            }
          }
        }
      }
    }
  },
  coordinationSpace: {
    type: "object",
    description: "The coordination space stores the values for each scope of each coordination object.",
    additionalProperties: true,
    required: [],
    properties: {
      dataset: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      obsType: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      featureType: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      featureValueType: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetZ: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingType: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingObsSetPolygonsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingObsSetLabelsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingObsSetLabelSize: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingObsRadius: {
        type: "object",
        patternProperties: {
          ".": {
            type: "number",
            description: "The cell radius value, used when embeddingCellRadiusMode is absolute or relative."
          }
        }
      },
      embeddingObsOpacity: {
        type: "object",
        patternProperties: {
          ".": {
            type: "number",
            description: "The cell opacity value, used when embeddingCellOpacityMode is static."
          }
        }
      },
      embeddingObsRadiusMode: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["manual", "auto"],
            description: "Should data points representing cells be assigned a static (manual) or dynamic (auto, based on zoom level and data extent) radius?"
          }
        }
      },
      embeddingObsOpacityMode: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["manual", "auto"],
            description: "Should data points representing cells be assigned a static (manual) or dynamic (auto, based on zoom level and data extent) opacity?"
          }
        }
      },
      spatialZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      spatialTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationOrbit: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialOrbitAxis: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "string" }
            ]
          }
        }
      },
      spatialAxisFixed: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "Whether or not to have a fixed axis for the camera. Only useful for 3D viewing."
              },
              { type: "boolean" }
            ]
          }
        }
      },
      spatialImageLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/spatialImageLayer" }
            ]
          }
        }
      },
      spatialSegmentationLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/cellsLayer" }
            ]
          }
        }
      },
      spatialNeighborhoodLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/neighborhoodsLayer" }
            ]
          }
        }
      },
      spatialPointLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/moleculesLayer" }
            ]
          }
        }
      },
      heatmapZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      obsFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cells will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      obsHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      obsSetSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto cell set initialization is enabled, cell set selections will be automatically initialized."
              },
              { type: "array" }
            ]
          }
        }
      },
      obsSetHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell sets will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      obsSetColor: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, cell set colors will be automatically initialized."
              },
              {
                type: "array",
                items: {
                  type: "object",
                  additionalProperties: false,
                  required: ["path", "color"],
                  properties: {
                    path: {
                      type: "array",
                      items: { type: "string" }
                    },
                    color: {
                      type: "array",
                      items: { type: "number" }
                    }
                  }
                }
              }
            ]
          }
        }
      },
      obsColorEncoding: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["geneSelection", "cellSetSelection"],
            description: "How should data points representing cells be colored?"
          }
        }
      },
      featureFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      featureHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      featureSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      featureValueTransform: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "string", pattern: "log1p" }
            ]
          }
        }
      },
      featureValueColormap: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      featureValueColormapRange: {
        type: "object",
        patternProperties: {
          ".": { type: "array", items: { type: "number" } }
        }
      },
      genomicZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      additionalObsSets: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              {
                $ref: "https://github.com/vitessce/vitessce/#cell-sets"
              }
            ]
          }
        }
      },
      moleculeHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no molecule will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      }
    }
  },
  layout: { $ref: "#/definitions/components" },
  initStrategy: {
    type: "string",
    enum: ["none", "auto"],
    description: "The initialization strategy determines how missing coordination objects and coordination scope mappings are initially filled in."
  },
  version: {
    type: "string",
    enum: ["1.0.12"],
    description: "The schema version for the view config."
  }
};
var config_1_0_12_schema_default = {
  $schema: $schema19,
  $id: $id19,
  title: title19,
  type: type19,
  definitions: definitions19,
  additionalProperties: additionalProperties15,
  required: required15,
  properties: properties15
};

// src/schemas/config-1.0.13.schema.json
var $schema20 = "http://json-schema.org/draft-07/schema#";
var $id20 = "https://github.com/vitessce/vitessce/#dataset";
var title20 = "Vitessce data set";
var type20 = "object";
var definitions20 = {
  stringOrStringArray: {
    oneOf: [
      { type: "string" },
      { type: "array", items: { type: "string" } }
    ]
  },
  componentCoordinationScopeByValue: {
    type: "object",
    description: "Keys are coordination scopes for the coordinationScopesBy key, values are coordination scopes for the direct parent coordination type.",
    patternProperties: {
      ".": { $ref: "#/definitions/stringOrStringArray" }
    }
  },
  components: {
    description: "The layout array defines the views, or components, rendered in the grid.",
    type: "array",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["component", "x", "y"],
      properties: {
        uid: {
          type: "string",
          description: "A unique identifier for the view, to refer to it in getter and setter functions in object-oriented contexts."
        },
        component: {
          type: "string",
          description: "Specify a component using a name defined in the component registry."
        },
        props: {
          type: "object",
          description: "Extra prop values for the component."
        },
        x: { type: "integer" },
        y: { type: "integer" },
        w: { type: "integer" },
        h: { type: "integer" },
        coordinationScopes: {
          type: "object",
          description: "Component-level coordination scope mappings define which coordination object values a particular component can read and write, for each coordination type.",
          additionalProperties: true,
          required: [],
          properties: {
            dataset: { $ref: "#/definitions/stringOrStringArray" },
            obsType: { $ref: "#/definitions/stringOrStringArray" },
            featureType: { $ref: "#/definitions/stringOrStringArray" },
            featureValueType: { $ref: "#/definitions/stringOrStringArray" },
            embeddingType: { $ref: "#/definitions/stringOrStringArray" },
            embeddingZoom: { $ref: "#/definitions/stringOrStringArray" },
            embeddingRotation: { $ref: "#/definitions/stringOrStringArray" },
            embeddingTargetX: { $ref: "#/definitions/stringOrStringArray" },
            embeddingTargetY: { $ref: "#/definitions/stringOrStringArray" },
            embeddingTargetZ: { $ref: "#/definitions/stringOrStringArray" },
            embeddingObsSetPolygonsVisible: { $ref: "#/definitions/stringOrStringArray" },
            embeddingObsSetLabelsVisible: { $ref: "#/definitions/stringOrStringArray" },
            embeddingObsSetLabelSize: { $ref: "#/definitions/stringOrStringArray" },
            embeddingObsRadius: { $ref: "#/definitions/stringOrStringArray" },
            embeddingObsOpacity: { $ref: "#/definitions/stringOrStringArray" },
            embeddingObsRadiusMode: { $ref: "#/definitions/stringOrStringArray" },
            embeddingObsOpacityMode: { $ref: "#/definitions/stringOrStringArray" },
            spatialZoom: { $ref: "#/definitions/stringOrStringArray" },
            spatialRotation: { $ref: "#/definitions/stringOrStringArray" },
            spatialTargetX: { $ref: "#/definitions/stringOrStringArray" },
            spatialTargetY: { $ref: "#/definitions/stringOrStringArray" },
            spatialTargetZ: { $ref: "#/definitions/stringOrStringArray" },
            spatialRotationX: { $ref: "#/definitions/stringOrStringArray" },
            spatialRotationY: { $ref: "#/definitions/stringOrStringArray" },
            spatialRotationZ: { $ref: "#/definitions/stringOrStringArray" },
            spatialRotationOrbit: { $ref: "#/definitions/stringOrStringArray" },
            spatialOrbitAxis: { $ref: "#/definitions/stringOrStringArray" },
            spatialAxisFixed: { $ref: "#/definitions/stringOrStringArray" },
            heatmapZoomX: { $ref: "#/definitions/stringOrStringArray" },
            heatmapZoomY: { $ref: "#/definitions/stringOrStringArray" },
            heatmapTargetX: { $ref: "#/definitions/stringOrStringArray" },
            heatmapTargetY: { $ref: "#/definitions/stringOrStringArray" },
            obsFilter: { $ref: "#/definitions/stringOrStringArray" },
            obsHighlight: { $ref: "#/definitions/stringOrStringArray" },
            obsSetSelection: { $ref: "#/definitions/stringOrStringArray" },
            obsSetHighlight: { $ref: "#/definitions/stringOrStringArray" },
            obsSetColor: { $ref: "#/definitions/stringOrStringArray" },
            featureFilter: { $ref: "#/definitions/stringOrStringArray" },
            featureHighlight: { $ref: "#/definitions/stringOrStringArray" },
            featureSelection: { $ref: "#/definitions/stringOrStringArray" },
            featureValueTransform: { $ref: "#/definitions/stringOrStringArray" },
            featureValueColormap: { $ref: "#/definitions/stringOrStringArray" },
            featureValueColormapRange: { $ref: "#/definitions/stringOrStringArray" },
            obsColorEncoding: { $ref: "#/definitions/stringOrStringArray" },
            spatialImageLayer: { $ref: "#/definitions/stringOrStringArray" },
            spatialSegmentationLayer: { $ref: "#/definitions/stringOrStringArray" },
            spatialPointLayer: { $ref: "#/definitions/stringOrStringArray" },
            spatialNeighborhoodLayer: { $ref: "#/definitions/stringOrStringArray" },
            genomicZoomX: { $ref: "#/definitions/stringOrStringArray" },
            genomicZoomY: { $ref: "#/definitions/stringOrStringArray" },
            genomicTargetX: { $ref: "#/definitions/stringOrStringArray" },
            genomicTargetY: { $ref: "#/definitions/stringOrStringArray" },
            additionalObsSets: { $ref: "#/definitions/stringOrStringArray" },
            moleculeHighlight: { $ref: "#/definitions/stringOrStringArray" }
          }
        },
        coordinationScopesBy: {
          type: "object",
          description: "Component-level and coordination type-level coordination scope mappings. Keys are coordination types.",
          additionalProperties: true,
          required: [],
          patternProperties: {
            ".": {
              type: "object",
              description: "Coordination type-level coordination scope mappings. Keys are coordination types. Values are objects.",
              additionalProperties: true,
              required: [],
              patternProperties: {
                ".": {
                  $ref: "#/definitions/componentCoordinationScopeByValue"
                }
              }
            }
          }
        }
      }
    }
  },
  annDataCellSets: {
    type: "array",
    description: "Array of cell set configuration, following closely the conventions of the tabular schema",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["groupName", "setName"],
      properties: {
        groupName: {
          type: "string",
          description: "The display name for the set, like 'Cell Type' or 'Louvain.'"
        },
        setName: {
          oneOf: [
            {
              type: "string",
              description: "The location in the AnnData store for the set, like 'obs/louvain' or 'obs/celltype.'"
            },
            {
              type: "array",
              items: { type: "string" },
              description: "An array of locations in the AnnData store for a hierarchy of set names, from coarse to fine levels."
            }
          ]
        },
        scoreName: {
          oneOf: [
            {
              type: "string",
              description: "The location in the AnnData store for the set confidence scores, like 'obs/celltype_prediction_score.'"
            }
          ]
        }
      }
    }
  },
  annDataCells: {
    type: "object",
    description: "The properties of this object are the configuration for how to layout scatterplots and spatial information",
    minProperties: 1,
    additionalProperties: false,
    required: [],
    properties: {
      xy: {
        type: "string",
        description: "The location in the AnnData store of cell centroids, like 'obsm/X_centroids.'"
      },
      poly: {
        type: "string",
        description: "The location in the AnnData store of cell polygon outlines, like 'obsm/X_polygons.'"
      },
      factors: {
        type: "array",
        description: "List of locations in the AnnData store of cell sets, like 'obs/louvain'",
        items: {
          type: "string"
        }
      },
      mappings: {
        patternProperties: {
          ".": {
            type: "object",
            description: "An object containing key-values for mappings like { UMAP: { key: 'obsm/X_umap', dims: [0, 1] } }.",
            additionalProperties: false,
            required: ["key"],
            properties: {
              key: {
                type: "string",
                description: "Where to look in the AnnData store for this mapping, like 'obsm/X_umap.'"
              },
              dims: {
                type: "array",
                description: "Which indices of the obsm object to take for a scatterplot, allowing for, for example, different PCs from obsm/X_pca",
                minItems: 2,
                maxItems: 2,
                items: { type: "number" }
              }
            }
          }
        }
      }
    }
  },
  annDataExpressionMatrix: {
    type: "object",
    description: "The properties of this object are the configuration for how to fetch the cell x genes matrix",
    additionalProperties: false,
    required: ["matrix"],
    properties: {
      matrix: {
        type: "string",
        description: "The location in the AnnData store of the cell x gene matrix, like 'obsm/hvg_subset.' or 'X'"
      },
      geneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the genes if using a subset of the data, like 'var.highly_variable.' if the matrix comes from 'obsm/hvg_subset.'"
      },
      matrixGeneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the matrix data (used in heatmap and histogram), like 'var.highly_variable.''"
      },
      geneAlias: {
        type: "string",
        description: "The location in the AnnData store of a different list of names for gene list component, other than the `var` index"
      }
    }
  },
  requestInit: {
    type: "object",
    description: "The properties of this object correspond to the parameters of the JavaScript fetch() function.",
    additionalProperties: false,
    required: [],
    properties: {
      method: {
        type: "string"
      },
      headers: {
        type: "object"
      },
      body: {
        type: "string"
      },
      mode: {
        type: "string"
      },
      credentials: {
        type: "string"
      },
      cache: {
        type: "string"
      },
      redirect: {
        type: "string"
      },
      referrer: {
        type: "string"
      },
      integrity: {
        type: "string"
      }
    }
  },
  rasterLayer: {
    description: "The properties of this object are the rendering settings for the raster layer.",
    additionalProperties: false,
    required: ["channels", "colormap", "index", "opacity"],
    properties: {
      channels: {
        type: "array",
        items: {
          type: "object",
          additionalProperties: false,
          required: ["selection"],
          properties: {
            color: {
              type: "array",
              items: { type: "number" },
              description: "The color to use when rendering this channel under the null colormap."
            },
            selection: {
              type: "object",
              description: "Determines the channel selection, e.g. some Z and time slice."
            },
            slider: {
              type: "array",
              items: { type: "number" },
              description: "Determines the range for color mapping."
            },
            visible: {
              type: "boolean",
              description: "Determines whether this channel of the layer will be rendered in the spatial component."
            }
          }
        }
      },
      colormap: {
        oneOf: [
          {
            type: "string",
            description: "The name of the colormap to use for this layer."
          },
          {
            type: "null",
            description: "Use the solid color definitions."
          }
        ]
      },
      transparentColor: {
        oneOf: [
          {
            type: "array",
            minItems: 3,
            maxItems: 3,
            items: {
              type: "number",
              description: "One of R G or B (0 - 255)."
            },
            description: "Determines the color to be set to opacity 0"
          },
          {
            type: "null",
            description: "No selection."
          }
        ]
      },
      index: {
        type: "number",
        description: "The index of the layer among the array of layers available in the image file."
      },
      opacity: {
        type: "number"
      },
      modelMatrix: {
        oneOf: [
          {
            type: "array",
            minItems: 16,
            maxItems: 16,
            description: "transformation matrix for this layer"
          },
          {
            type: "null",
            description: "Use no transformation."
          }
        ]
      },
      domainType: {
        type: "string",
        enum: ["Full", "Min/Max"],
        description: "Determines the extent of the channel slider input element in the layer controller."
      },
      resolution: {
        type: "number",
        description: "Resolution of 3D volumetric rendering"
      },
      xSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      renderingMode: {
        type: "string",
        description: "Rendering mode of 3D volumetric rendering"
      },
      ySlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      zSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      type: {
        type: "string",
        enum: ["raster", "bitmask"]
      },
      use3d: {
        type: "boolean"
      },
      visible: {
        type: "boolean",
        description: "Determines whether this entire layer will be rendered in the spatial component."
      }
    }
  },
  moleculesLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the molecules layer.",
    additionalProperties: false,
    required: ["visible", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  cellsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the cells layer.",
    additionalProperties: false,
    required: ["visible", "stroked", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      stroked: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  neighborhoodsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the neighborhoods layer.",
    additionalProperties: false,
    required: ["visible"],
    properties: {
      visible: {
        type: "boolean"
      }
    }
  },
  spatialImageLayer: {
    type: "array",
    description: "Array of Spatial Layers",
    items: {
      $ref: "#/definitions/rasterLayer"
    }
  }
};
var additionalProperties16 = false;
var required16 = ["version", "name", "datasets", "layout", "initStrategy"];
var properties16 = {
  name: { type: "string" },
  public: { type: "boolean" },
  description: { type: "string" },
  datasets: {
    type: "array",
    description: "The datasets array defines groups of files, where the files within each dataset reference the same entities (cells, genes, cell sets, etc).",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["uid", "files"],
      properties: {
        uid: { type: "string" },
        name: { type: "string" },
        description: { type: "string" },
        files: {
          type: "array",
          items: {
            type: "object",
            additionalProperties: false,
            required: ["type", "fileType"],
            properties: {
              name: { type: "string" },
              type: { type: "string" },
              fileType: { type: "string" },
              url: { type: "string" },
              options: { oneOf: [{ $ref: "#/definitions/annDataCellSets" }, { $ref: "https://github.com/vitessce/vitessce/#raster" }, { $ref: "#/definitions/annDataCells" }, { $ref: "#/definitions/annDataExpressionMatrix" }] },
              requestInit: { $ref: "#/definitions/requestInit" },
              coordinationValues: {
                type: "object",
                description: "Keys are coordination types. Values are coordination values. Used for matching views to files.",
                patternProperties: {
                  ".": {
                    oneOf: [
                      { type: "string" }
                    ]
                  }
                }
              }
            }
          }
        }
      }
    }
  },
  coordinationSpace: {
    type: "object",
    description: "The coordination space stores the values for each scope of each coordination object.",
    additionalProperties: true,
    required: [],
    properties: {
      dataset: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      obsType: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      featureType: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      featureValueType: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetZ: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingType: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingObsSetPolygonsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingObsSetLabelsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingObsSetLabelSize: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingObsRadius: {
        type: "object",
        patternProperties: {
          ".": {
            type: "number",
            description: "The cell radius value, used when embeddingCellRadiusMode is absolute or relative."
          }
        }
      },
      embeddingObsOpacity: {
        type: "object",
        patternProperties: {
          ".": {
            type: "number",
            description: "The cell opacity value, used when embeddingCellOpacityMode is static."
          }
        }
      },
      embeddingObsRadiusMode: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["manual", "auto"],
            description: "Should data points representing cells be assigned a static (manual) or dynamic (auto, based on zoom level and data extent) radius?"
          }
        }
      },
      embeddingObsOpacityMode: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["manual", "auto"],
            description: "Should data points representing cells be assigned a static (manual) or dynamic (auto, based on zoom level and data extent) opacity?"
          }
        }
      },
      spatialZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      spatialTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationOrbit: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialOrbitAxis: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "string" }
            ]
          }
        }
      },
      spatialAxisFixed: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "Whether or not to have a fixed axis for the camera. Only useful for 3D viewing."
              },
              { type: "boolean" }
            ]
          }
        }
      },
      spatialImageLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/spatialImageLayer" }
            ]
          }
        }
      },
      spatialSegmentationLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/cellsLayer" }
            ]
          }
        }
      },
      spatialNeighborhoodLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/neighborhoodsLayer" }
            ]
          }
        }
      },
      spatialPointLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/moleculesLayer" }
            ]
          }
        }
      },
      heatmapZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      obsFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cells will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      obsHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      obsSetSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto cell set initialization is enabled, cell set selections will be automatically initialized."
              },
              { type: "array" }
            ]
          }
        }
      },
      obsSetHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell sets will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      obsSetColor: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, cell set colors will be automatically initialized."
              },
              {
                type: "array",
                items: {
                  type: "object",
                  additionalProperties: false,
                  required: ["path", "color"],
                  properties: {
                    path: {
                      type: "array",
                      items: { type: "string" }
                    },
                    color: {
                      type: "array",
                      items: { type: "number" }
                    }
                  }
                }
              }
            ]
          }
        }
      },
      obsColorEncoding: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["geneSelection", "cellSetSelection"],
            description: "How should data points representing cells be colored?"
          }
        }
      },
      featureFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      featureHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      featureSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      featureValueTransform: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "string", pattern: "log1p" }
            ]
          }
        }
      },
      featureValueColormap: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      featureValueColormapRange: {
        type: "object",
        patternProperties: {
          ".": { type: "array", items: { type: "number" } }
        }
      },
      genomicZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      additionalObsSets: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              {
                $ref: "https://github.com/vitessce/vitessce/#cell-sets"
              }
            ]
          }
        }
      },
      moleculeHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no molecule will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      }
    }
  },
  layout: { $ref: "#/definitions/components" },
  initStrategy: {
    type: "string",
    enum: ["none", "auto"],
    description: "The initialization strategy determines how missing coordination objects and coordination scope mappings are initially filled in."
  },
  version: {
    type: "string",
    enum: ["1.0.13"],
    description: "The schema version for the view config."
  }
};
var config_1_0_13_schema_default = {
  $schema: $schema20,
  $id: $id20,
  title: title20,
  type: type20,
  definitions: definitions20,
  additionalProperties: additionalProperties16,
  required: required16,
  properties: properties16
};

// src/schemas/config-1.0.14.schema.json
var $schema21 = "http://json-schema.org/draft-07/schema#";
var $id21 = "https://github.com/vitessce/vitessce/#dataset";
var title21 = "Vitessce data set";
var type21 = "object";
var definitions21 = {
  stringOrStringArray: {
    oneOf: [
      { type: "string" },
      { type: "array", items: { type: "string" } }
    ]
  },
  componentCoordinationScopeByValue: {
    type: "object",
    description: "Keys are coordination scopes for the coordinationScopesBy key, values are coordination scopes for the direct parent coordination type.",
    patternProperties: {
      ".": { $ref: "#/definitions/stringOrStringArray" }
    }
  },
  components: {
    description: "The layout array defines the views, or components, rendered in the grid.",
    type: "array",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["component", "x", "y"],
      properties: {
        uid: {
          type: "string",
          description: "A unique identifier for the view, to refer to it in getter and setter functions in object-oriented contexts."
        },
        component: {
          type: "string",
          description: "Specify a component using a name defined in the component registry."
        },
        props: {
          type: "object",
          description: "Extra prop values for the component."
        },
        x: { type: "integer" },
        y: { type: "integer" },
        w: { type: "integer" },
        h: { type: "integer" },
        coordinationValues: {
          type: "object",
          description: "Component-level coordination values. This value will apply to only this one view and is a shortcut which bypasses the coordinated multiple view functionality.",
          additionalProperties: true,
          required: [],
          properties: {}
        },
        coordinationScopes: {
          type: "object",
          description: "Component-level coordination scope mappings define which coordination object values a particular component can read and write, for each coordination type.",
          additionalProperties: true,
          required: [],
          properties: {
            dataset: { $ref: "#/definitions/stringOrStringArray" },
            obsType: { $ref: "#/definitions/stringOrStringArray" },
            featureType: { $ref: "#/definitions/stringOrStringArray" },
            featureValueType: { $ref: "#/definitions/stringOrStringArray" },
            embeddingType: { $ref: "#/definitions/stringOrStringArray" },
            embeddingZoom: { $ref: "#/definitions/stringOrStringArray" },
            embeddingRotation: { $ref: "#/definitions/stringOrStringArray" },
            embeddingTargetX: { $ref: "#/definitions/stringOrStringArray" },
            embeddingTargetY: { $ref: "#/definitions/stringOrStringArray" },
            embeddingTargetZ: { $ref: "#/definitions/stringOrStringArray" },
            embeddingObsSetPolygonsVisible: { $ref: "#/definitions/stringOrStringArray" },
            embeddingObsSetLabelsVisible: { $ref: "#/definitions/stringOrStringArray" },
            embeddingObsSetLabelSize: { $ref: "#/definitions/stringOrStringArray" },
            embeddingObsRadius: { $ref: "#/definitions/stringOrStringArray" },
            embeddingObsOpacity: { $ref: "#/definitions/stringOrStringArray" },
            embeddingObsRadiusMode: { $ref: "#/definitions/stringOrStringArray" },
            embeddingObsOpacityMode: { $ref: "#/definitions/stringOrStringArray" },
            spatialZoom: { $ref: "#/definitions/stringOrStringArray" },
            spatialRotation: { $ref: "#/definitions/stringOrStringArray" },
            spatialTargetX: { $ref: "#/definitions/stringOrStringArray" },
            spatialTargetY: { $ref: "#/definitions/stringOrStringArray" },
            spatialTargetZ: { $ref: "#/definitions/stringOrStringArray" },
            spatialRotationX: { $ref: "#/definitions/stringOrStringArray" },
            spatialRotationY: { $ref: "#/definitions/stringOrStringArray" },
            spatialRotationZ: { $ref: "#/definitions/stringOrStringArray" },
            spatialRotationOrbit: { $ref: "#/definitions/stringOrStringArray" },
            spatialOrbitAxis: { $ref: "#/definitions/stringOrStringArray" },
            spatialAxisFixed: { $ref: "#/definitions/stringOrStringArray" },
            heatmapZoomX: { $ref: "#/definitions/stringOrStringArray" },
            heatmapZoomY: { $ref: "#/definitions/stringOrStringArray" },
            heatmapTargetX: { $ref: "#/definitions/stringOrStringArray" },
            heatmapTargetY: { $ref: "#/definitions/stringOrStringArray" },
            obsFilter: { $ref: "#/definitions/stringOrStringArray" },
            obsHighlight: { $ref: "#/definitions/stringOrStringArray" },
            obsSetSelection: { $ref: "#/definitions/stringOrStringArray" },
            obsSetHighlight: { $ref: "#/definitions/stringOrStringArray" },
            obsSetColor: { $ref: "#/definitions/stringOrStringArray" },
            featureFilter: { $ref: "#/definitions/stringOrStringArray" },
            featureHighlight: { $ref: "#/definitions/stringOrStringArray" },
            featureSelection: { $ref: "#/definitions/stringOrStringArray" },
            featureValueTransform: { $ref: "#/definitions/stringOrStringArray" },
            featureValueColormap: { $ref: "#/definitions/stringOrStringArray" },
            featureValueColormapRange: { $ref: "#/definitions/stringOrStringArray" },
            obsColorEncoding: { $ref: "#/definitions/stringOrStringArray" },
            spatialImageLayer: { $ref: "#/definitions/stringOrStringArray" },
            spatialSegmentationLayer: { $ref: "#/definitions/stringOrStringArray" },
            spatialPointLayer: { $ref: "#/definitions/stringOrStringArray" },
            spatialNeighborhoodLayer: { $ref: "#/definitions/stringOrStringArray" },
            genomicZoomX: { $ref: "#/definitions/stringOrStringArray" },
            genomicZoomY: { $ref: "#/definitions/stringOrStringArray" },
            genomicTargetX: { $ref: "#/definitions/stringOrStringArray" },
            genomicTargetY: { $ref: "#/definitions/stringOrStringArray" },
            additionalObsSets: { $ref: "#/definitions/stringOrStringArray" },
            moleculeHighlight: { $ref: "#/definitions/stringOrStringArray" }
          }
        },
        coordinationScopesBy: {
          type: "object",
          description: "Component-level and coordination type-level coordination scope mappings. Keys are coordination types.",
          additionalProperties: true,
          required: [],
          patternProperties: {
            ".": {
              type: "object",
              description: "Coordination type-level coordination scope mappings. Keys are coordination types. Values are objects.",
              additionalProperties: true,
              required: [],
              patternProperties: {
                ".": {
                  $ref: "#/definitions/componentCoordinationScopeByValue"
                }
              }
            }
          }
        }
      }
    }
  },
  annDataCellSets: {
    type: "array",
    description: "Array of cell set configuration, following closely the conventions of the tabular schema",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["groupName", "setName"],
      properties: {
        groupName: {
          type: "string",
          description: "The display name for the set, like 'Cell Type' or 'Louvain.'"
        },
        setName: {
          oneOf: [
            {
              type: "string",
              description: "The location in the AnnData store for the set, like 'obs/louvain' or 'obs/celltype.'"
            },
            {
              type: "array",
              items: { type: "string" },
              description: "An array of locations in the AnnData store for a hierarchy of set names, from coarse to fine levels."
            }
          ]
        },
        scoreName: {
          oneOf: [
            {
              type: "string",
              description: "The location in the AnnData store for the set confidence scores, like 'obs/celltype_prediction_score.'"
            }
          ]
        }
      }
    }
  },
  annDataCells: {
    type: "object",
    description: "The properties of this object are the configuration for how to layout scatterplots and spatial information",
    minProperties: 1,
    additionalProperties: false,
    required: [],
    properties: {
      xy: {
        type: "string",
        description: "The location in the AnnData store of cell centroids, like 'obsm/X_centroids.'"
      },
      poly: {
        type: "string",
        description: "The location in the AnnData store of cell polygon outlines, like 'obsm/X_polygons.'"
      },
      factors: {
        type: "array",
        description: "List of locations in the AnnData store of cell sets, like 'obs/louvain'",
        items: {
          type: "string"
        }
      },
      mappings: {
        patternProperties: {
          ".": {
            type: "object",
            description: "An object containing key-values for mappings like { UMAP: { key: 'obsm/X_umap', dims: [0, 1] } }.",
            additionalProperties: false,
            required: ["key"],
            properties: {
              key: {
                type: "string",
                description: "Where to look in the AnnData store for this mapping, like 'obsm/X_umap.'"
              },
              dims: {
                type: "array",
                description: "Which indices of the obsm object to take for a scatterplot, allowing for, for example, different PCs from obsm/X_pca",
                minItems: 2,
                maxItems: 2,
                items: { type: "number" }
              }
            }
          }
        }
      }
    }
  },
  annDataExpressionMatrix: {
    type: "object",
    description: "The properties of this object are the configuration for how to fetch the cell x genes matrix",
    additionalProperties: false,
    required: ["matrix"],
    properties: {
      matrix: {
        type: "string",
        description: "The location in the AnnData store of the cell x gene matrix, like 'obsm/hvg_subset.' or 'X'"
      },
      geneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the genes if using a subset of the data, like 'var.highly_variable.' if the matrix comes from 'obsm/hvg_subset.'"
      },
      matrixGeneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the matrix data (used in heatmap and histogram), like 'var.highly_variable.''"
      },
      geneAlias: {
        type: "string",
        description: "The location in the AnnData store of a different list of names for gene list component, other than the `var` index"
      }
    }
  },
  requestInit: {
    type: "object",
    description: "The properties of this object correspond to the parameters of the JavaScript fetch() function.",
    additionalProperties: false,
    required: [],
    properties: {
      method: {
        type: "string"
      },
      headers: {
        type: "object"
      },
      body: {
        type: "string"
      },
      mode: {
        type: "string"
      },
      credentials: {
        type: "string"
      },
      cache: {
        type: "string"
      },
      redirect: {
        type: "string"
      },
      referrer: {
        type: "string"
      },
      integrity: {
        type: "string"
      }
    }
  },
  rasterLayer: {
    description: "The properties of this object are the rendering settings for the raster layer.",
    additionalProperties: false,
    required: ["channels", "colormap", "index", "opacity"],
    properties: {
      channels: {
        type: "array",
        items: {
          type: "object",
          additionalProperties: false,
          required: ["selection"],
          properties: {
            color: {
              type: "array",
              items: { type: "number" },
              description: "The color to use when rendering this channel under the null colormap."
            },
            selection: {
              type: "object",
              description: "Determines the channel selection, e.g. some Z and time slice."
            },
            slider: {
              type: "array",
              items: { type: "number" },
              description: "Determines the range for color mapping."
            },
            visible: {
              type: "boolean",
              description: "Determines whether this channel of the layer will be rendered in the spatial component."
            }
          }
        }
      },
      colormap: {
        oneOf: [
          {
            type: "string",
            description: "The name of the colormap to use for this layer."
          },
          {
            type: "null",
            description: "Use the solid color definitions."
          }
        ]
      },
      transparentColor: {
        oneOf: [
          {
            type: "array",
            minItems: 3,
            maxItems: 3,
            items: {
              type: "number",
              description: "One of R G or B (0 - 255)."
            },
            description: "Determines the color to be set to opacity 0"
          },
          {
            type: "null",
            description: "No selection."
          }
        ]
      },
      index: {
        type: "number",
        description: "The index of the layer among the array of layers available in the image file."
      },
      opacity: {
        type: "number"
      },
      modelMatrix: {
        oneOf: [
          {
            type: "array",
            minItems: 16,
            maxItems: 16,
            description: "transformation matrix for this layer"
          },
          {
            type: "null",
            description: "Use no transformation."
          }
        ]
      },
      domainType: {
        type: "string",
        enum: ["Full", "Min/Max"],
        description: "Determines the extent of the channel slider input element in the layer controller."
      },
      resolution: {
        type: "number",
        description: "Resolution of 3D volumetric rendering"
      },
      xSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      renderingMode: {
        type: "string",
        description: "Rendering mode of 3D volumetric rendering"
      },
      ySlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      zSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      type: {
        type: "string",
        enum: ["raster", "bitmask"]
      },
      use3d: {
        type: "boolean"
      },
      visible: {
        type: "boolean",
        description: "Determines whether this entire layer will be rendered in the spatial component."
      }
    }
  },
  moleculesLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the molecules layer.",
    additionalProperties: false,
    required: ["visible", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  cellsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the cells layer.",
    additionalProperties: false,
    required: ["visible", "stroked", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      stroked: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  neighborhoodsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the neighborhoods layer.",
    additionalProperties: false,
    required: ["visible"],
    properties: {
      visible: {
        type: "boolean"
      }
    }
  },
  spatialImageLayer: {
    type: "array",
    description: "Array of Spatial Layers",
    items: {
      $ref: "#/definitions/rasterLayer"
    }
  }
};
var additionalProperties17 = false;
var required17 = ["version", "name", "datasets", "layout", "initStrategy"];
var properties17 = {
  name: { type: "string" },
  public: { type: "boolean" },
  description: { type: "string" },
  datasets: {
    type: "array",
    description: "The datasets array defines groups of files, where the files within each dataset reference the same entities (cells, genes, cell sets, etc).",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["uid", "files"],
      properties: {
        uid: { type: "string" },
        name: { type: "string" },
        description: { type: "string" },
        files: {
          type: "array",
          items: {
            type: "object",
            additionalProperties: false,
            required: ["type", "fileType"],
            properties: {
              name: { type: "string" },
              type: { type: "string" },
              fileType: { type: "string" },
              url: { type: "string" },
              options: { oneOf: [{ $ref: "#/definitions/annDataCellSets" }, { $ref: "https://github.com/vitessce/vitessce/#raster" }, { $ref: "#/definitions/annDataCells" }, { $ref: "#/definitions/annDataExpressionMatrix" }] },
              requestInit: { $ref: "#/definitions/requestInit" },
              coordinationValues: {
                type: "object",
                description: "Keys are coordination types. Values are coordination values. Used for matching views to files.",
                patternProperties: {
                  ".": {
                    oneOf: [
                      { type: "string" }
                    ]
                  }
                }
              }
            }
          }
        }
      }
    }
  },
  coordinationSpace: {
    type: "object",
    description: "The coordination space stores the values for each scope of each coordination object.",
    additionalProperties: true,
    required: [],
    properties: {
      dataset: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      obsType: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      featureType: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      featureValueType: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetZ: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingType: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingObsSetPolygonsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingObsSetLabelsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingObsSetLabelSize: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingObsRadius: {
        type: "object",
        patternProperties: {
          ".": {
            type: "number",
            description: "The cell radius value, used when embeddingCellRadiusMode is absolute or relative."
          }
        }
      },
      embeddingObsOpacity: {
        type: "object",
        patternProperties: {
          ".": {
            type: "number",
            description: "The cell opacity value, used when embeddingCellOpacityMode is static."
          }
        }
      },
      embeddingObsRadiusMode: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["manual", "auto"],
            description: "Should data points representing cells be assigned a static (manual) or dynamic (auto, based on zoom level and data extent) radius?"
          }
        }
      },
      embeddingObsOpacityMode: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["manual", "auto"],
            description: "Should data points representing cells be assigned a static (manual) or dynamic (auto, based on zoom level and data extent) opacity?"
          }
        }
      },
      spatialZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      spatialTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationOrbit: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialOrbitAxis: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "string" }
            ]
          }
        }
      },
      spatialAxisFixed: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "Whether or not to have a fixed axis for the camera. Only useful for 3D viewing."
              },
              { type: "boolean" }
            ]
          }
        }
      },
      spatialImageLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/spatialImageLayer" }
            ]
          }
        }
      },
      spatialSegmentationLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/cellsLayer" }
            ]
          }
        }
      },
      spatialNeighborhoodLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/neighborhoodsLayer" }
            ]
          }
        }
      },
      spatialPointLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/moleculesLayer" }
            ]
          }
        }
      },
      heatmapZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      obsFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cells will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      obsHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      obsSetSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto cell set initialization is enabled, cell set selections will be automatically initialized."
              },
              { type: "array" }
            ]
          }
        }
      },
      obsSetHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell sets will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      obsSetColor: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, cell set colors will be automatically initialized."
              },
              {
                type: "array",
                items: {
                  type: "object",
                  additionalProperties: false,
                  required: ["path", "color"],
                  properties: {
                    path: {
                      type: "array",
                      items: { type: "string" }
                    },
                    color: {
                      type: "array",
                      items: { type: "number" }
                    }
                  }
                }
              }
            ]
          }
        }
      },
      obsColorEncoding: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["geneSelection", "cellSetSelection"],
            description: "How should data points representing cells be colored?"
          }
        }
      },
      featureFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      featureHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      featureSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      featureValueTransform: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "string", pattern: "log1p" }
            ]
          }
        }
      },
      featureValueColormap: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      featureValueColormapRange: {
        type: "object",
        patternProperties: {
          ".": { type: "array", items: { type: "number" } }
        }
      },
      genomicZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      additionalObsSets: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              {
                $ref: "https://github.com/vitessce/vitessce/#cell-sets"
              }
            ]
          }
        }
      },
      moleculeHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no molecule will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      }
    }
  },
  layout: { $ref: "#/definitions/components" },
  initStrategy: {
    type: "string",
    enum: ["none", "auto"],
    description: "The initialization strategy determines how missing coordination objects and coordination scope mappings are initially filled in."
  },
  version: {
    type: "string",
    enum: ["1.0.14"],
    description: "The schema version for the view config."
  }
};
var config_1_0_14_schema_default = {
  $schema: $schema21,
  $id: $id21,
  title: title21,
  type: type21,
  definitions: definitions21,
  additionalProperties: additionalProperties17,
  required: required17,
  properties: properties17
};

// src/schemas/config-1.0.15.schema.json
var $schema22 = "http://json-schema.org/draft-07/schema#";
var $id22 = "https://github.com/vitessce/vitessce/#dataset";
var title22 = "Vitessce data set";
var type22 = "object";
var definitions22 = {
  componentCoordinationScopeValue: {
    oneOf: [
      { type: "string" },
      {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      }
    ]
  },
  components: {
    description: "The layout array defines the views, or components, rendered in the grid.",
    type: "array",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["component", "x", "y"],
      properties: {
        uid: {
          type: "string",
          description: "A unique identifier for the view, to refer to it in getter and setter functions in object-oriented contexts."
        },
        component: {
          type: "string",
          description: "Specify a component using a name defined in the component registry."
        },
        props: {
          type: "object",
          description: "Extra prop values for the component."
        },
        x: { type: "integer" },
        y: { type: "integer" },
        w: { type: "integer" },
        h: { type: "integer" },
        coordinationScopes: {
          type: "object",
          description: "Component-level coordination scope mappings define which coordination object values a particular component can read and write, for each coordination type.",
          additionalProperties: true,
          required: [],
          properties: {
            dataset: {
              oneOf: [
                { type: "string" },
                { type: "array", items: { type: "string" } }
              ]
            },
            embeddingType: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingZoom: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingRotation: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingTargetX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingTargetY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingTargetZ: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingCellSetPolygonsVisible: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingCellSetLabelsVisible: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingCellSetLabelSize: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingCellRadius: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingCellOpacity: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingCellRadiusMode: { $ref: "#/definitions/componentCoordinationScopeValue" },
            embeddingCellOpacityMode: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialZoom: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRotation: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialTargetX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialTargetY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialTargetZ: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRotationX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRotationY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRotationZ: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRotationOrbit: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialOrbitAxis: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialAxisFixed: { $ref: "#/definitions/componentCoordinationScopeValue" },
            heatmapZoomX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            heatmapZoomY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            heatmapTargetX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            heatmapTargetY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            cellFilter: { $ref: "#/definitions/componentCoordinationScopeValue" },
            cellHighlight: { $ref: "#/definitions/componentCoordinationScopeValue" },
            cellSetSelection: { $ref: "#/definitions/componentCoordinationScopeValue" },
            cellSetHighlight: { $ref: "#/definitions/componentCoordinationScopeValue" },
            cellSetColor: { $ref: "#/definitions/componentCoordinationScopeValue" },
            geneFilter: { $ref: "#/definitions/componentCoordinationScopeValue" },
            geneHighlight: { $ref: "#/definitions/componentCoordinationScopeValue" },
            geneSelection: { $ref: "#/definitions/componentCoordinationScopeValue" },
            geneExpressionTransform: { $ref: "#/definitions/componentCoordinationScopeValue" },
            geneExpressionColormap: { $ref: "#/definitions/componentCoordinationScopeValue" },
            geneExpressionColormapRange: { $ref: "#/definitions/componentCoordinationScopeValue" },
            cellColorEncoding: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialRasterLayers: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialCellsLayer: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialMoleculesLayer: { $ref: "#/definitions/componentCoordinationScopeValue" },
            spatialNeighborhoodsLayer: { $ref: "#/definitions/componentCoordinationScopeValue" },
            genomicZoomX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            genomicZoomY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            genomicTargetX: { $ref: "#/definitions/componentCoordinationScopeValue" },
            genomicTargetY: { $ref: "#/definitions/componentCoordinationScopeValue" },
            additionalCellSets: { $ref: "#/definitions/componentCoordinationScopeValue" },
            moleculeHighlight: { $ref: "#/definitions/componentCoordinationScopeValue" }
          }
        }
      }
    }
  },
  annDataCellSets: {
    type: "array",
    description: "Array of cell set configuration, following closely the conventions of the tabular schema",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["groupName", "setName"],
      properties: {
        groupName: {
          type: "string",
          description: "The display name for the set, like 'Cell Type' or 'Louvain.'"
        },
        setName: {
          oneOf: [
            {
              type: "string",
              description: "The location in the AnnData store for the set, like 'obs/louvain' or 'obs/celltype.'"
            },
            {
              type: "array",
              items: { type: "string" },
              description: "An array of locations in the AnnData store for a hierarchy of set names, from coarse to fine levels."
            }
          ]
        },
        scoreName: {
          oneOf: [
            {
              type: "string",
              description: "The location in the AnnData store for the set confidence scores, like 'obs/celltype_prediction_score.'"
            }
          ]
        }
      }
    }
  },
  annDataCells: {
    type: "object",
    description: "The properties of this object are the configuration for how to layout scatterplots and spatial information",
    minProperties: 1,
    additionalProperties: false,
    required: [],
    properties: {
      xy: {
        type: "string",
        description: "The location in the AnnData store of cell centroids, like 'obsm/X_centroids.'"
      },
      poly: {
        type: "string",
        description: "The location in the AnnData store of cell polygon outlines, like 'obsm/X_polygons.'"
      },
      factors: {
        type: "array",
        description: "List of locations in the AnnData store of cell sets, like 'obs/louvain'",
        items: {
          type: "string"
        }
      },
      mappings: {
        patternProperties: {
          ".": {
            type: "object",
            description: "An object containing key-values for mappings like { UMAP: { key: 'obsm/X_umap', dims: [0, 1] } }.",
            additionalProperties: false,
            required: ["key"],
            properties: {
              key: {
                type: "string",
                description: "Where to look in the AnnData store for this mapping, like 'obsm/X_umap.'"
              },
              dims: {
                type: "array",
                description: "Which indices of the obsm object to take for a scatterplot, allowing for, for example, different PCs from obsm/X_pca",
                minItems: 2,
                maxItems: 2,
                items: { type: "number" }
              }
            }
          }
        }
      }
    }
  },
  annDataExpressionMatrix: {
    type: "object",
    description: "The properties of this object are the configuration for how to fetch the cell x genes matrix",
    additionalProperties: false,
    required: ["matrix"],
    properties: {
      matrix: {
        type: "string",
        description: "The location in the AnnData store of the cell x gene matrix, like 'obsm/hvg_subset.' or 'X'"
      },
      geneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the genes if using a subset of the data, like 'var.highly_variable.' if the matrix comes from 'obsm/hvg_subset.'"
      },
      matrixGeneFilter: {
        type: "string",
        description: "The location in the AnnData store of a filter for the matrix data (used in heatmap and histogram), like 'var.highly_variable.''"
      },
      geneAlias: {
        type: "string",
        description: "The location in the AnnData store of a different list of names for gene list component, other than the `var` index"
      }
    }
  },
  requestInit: {
    type: "object",
    description: "The properties of this object correspond to the parameters of the JavaScript fetch() function.",
    additionalProperties: false,
    required: [],
    properties: {
      method: {
        type: "string"
      },
      headers: {
        type: "object"
      },
      body: {
        type: "string"
      },
      mode: {
        type: "string"
      },
      credentials: {
        type: "string"
      },
      cache: {
        type: "string"
      },
      redirect: {
        type: "string"
      },
      referrer: {
        type: "string"
      },
      integrity: {
        type: "string"
      }
    }
  },
  rasterLayer: {
    description: "The properties of this object are the rendering settings for the raster layer.",
    additionalProperties: false,
    required: ["channels", "colormap", "index", "opacity"],
    properties: {
      channels: {
        type: "array",
        items: {
          type: "object",
          additionalProperties: false,
          required: ["selection"],
          properties: {
            color: {
              type: "array",
              items: { type: "number" },
              description: "The color to use when rendering this channel under the null colormap."
            },
            selection: {
              type: "object",
              description: "Determines the channel selection, e.g. some Z and time slice."
            },
            slider: {
              type: "array",
              items: { type: "number" },
              description: "Determines the range for color mapping."
            },
            visible: {
              type: "boolean",
              description: "Determines whether this channel of the layer will be rendered in the spatial component."
            }
          }
        }
      },
      colormap: {
        oneOf: [
          {
            type: "string",
            description: "The name of the colormap to use for this layer."
          },
          {
            type: "null",
            description: "Use the solid color definitions."
          }
        ]
      },
      transparentColor: {
        oneOf: [
          {
            type: "array",
            minItems: 3,
            maxItems: 3,
            items: {
              type: "number",
              description: "One of R G or B (0 - 255)."
            },
            description: "Determines the color to be set to opacity 0"
          },
          {
            type: "null",
            description: "No selection."
          }
        ]
      },
      index: {
        type: "number",
        description: "The index of the layer among the array of layers available in the image file."
      },
      opacity: {
        type: "number"
      },
      modelMatrix: {
        oneOf: [
          {
            type: "array",
            minItems: 16,
            maxItems: 16,
            description: "transformation matrix for this layer"
          },
          {
            type: "null",
            description: "Use no transformation."
          }
        ]
      },
      domainType: {
        type: "string",
        enum: ["Full", "Min/Max"],
        description: "Determines the extent of the channel slider input element in the layer controller."
      },
      resolution: {
        type: "number",
        description: "Resolution of 3D volumetric rendering"
      },
      xSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      renderingMode: {
        type: "string",
        description: "Rendering mode of 3D volumetric rendering"
      },
      ySlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      zSlice: {
        oneOf: [
          {
            type: "array",
            minItems: 2,
            maxItems: 2,
            description: "Slice bounds"
          },
          {
            type: "null",
            description: "No slicing"
          }
        ]
      },
      type: {
        type: "string",
        enum: ["raster", "bitmask"]
      },
      use3d: {
        type: "boolean"
      },
      visible: {
        type: "boolean",
        description: "Determines whether this entire layer will be rendered in the spatial component."
      }
    }
  },
  moleculesLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the molecules layer.",
    additionalProperties: false,
    required: ["visible", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  cellsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the cells layer.",
    additionalProperties: false,
    required: ["visible", "stroked", "radius", "opacity"],
    properties: {
      visible: {
        type: "boolean"
      },
      stroked: {
        type: "boolean"
      },
      radius: {
        type: "number"
      },
      opacity: {
        type: "number"
      }
    }
  },
  neighborhoodsLayer: {
    type: "object",
    description: "The properties of this object are the rendering settings for the neighborhoods layer.",
    additionalProperties: false,
    required: ["visible"],
    properties: {
      visible: {
        type: "boolean"
      }
    }
  },
  spatialRasterLayers: {
    type: "array",
    description: "Array of Spatial Layers",
    items: {
      $ref: "#/definitions/rasterLayer"
    }
  }
};
var additionalProperties18 = false;
var required18 = ["version", "name", "datasets", "layout", "initStrategy"];
var properties18 = {
  name: { type: "string" },
  public: { type: "boolean" },
  description: { type: "string" },
  datasets: {
    type: "array",
    description: "The datasets array defines groups of files, where the files within each dataset reference the same entities (cells, genes, cell sets, etc).",
    items: {
      type: "object",
      additionalProperties: false,
      required: ["uid", "files"],
      properties: {
        uid: { type: "string" },
        name: { type: "string" },
        description: { type: "string" },
        files: {
          type: "array",
          items: {
            type: "object",
            additionalProperties: false,
            required: ["fileType"],
            properties: {
              name: { type: "string" },
              type: { type: "string" },
              fileType: { type: "string" },
              url: { type: "string" },
              options: { oneOf: [{ $ref: "#/definitions/annDataCellSets" }, { $ref: "https://github.com/vitessce/vitessce/#raster" }, { $ref: "#/definitions/annDataCells" }, { $ref: "#/definitions/annDataExpressionMatrix" }] },
              requestInit: { $ref: "#/definitions/requestInit" }
            }
          }
        }
      }
    }
  },
  coordinationSpace: {
    type: "object",
    description: "The coordination space stores the values for each scope of each coordination object.",
    additionalProperties: true,
    required: [],
    properties: {
      dataset: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      embeddingTargetZ: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingType: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      embeddingCellSetPolygonsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingCellSetLabelsVisible: {
        type: "object",
        patternProperties: {
          ".": { type: "boolean" }
        }
      },
      embeddingCellSetLabelSize: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      embeddingCellRadius: {
        type: "object",
        patternProperties: {
          ".": {
            type: "number",
            description: "The cell radius value, used when embeddingCellRadiusMode is absolute or relative."
          }
        }
      },
      embeddingCellOpacity: {
        type: "object",
        patternProperties: {
          ".": {
            type: "number",
            description: "The cell opacity value, used when embeddingCellOpacityMode is static."
          }
        }
      },
      embeddingCellRadiusMode: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["manual", "auto"],
            description: "Should data points representing cells be assigned a static (manual) or dynamic (auto, based on zoom level and data extent) radius?"
          }
        }
      },
      embeddingCellOpacityMode: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["manual", "auto"],
            description: "Should data points representing cells be assigned a static (manual) or dynamic (auto, based on zoom level and data extent) opacity?"
          }
        }
      },
      spatialZoom: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotation: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      spatialTargetX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialTargetZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationX: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationY: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationZ: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialRotationOrbit: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "number" }
            ]
          }
        }
      },
      spatialOrbitAxis: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, value will be automatically set. Only useful for 3D viewing."
              },
              { type: "string" }
            ]
          }
        }
      },
      spatialAxisFixed: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "Whether or not to have a fixed axis for the camera. Only useful for 3D viewing."
              },
              { type: "boolean" }
            ]
          }
        }
      },
      spatialRasterLayers: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/spatialRasterLayers" }
            ]
          }
        }
      },
      spatialCellsLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/cellsLayer" }
            ]
          }
        }
      },
      spatialNeighborhoodsLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/neighborhoodsLayer" }
            ]
          }
        }
      },
      spatialMoleculesLayer: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto layer initialization is enabled, layers will be automatically initialized."
              },
              { $ref: "#/definitions/moleculesLayer" }
            ]
          }
        }
      },
      heatmapZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      heatmapTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      cellFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cells will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      cellHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      cellSetSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided and auto cell set initialization is enabled, cell set selections will be automatically initialized."
              },
              { type: "array" }
            ]
          }
        }
      },
      cellSetHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell sets will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      cellSetColor: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, cell set colors will be automatically initialized."
              },
              {
                type: "array",
                items: {
                  type: "object",
                  additionalProperties: false,
                  required: ["path", "color"],
                  properties: {
                    path: {
                      type: "array",
                      items: { type: "string" }
                    },
                    color: {
                      type: "array",
                      items: { type: "number" }
                    }
                  }
                }
              }
            ]
          }
        }
      },
      cellColorEncoding: {
        type: "object",
        patternProperties: {
          ".": {
            type: "string",
            enum: ["geneSelection", "cellSetSelection"],
            description: "How should data points representing cells be colored?"
          }
        }
      },
      geneFilter: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be filtered out initially."
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      geneHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no genes will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      },
      geneSelection: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "array", items: { type: "string" } }
            ]
          }
        }
      },
      geneExpressionTransform: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null"
              },
              { type: "string", pattern: "log1p" }
            ]
          }
        }
      },
      geneExpressionColormap: {
        type: "object",
        patternProperties: {
          ".": { type: "string" }
        }
      },
      geneExpressionColormapRange: {
        type: "object",
        patternProperties: {
          ".": { type: "array", items: { type: "number" } }
        }
      },
      genomicZoomX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicZoomY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetX: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      genomicTargetY: {
        type: "object",
        patternProperties: {
          ".": { type: "number" }
        }
      },
      additionalCellSets: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no cell will be highlighted initially."
              },
              {
                $ref: "https://github.com/vitessce/vitessce/#cell-sets"
              }
            ]
          }
        }
      },
      moleculeHighlight: {
        type: "object",
        patternProperties: {
          ".": {
            oneOf: [
              {
                type: "null",
                description: "If null is provided, no molecule will be highlighted initially."
              },
              { type: "string" }
            ]
          }
        }
      }
    }
  },
  layout: { $ref: "#/definitions/components" },
  initStrategy: {
    type: "string",
    enum: ["none", "auto"],
    description: "The initialization strategy determines how missing coordination objects and coordination scope mappings are initially filled in."
  },
  version: {
    type: "string",
    enum: ["1.0.15"],
    description: "The schema version for the view config."
  }
};
var config_1_0_15_schema_default = {
  $schema: $schema22,
  $id: $id22,
  title: title22,
  type: type22,
  definitions: definitions22,
  additionalProperties: additionalProperties18,
  required: required18,
  properties: properties18
};

// src/app/view-config-upgraders.js
import uuidv42 from "uuid/v4";
import cloneDeep from "lodash/cloneDeep";
function upgradeReplaceViewProp(prefix, view, coordinationSpace) {
  const prevZScopes = Object.keys(coordinationSpace[`${prefix}Zoom`]);
  const prevTXScopes = Object.keys(coordinationSpace[`${prefix}TargetX`]);
  const prevTYScopes = Object.keys(coordinationSpace[`${prefix}TargetY`]);
  const nextZScope = getNextScope(prevZScopes);
  const nextTXScope = getNextScope(prevTXScopes);
  const nextTYScope = getNextScope(prevTYScopes);
  const { zoom, target: [targetX, targetY] } = view;
  coordinationSpace[`${prefix}Zoom`][nextZScope] = zoom;
  coordinationSpace[`${prefix}TargetX`][nextTXScope] = targetX;
  coordinationSpace[`${prefix}TargetY`][nextTYScope] = targetY;
  return {
    [`${prefix}Zoom`]: nextZScope,
    [`${prefix}TargetX`]: nextTXScope,
    [`${prefix}TargetY`]: nextTYScope
  };
}
function upgradeFrom0_1_0(config, datasetUid = null) {
  const coordinationSpace = {
    embeddingType: {},
    embeddingZoom: {},
    embeddingTargetX: {},
    embeddingTargetY: {},
    spatialZoom: {},
    spatialTargetX: {},
    spatialTargetY: {}
  };
  const layout = [];
  config.staticLayout.forEach((componentDef) => {
    var _a;
    let newComponentDef = __spreadProps(__spreadValues({}, componentDef), {
      coordinationScopes: {}
    });
    if (componentDef.component === "scatterplot") {
      if (componentDef.props.mapping) {
        coordinationSpace.embeddingType[componentDef.props.mapping] = componentDef.props.mapping;
        newComponentDef = __spreadProps(__spreadValues({}, newComponentDef), {
          coordinationScopes: __spreadProps(__spreadValues({}, newComponentDef.coordinationScopes), {
            embeddingType: componentDef.props.mapping
          })
        });
      }
      if (componentDef.props.view) {
        const newScopeValues = upgradeReplaceViewProp("embedding", componentDef.props.view, coordinationSpace);
        newComponentDef = __spreadProps(__spreadValues({}, newComponentDef), {
          coordinationScopes: __spreadValues(__spreadValues({}, newComponentDef.coordinationScopes), newScopeValues)
        });
      }
    }
    if (componentDef.component === "spatial") {
      if ((_a = componentDef == null ? void 0 : componentDef.props) == null ? void 0 : _a.view) {
        const newScopeValues = upgradeReplaceViewProp("spatial", componentDef.props.view, coordinationSpace);
        newComponentDef = __spreadProps(__spreadValues({}, newComponentDef), {
          coordinationScopes: __spreadValues(__spreadValues({}, newComponentDef.coordinationScopes), newScopeValues)
        });
      }
    }
    layout.push(newComponentDef);
  });
  const newDatasetUid = datasetUid || uuidv42();
  return {
    version: "1.0.1",
    name: config.name,
    description: config.description,
    public: config.public,
    datasets: [
      {
        uid: newDatasetUid,
        name: newDatasetUid,
        files: config.layers.map((layer) => ({
          type: layer.type.toLowerCase(),
          fileType: layer.fileType,
          url: layer.url
        }))
      }
    ],
    initStrategy: "auto",
    coordinationSpace,
    layout
  };
}
function upgradeFrom1_0_0(config) {
  const coordinationSpace = __spreadValues({}, config.coordinationSpace);
  function replaceLayerType(layerType) {
    const isRaster = layerType === "raster";
    coordinationSpace[`spatial${capitalize(layerType)}Layer${isRaster ? "s" : ""}`] = {};
    Object.entries(coordinationSpace.spatialLayers).forEach(([scope, layers]) => {
      if (Array.isArray(layers) && layers.find((layer) => layer.type === layerType)) {
        const typedLayers = layers.filter((layer) => layer.type === layerType).map((layer) => {
          const newLayer = __spreadValues({}, layer);
          delete newLayer.type;
          return newLayer;
        });
        coordinationSpace[`spatial${capitalize(layerType)}Layer${isRaster ? "s" : ""}`][scope] = isRaster ? typedLayers : typedLayers[0];
      } else {
        coordinationSpace[`spatial${capitalize(layerType)}Layer${isRaster ? "s" : ""}`][scope] = null;
      }
    });
  }
  if (coordinationSpace.spatialLayers) {
    replaceLayerType("raster");
    replaceLayerType("cells");
    replaceLayerType("molecules");
    replaceLayerType("neighborhoods");
    delete coordinationSpace.spatialLayers;
  }
  const layout = config.layout.map((component) => {
    const newComponent = __spreadValues({}, component);
    function replaceCoordinationScope(layerType) {
      const isRaster = layerType === "raster";
      if (COMPONENT_COORDINATION_TYPES[newComponent.component].includes(`spatial${capitalize(layerType)}Layer${isRaster ? "s" : ""}`)) {
        newComponent.coordinationScopes[`spatial${capitalize(layerType)}Layer${isRaster ? "s" : ""}`] = newComponent.coordinationScopes.spatialLayers;
      }
    }
    if (newComponent.coordinationScopes && newComponent.coordinationScopes.spatialLayers) {
      replaceCoordinationScope("raster");
      replaceCoordinationScope("cells");
      replaceCoordinationScope("molecules");
      replaceCoordinationScope("neighborhoods");
      delete newComponent.coordinationScopes.spatialLayers;
    }
    return newComponent;
  });
  return __spreadProps(__spreadValues({}, config), {
    coordinationSpace,
    layout,
    version: "1.0.1"
  });
}
function upgradeFrom1_0_1(config) {
  var _a;
  const layout = config.layout.map((component) => {
    const newComponent = __spreadValues({}, component);
    if (newComponent.component === "layerController") {
      newComponent.props = __spreadProps(__spreadValues({}, newComponent.props), {
        globalDisable3d: true
      });
    }
    return newComponent;
  });
  const newConfig = cloneDeep(config);
  Object.keys(((_a = newConfig == null ? void 0 : newConfig.coordinationSpace) == null ? void 0 : _a.spatialRasterLayers) || {}).forEach((key) => {
    if (newConfig.coordinationSpace.spatialRasterLayers[key]) {
      newConfig.coordinationSpace.spatialRasterLayers[key].forEach((layer, index) => {
        newConfig.coordinationSpace.spatialRasterLayers[key][index].type = ["bitmask", "raster"].includes(layer.type) ? layer.type : "raster";
      });
    }
  });
  return __spreadProps(__spreadValues({}, newConfig), {
    layout,
    version: "1.0.2"
  });
}
function upgradeFrom1_0_2(config) {
  const layout = config.layout.map((component) => {
    const newComponent = __spreadValues({}, component);
    if (newComponent.component === "layerController") {
      newComponent.props = __spreadProps(__spreadValues({}, newComponent.props), {
        disableChannelsIfRgbDetected: true
      });
    }
    return newComponent;
  });
  const newConfig = cloneDeep(config);
  return __spreadProps(__spreadValues({}, newConfig), {
    layout,
    version: "1.0.3"
  });
}
function upgradeFrom1_0_3(config) {
  const newConfig = cloneDeep(config);
  return __spreadProps(__spreadValues({}, newConfig), {
    version: "1.0.4"
  });
}
function upgradeFrom1_0_4(config) {
  const newConfig = cloneDeep(config);
  return __spreadProps(__spreadValues({}, newConfig), {
    version: "1.0.5"
  });
}
function upgradeFrom1_0_5(config) {
  const newConfig = cloneDeep(config);
  return __spreadProps(__spreadValues({}, newConfig), {
    version: "1.0.6"
  });
}
function upgradeFrom1_0_6(config) {
  const newConfig = cloneDeep(config);
  return __spreadProps(__spreadValues({}, newConfig), {
    version: "1.0.7"
  });
}
function upgradeFrom1_0_7(config) {
  const newConfig = cloneDeep(config);
  return __spreadProps(__spreadValues({}, newConfig), {
    version: "1.0.8"
  });
}
function upgradeFrom1_0_8(config) {
  const newConfig = cloneDeep(config);
  return __spreadProps(__spreadValues({}, newConfig), {
    version: "1.0.9"
  });
}
function upgradeFrom1_0_9(config) {
  const newConfig = cloneDeep(config);
  return __spreadProps(__spreadValues({}, newConfig), {
    version: "1.0.10"
  });
}
function upgradeFrom1_0_10(config) {
  const coordinationSpace = __spreadValues({}, config.coordinationSpace);
  const scopeAnalogies = {
    spatialRasterLayers: "spatialImageLayer",
    spatialCellsLayer: "spatialSegmentationLayer",
    spatialMoleculesLayer: "spatialPointLayer",
    spatialNeighborhoodsLayer: "spatialNeighborhoodLayer",
    cellFilter: "obsFilter",
    cellHighlight: "obsHighlight",
    cellSelection: "obsSelection",
    cellSetSelection: "obsSetSelection",
    cellSetHighlight: "obsSetHighlight",
    cellSetColor: "obsSetColor",
    geneFilter: "featureFilter",
    geneHighlight: "featureHighlight",
    geneSelection: "featureSelection",
    geneExpressionColormap: "featureValueColormap",
    geneExpressionColormapRange: "featureValueColormapRange",
    cellColorEncoding: "obsColorEncoding",
    additionalCellSets: "additionalObsSets",
    embeddingCellSetPolygonsVisible: "embeddingObsSetPolygonsVisible",
    embeddingCellSetLabelsVisible: "embeddingObsSetLabelsVisible",
    embeddingCellSetLabelSize: "embeddingObsSetLabelSize",
    embeddingCellRadius: "embeddingObsRadius",
    embeddingCellRadiusMode: "embeddingObsRadiusMode",
    embeddingCellOpacity: "embeddingObsOpacity",
    embeddingCellOpacityMode: "embeddingObsOpacityMode"
  };
  Object.entries(scopeAnalogies).forEach(([oldKey, newKey]) => {
    if (coordinationSpace[oldKey]) {
      coordinationSpace[newKey] = coordinationSpace[oldKey];
      delete coordinationSpace[oldKey];
    }
  });
  const layout = config.layout.map((component) => {
    const newComponent = __spreadValues({}, component);
    const { coordinationScopes = {} } = newComponent;
    Object.entries(scopeAnalogies).forEach(([oldKey, newKey]) => {
      if (coordinationScopes[oldKey]) {
        coordinationScopes[newKey] = coordinationScopes[oldKey];
        delete coordinationScopes[oldKey];
      }
    });
    return __spreadProps(__spreadValues({}, newComponent), {
      coordinationScopes
    });
  });
  return __spreadProps(__spreadValues({}, config), {
    coordinationSpace,
    layout,
    version: "1.0.11"
  });
}
function upgradeFrom1_0_11(config) {
  const newConfig = cloneDeep(config);
  const { layout } = newConfig;
  const newLayout = layout.map((view) => {
    const { coordinationScopes = {} } = view;
    if (coordinationScopes.dataset && Array.isArray(coordinationScopes.dataset)) {
      const coordinationScopesBy = {
        dataset: {}
      };
      Object.entries(coordinationScopes).forEach(([coordinationType, coordinationScope]) => {
        if (coordinationType !== "dataset" && !Array.isArray(coordinationScope) && typeof coordinationScope === "object") {
          coordinationScopesBy.dataset[coordinationType] = coordinationScope;
          delete coordinationScopes[coordinationType];
        }
      });
      return __spreadProps(__spreadValues({}, view), {
        coordinationScopes,
        coordinationScopesBy
      });
    }
    return view;
  });
  return __spreadProps(__spreadValues({}, newConfig), {
    layout: newLayout,
    version: "1.0.12"
  });
}
function upgradeFrom1_0_12(config) {
  const newConfig = cloneDeep(config);
  return __spreadProps(__spreadValues({}, newConfig), {
    version: "1.0.13"
  });
}
function upgradeFrom1_0_13(config) {
  const newConfig = cloneDeep(config);
  return __spreadProps(__spreadValues({}, newConfig), {
    version: "1.0.14"
  });
}
function upgradeFrom1_0_14(config) {
  const newConfig = cloneDeep(config);
  return __spreadProps(__spreadValues({}, newConfig), {
    version: "1.0.15"
  });
}

// src/app/view-config-versions.js
var LATEST_VERSION = "1.0.15";
var SCHEMA_HANDLERS = {
  "0.1.0": [new Ajv2().compile(config_0_1_0_schema_default), upgradeFrom0_1_0],
  "1.0.0": [new Ajv2().addSchema(cell_sets_schema_default).addSchema(raster_schema_default).compile(config_1_0_0_schema_default), upgradeFrom1_0_0],
  "1.0.1": [new Ajv2().addSchema(cell_sets_schema_default).addSchema(raster_schema_default).compile(config_1_0_1_schema_default), upgradeFrom1_0_1],
  "1.0.2": [new Ajv2().addSchema(cell_sets_schema_default).addSchema(raster_schema_default).compile(config_1_0_2_schema_default), upgradeFrom1_0_2],
  "1.0.3": [new Ajv2().addSchema(cell_sets_schema_default).addSchema(raster_schema_default).compile(config_1_0_3_schema_default), upgradeFrom1_0_3],
  "1.0.4": [new Ajv2().addSchema(cell_sets_schema_default).addSchema(raster_schema_default).compile(config_1_0_4_schema_default), upgradeFrom1_0_4],
  "1.0.5": [new Ajv2().addSchema(cell_sets_schema_default).addSchema(raster_schema_default).compile(config_1_0_5_schema_default), upgradeFrom1_0_5],
  "1.0.6": [new Ajv2().addSchema(cell_sets_schema_default).addSchema(raster_schema_default).compile(config_1_0_6_schema_default), upgradeFrom1_0_6],
  "1.0.7": [new Ajv2().addSchema(cell_sets_schema_default).addSchema(raster_schema_default).compile(config_1_0_7_schema_default), upgradeFrom1_0_7],
  "1.0.8": [new Ajv2().addSchema(cell_sets_schema_default).addSchema(raster_schema_default).compile(config_1_0_8_schema_default), upgradeFrom1_0_8],
  "1.0.9": [new Ajv2().addSchema(cell_sets_schema_default).addSchema(raster_schema_default).compile(config_1_0_9_schema_default), upgradeFrom1_0_9],
  "1.0.10": [new Ajv2().addSchema(cell_sets_schema_default).addSchema(raster_schema_default).compile(config_1_0_10_schema_default), upgradeFrom1_0_10],
  "1.0.11": [new Ajv2().addSchema(cell_sets_schema_default).addSchema(raster_schema_default).compile(config_1_0_11_schema_default), upgradeFrom1_0_11],
  "1.0.12": [new Ajv2().addSchema(cell_sets_schema_default).addSchema(raster_schema_default).compile(config_1_0_12_schema_default), upgradeFrom1_0_12],
  "1.0.13": [new Ajv2().addSchema(cell_sets_schema_default).addSchema(raster_schema_default).compile(config_1_0_13_schema_default), upgradeFrom1_0_13],
  "1.0.14": [new Ajv2().addSchema(cell_sets_schema_default).addSchema(raster_schema_default).compile(config_1_0_14_schema_default), upgradeFrom1_0_14],
  "1.0.15": [new Ajv2().addSchema(cell_sets_schema_default).addSchema(raster_schema_default).compile(config_1_0_15_schema_default), null]
};

// src/app/CallbackPublisher.js
function validateViewConfig(viewConfig) {
  try {
    const validate = SCHEMA_HANDLERS[LATEST_VERSION][0];
    const valid = validate(viewConfig);
    if (!valid) {
      const failureReason = JSON.stringify(validate.errors, null, 2);
      throw new Error(`Config validation failed: ${failureReason}`);
    }
  } catch (e) {
    console.error(e);
  }
}
function CallbackPublisher(props) {
  const {
    onWarn,
    onConfigChange,
    onLoaderChange,
    validateOnConfigChange
  } = props;
  const warning = useWarning();
  const loaders = useLoaders();
  const viewConfigStoreApi = useViewConfigStoreApi();
  useEffect4(() => viewConfigStoreApi.subscribe((viewConfig) => {
    if (validateOnConfigChange && viewConfig) {
      validateViewConfig(viewConfig);
    }
    if (onConfigChange && viewConfig) {
      onConfigChange(viewConfig);
    }
  }, (state) => state.viewConfig), [onConfigChange, validateOnConfigChange, viewConfigStoreApi]);
  useEffect4(() => {
    if (onWarn && warning) {
      onWarn(warning);
    }
  }, [warning, onWarn]);
  useEffect4(() => {
    if (onLoaderChange && loaders) {
      onLoaderChange(loaders);
    }
  }, [loaders, onLoaderChange]);
  return null;
}

// src/components/description/DescriptionSubscriber.js
import React11, { useEffect as useEffect6, useMemo as useMemo3 } from "react";

// src/components/data-hooks.js
import { useState as useState4, useEffect as useEffect5 } from "react";
import equal from "fast-deep-equal";
function warn(error, setWarning) {
  setWarning(error.message);
  console.warn(error.message);
  if (error instanceof AbstractLoaderError) {
    error.warnInConsole();
  }
}
function initCoordinationSpace(values, setters, initialValues) {
  if (!values || !setters) {
    return;
  }
  const defaultCoordinationValues = getDefaultCoordinationValues();
  Object.entries(values).forEach(([coordinationType, value]) => {
    const setterName = `set${capitalize(coordinationType)}`;
    const setterFunc = setters[setterName];
    const initialValue = initialValues && initialValues[coordinationType];
    const shouldInit = equal(initialValue, defaultCoordinationValues[coordinationType]);
    if (shouldInit && setterFunc) {
      setterFunc(value);
    }
  });
}
function useDescription(loaders, dataset) {
  const [description2, setDescription] = useState4();
  useEffect5(() => {
    if (!loaders[dataset]) {
      return;
    }
    if (loaders[dataset].description) {
      setDescription(loaders[dataset].description);
    } else {
      setDescription(null);
    }
  }, [loaders, dataset]);
  return [description2];
}
function useRasterData(loaders, dataset, setItemIsReady, addUrl, isRequired, coordinationSetters, initialCoordinationValues) {
  const [raster, setRaster] = useState4();
  const [imageLayerLoaders, setImageLayerLoaders] = useState4([]);
  const [imageLayerMeta, setImageLayerMeta] = useState4([]);
  const setWarning = useSetWarning();
  const loader = useMatchingLoader(loaders, dataset, "raster", {});
  useEffect5(() => {
    if (loader) {
      loader.load().catch((e) => warn(e, setWarning)).then((payload) => {
        if (!payload)
          return;
        const { data, url: urls, coordinationValues } = payload;
        setRaster(data);
        urls.forEach(([url, name2]) => {
          addUrl(url, name2);
        });
        const { loaders: nextImageLoaders, meta: nextImageMeta } = data;
        setImageLayerLoaders(nextImageLoaders);
        setImageLayerMeta(nextImageMeta);
        initCoordinationSpace(coordinationValues, coordinationSetters, initialCoordinationValues);
        setItemIsReady("raster");
      });
    } else {
      setImageLayerLoaders([]);
      setImageLayerMeta([]);
      if (isRequired) {
        if (dataset) {
          warn(new LoaderNotFoundError(dataset, "raster", null, null), setWarning);
        } else {
          warn(new DatasetNotFoundError(dataset), setWarning);
        }
      } else {
        setItemIsReady("raster");
      }
    }
  }, [loader]);
  return [raster, imageLayerLoaders, imageLayerMeta];
}

// src/components/description/Description.js
import React10 from "react";
function Description(props) {
  const { description: description2, metadata } = props;
  return /* @__PURE__ */ React10.createElement("div", {
    className: "description"
  }, /* @__PURE__ */ React10.createElement("p", null, description2), metadata && Array.from(metadata.entries()).map(([layerIndex, { name: layerName, metadata: metadataRecord }]) => metadataRecord && Object.entries(metadataRecord).length > 0 ? /* @__PURE__ */ React10.createElement("details", {
    key: layerIndex
  }, /* @__PURE__ */ React10.createElement("summary", null, layerName), /* @__PURE__ */ React10.createElement("div", {
    className: "metadata-container"
  }, /* @__PURE__ */ React10.createElement("table", null, /* @__PURE__ */ React10.createElement("tbody", null, Object.entries(metadataRecord).map(([key, value]) => /* @__PURE__ */ React10.createElement("tr", {
    key
  }, /* @__PURE__ */ React10.createElement("th", {
    title: key
  }, key), /* @__PURE__ */ React10.createElement("td", {
    title: value
  }, value))))))) : null));
}

// src/components/description/DescriptionSubscriber.js
var DESCRIPTION_DATA_TYPES = ["raster"];
function DescriptionSubscriber(props) {
  const {
    coordinationScopes,
    description: descriptionOverride,
    removeGridComponent,
    theme,
    title: title23 = "Data Set"
  } = props;
  const loaders = useLoaders();
  const [{
    dataset,
    spatialImageLayer: rasterLayers
  }] = useCoordination(COMPONENT_COORDINATION_TYPES.description, coordinationScopes);
  const [
    isReady,
    setItemIsReady,
    setItemIsNotReady,
    resetReadyItems
  ] = useReady(DESCRIPTION_DATA_TYPES);
  useEffect6(() => {
    resetReadyItems();
  }, [loaders, dataset]);
  const [description2] = useDescription(loaders, dataset);
  const [raster, imageLayerLoaders, imageLayerMeta] = useRasterData(loaders, dataset, setItemIsReady, () => {
  }, false);
  const metadata = useMemo3(() => {
    const result = new Map();
    if (rasterLayers && rasterLayers.length > 0 && raster && imageLayerMeta && imageLayerLoaders) {
      rasterLayers.forEach((layer) => {
        if (imageLayerMeta[layer.index]) {
          const { format } = imageLayerLoaders[layer.index].metadata;
          result.set(`${layer.index}`, {
            name: raster.meta[layer.index].name,
            metadata: format && format()
          });
        }
      });
    }
    return result;
  }, [raster, rasterLayers, imageLayerMeta, imageLayerLoaders]);
  return /* @__PURE__ */ React11.createElement(TitleInfo, {
    title: title23,
    removeGridComponent,
    isScroll: true,
    theme,
    isReady
  }, /* @__PURE__ */ React11.createElement(Description, {
    description: descriptionOverride || description2,
    metadata
  }));
}

// src/components/status/StatusSubscriber.js
import React13 from "react";

// src/components/status/Status.js
import React12 from "react";
function Status(props) {
  const warnClass = "alert alert-warning my-0 details";
  const { info, warn: warn2 } = props;
  const messages = [];
  if (info) {
    messages.push(/* @__PURE__ */ React12.createElement("p", {
      className: "details",
      key: "info"
    }, info));
  }
  if (warn2) {
    messages.push(/* @__PURE__ */ React12.createElement("p", {
      className: warnClass,
      key: "warn"
    }, warn2));
  }
  return messages;
}

// src/components/status/StatusSubscriber.js
function StatusSubscriber(props) {
  const {
    coordinationScopes,
    removeGridComponent,
    theme,
    title: title23 = "Status"
  } = props;
  const [{
    obsHighlight: cellHighlight,
    featureHighlight: geneHighlight,
    moleculeHighlight
  }] = useCoordination(COMPONENT_COORDINATION_TYPES.status, coordinationScopes);
  const warn2 = useWarning();
  const infos = [
    ...cellHighlight ? [`Hovered cell ${cellHighlight}`] : [],
    ...geneHighlight ? [`Hovered gene ${geneHighlight}`] : [],
    ...moleculeHighlight ? [`Hovered gene ${moleculeHighlight}`] : []
  ];
  const info = infos.join("; ");
  return /* @__PURE__ */ React13.createElement(TitleInfo, {
    title: title23,
    theme,
    removeGridComponent,
    isScroll: true,
    isReady: true
  }, /* @__PURE__ */ React13.createElement(Status, {
    warn: warn2,
    info
  }));
}

// src/app/component-registry.js
var registry = {
  [Component.DESCRIPTION]: DescriptionSubscriber,
  [Component.STATUS]: StatusSubscriber
};
function getComponent(name2) {
  let component = registry[name2];
  if (component === void 0) {
    component = getPluginViewType(name2);
    if (component === void 0) {
      throw new Error(`Could not find definition for "${name2}" in the core registry nor the plugin registry.`);
    }
  }
  return component;
}
function getViewTypes() {
  return [
    ...Object.keys(registry),
    ...getPluginViewTypes()
  ];
}

// src/app/view-config-utils.js
import difference from "lodash/difference";
import cloneDeep2 from "lodash/cloneDeep";

// package.json
var name = "vit-s";
var version = "1.1.21";
var description = "Vit-s library";
var author = "Mark Keller";
var homepage = "http://vit-s.markk.co/";
var license = "MIT";
var repository = "https://github.com/keller-mark/vit-s/";
var keywords = [
  "react-component"
];
var files = [
  "dist",
  "src"
];
var main = "dist/umd/production/index.min.js";
var module = "dist/esm/index.js";
var peerDependencies = {
  react: ">=16.14.0",
  "react-dom": ">=16.14.0"
};
var dependencies = {
  "@babel/runtime": "7.8.7",
  "@hms-dbmi/viv": "~0.12.6",
  "@loaders.gl/3d-tiles": "^3.0.0",
  "@loaders.gl/core": "^3.0.0",
  "@loaders.gl/images": "^3.0.0",
  "@loaders.gl/loader-utils": "^3.0.0",
  "@luma.gl/core": "~8.5.10",
  "@material-ui/core": "~4.12.3",
  "@material-ui/icons": "~4.11.2",
  "@math.gl/core": "^3.5.6",
  "@turf/area": "^6.5.0",
  "@turf/boolean-contains": "^6.0.1",
  "@turf/boolean-overlap": "^6.0.1",
  "@turf/boolean-point-in-polygon": "^6.0.1",
  "@turf/boolean-within": "^6.0.1",
  "@turf/centroid": "^6.0.2",
  "@turf/helpers": "^6.1.4",
  ajv: "^6.10.0",
  bowser: "^2.11.0",
  classnames: "^2.2.6",
  clsx: "^1.1.1",
  concaveman: "^1.2.1",
  "d3-array": "^2.4.0",
  "d3-dsv": "^1.1.1",
  "d3-force": "^2.1.1",
  "d3-quadtree": "^1.0.7",
  "d3-scale-chromatic": "^1.3.3",
  "deck.gl": "~8.6.7",
  "dynamic-import-polyfill": "^0.1.1",
  "fast-deep-equal": "^3.1.3",
  glslify: "^7.0.0",
  higlass: "1.11.4",
  "higlass-register": "^0.3.0",
  "higlass-zarr-datafetchers": "^0.2.1",
  internmap: "^2.0.3",
  json2csv: "^4.5.2",
  lodash: "^4.17.21",
  "lz-string": "^1.4.4",
  "math.gl": "^3.5.6",
  mathjs: "^9.2.0",
  "nebula.gl": "^0.23.8",
  "prop-types": "^15.7.2",
  "rc-tooltip": "^4.0.3",
  "rc-tree": "2.1.0",
  "react-color": "^2.18.0",
  "react-grid-layout": "^1.1.1",
  "react-vega": "^7.4.4",
  "react-virtualized": "^9.22.2",
  "short-number": "^1.0.6",
  store: "^2.0.12",
  tinycolor2: "^1.4.1",
  uuid: "^3.3.2",
  vega: "^5.21.0",
  "vega-lite": "^5.1.1",
  "vega-tooltip": "^0.27.0",
  "whatwg-fetch": "^3.0.0",
  "window-pixi": "5.3.3",
  zarr: "^0.5.1",
  zustand: "^3.5.10"
};
var devDependencies = {
  "@babel/core": "7.9.0",
  "@babel/plugin-proposal-class-properties": "7.14.5",
  "@svgr/webpack": "5.3.1",
  "@typescript-eslint/eslint-plugin": "^2.10.0",
  "@typescript-eslint/parser": "^2.10.0",
  "babel-eslint": "10.0.3",
  "babel-loader": "8.1.0",
  "babel-plugin-glsl": "^1.0.0",
  "babel-plugin-named-asset-import": "^0.3.6",
  "babel-preset-react-app": "9.1.2",
  camelcase: "^5.3.1",
  "case-sensitive-paths-webpack-plugin": "2.3.0",
  concurrently: "^5.3.0",
  cors: "^2.8.5",
  "css-loader": "3.4.2",
  cypress: "^3.6.1",
  "cypress-fail-on-console-error": "^2.0.6",
  dotenv: "8.2.0",
  "dotenv-expand": "5.1.0",
  enzyme: "^3.9.0",
  "enzyme-adapter-react-16": "^1.11.2",
  esbuild: "^0.12.28",
  "esbuild-plugin-babel": "^0.2.3",
  "esbuild-plugin-sass": "^0.6.0",
  eslint: "^6.6.0",
  "eslint-config-airbnb": "^17.1.0",
  "eslint-config-react-app": "^5.2.0",
  "eslint-loader": "3.0.3",
  "eslint-plugin-cypress": "^2.2.1",
  "eslint-plugin-flowtype": "4.6.0",
  "eslint-plugin-import": "2.20.0",
  "eslint-plugin-jsx-a11y": "6.2.3",
  "eslint-plugin-react": "7.18.0",
  "eslint-plugin-react-hooks": "^1.6.1",
  "eslint-plugin-vitessce-rules": "file:eslint",
  expect: "^24.5.0",
  express: "^4.17.2",
  "file-loader": "4.3.0",
  "fs-extra": "^8.1.0",
  "glsl-colormap": "^1.0.1",
  "html-webpack-plugin": "4.0.0-beta.11",
  "http-server": "^14.0.0",
  "identity-obj-proxy": "3.0.0",
  "js-yaml": "^3.13.1",
  karma: "4.4.1",
  "karma-chrome-launcher": "3.1.0",
  "karma-mocha": "1.3.0",
  "karma-mocha-reporter": "2.2.5",
  "karma-sourcemap-loader": "0.3.7",
  "karma-webpack": "4.0.2",
  "mini-css-extract-plugin": "0.9.0",
  mocha: "7.1.0",
  "node-sass": "^7.0.0",
  "object.fromentries": "^2.0.2",
  "optimize-css-assets-webpack-plugin": "5.0.3",
  "pnp-webpack-plugin": "1.6.0",
  "postcss-flexbugs-fixes": "4.1.0",
  "postcss-loader": "3.0.0",
  "postcss-normalize": "8.0.1",
  "postcss-preset-env": "6.7.0",
  "postcss-safe-parser": "4.0.1",
  react: "^16.14.0",
  "react-app-polyfill": "^1.0.6",
  "react-dev-utils": "^10.2.0",
  "react-dom": "^16.14.0",
  resolve: "1.15.0",
  "resolve-url-loader": "3.1.1",
  "sass-loader": "^10.0.1",
  semver: "6.3.0",
  "style-loader": "0.23.1",
  "terser-webpack-plugin": "2.3.4",
  "url-loader": "2.3.0",
  "wait-on": "^3.2.0",
  webpack: "4.41.5",
  "webpack-dev-server": "3.10.2",
  "webpack-node-externals": "^2.5.2",
  "workbox-webpack-plugin": "4.3.1",
  "worker-loader": "^2.0.0"
};
var resolutions = {
  "@turf/difference": "6.0.1"
};
var scripts = {
  "build-demo:prod": "node scripts/build-demo.js production",
  "build-lib:prod": "NODE_ENV=production node scripts/build-esm.mjs && node scripts/build-lib.js production",
  "build-demo:dev": "node scripts/build-demo.js development",
  "build-lib:dev": "NODE_ENV=development node scripts/build-esm.mjs && node scripts/build-lib.js development",
  "build:prod": "npm run build-demo:prod && npm run build-lib:prod",
  "build:dev": "npm run build-demo:dev && npm run build-lib:dev",
  "build-lib:esm": "NODE_ENV=production node scripts/build-esm.mjs",
  prepublishOnly: "npm run build-lib:prod",
  clean: "rm -r dist-demo dist",
  start: "node scripts/start-demo.js",
  "start:fixtures": 'http-server src/loaders/fixtures/ --cors="*" -s',
  "start:fixtures-concurrently": 'concurrently --kill-others "npm run start:fixtures"',
  test: "node scripts/karma.run.js",
  "test:watch": "node scripts/karma.run.js --auto-watch",
  "cypress:open": 'npm run start:fixtures-concurrently -- "cypress open"',
  "cypress:run": 'npm run start:fixtures-concurrently -- --success first --kill-others "cypress run"',
  "lint-fix": "eslint -c .eslintrc.yml --ext .js --fix src/"
};
var browserslist = {
  production: [
    ">0.2%",
    "not dead",
    "not op_mini all"
  ],
  development: [
    "last 1 chrome version",
    "last 1 firefox version",
    "last 1 safari version"
  ]
};
var babel = {
  presets: [
    "react-app"
  ],
  plugins: [
    "glsl"
  ]
};
var package_default = {
  name,
  version,
  description,
  author,
  homepage,
  license,
  repository,
  keywords,
  files,
  main,
  module,
  peerDependencies,
  dependencies,
  devDependencies,
  resolutions,
  scripts,
  browserslist,
  babel
};

// src/app/view-config-utils.js
function getExistingScopesForCoordinationType(config, coordinationType) {
  var _a;
  const spaceScopes = Object.keys(((_a = config == null ? void 0 : config.coordinationSpace) == null ? void 0 : _a[coordinationType]) || {});
  const componentScopes = config.layout.map((c) => {
    var _a2;
    return (_a2 = c.coordinationScopes) == null ? void 0 : _a2[coordinationType];
  });
  return Array.from(new Set([...spaceScopes, ...componentScopes]));
}
function coordinateComponentsTogether(config, coordinationType, scopeValue) {
  var _a;
  const componentCoordinationTypes = getComponentCoordinationTypes();
  const scopeName = getNextScope(getExistingScopesForCoordinationType(config, coordinationType));
  const newConfig = __spreadProps(__spreadValues({}, config), {
    coordinationSpace: __spreadProps(__spreadValues({}, config.coordinationSpace), {
      [coordinationType]: __spreadProps(__spreadValues({}, (_a = config == null ? void 0 : config.coordinationSpace) == null ? void 0 : _a[coordinationType]), {
        [scopeName]: scopeValue
      })
    }),
    layout: config.layout.map((component) => {
      var _a2;
      return __spreadProps(__spreadValues({}, component), {
        coordinationScopes: __spreadValues(__spreadValues({}, component.coordinationScopes), componentCoordinationTypes[component.component].includes(coordinationType) && !((_a2 = component.coordinationScopes) == null ? void 0 : _a2[coordinationType]) ? {
          [coordinationType]: scopeName
        } : {})
      });
    })
  });
  return newConfig;
}
function coordinateComponentsIndependent(config, coordinationType, scopeValue) {
  const componentCoordinationTypes = getComponentCoordinationTypes();
  const newConfig = __spreadProps(__spreadValues({}, config), {
    layout: [...config.layout]
  });
  const newScopes = {};
  newConfig.layout.forEach((component, i) => {
    var _a;
    if (componentCoordinationTypes[component.component].includes(coordinationType) && !((_a = component.coordinationScopes) == null ? void 0 : _a[coordinationType])) {
      const scopeName = getNextScope([
        ...getExistingScopesForCoordinationType(config, coordinationType),
        ...Object.keys(newScopes)
      ]);
      newScopes[scopeName] = scopeValue;
      newConfig.layout[i] = __spreadProps(__spreadValues({}, component), {
        coordinationScopes: __spreadProps(__spreadValues({}, component.coordinationScopes), {
          [coordinationType]: scopeName
        })
      });
    }
  });
  newConfig.coordinationSpace = __spreadProps(__spreadValues({}, newConfig.coordinationSpace), {
    [coordinationType]: __spreadValues(__spreadValues({}, newConfig.coordinationSpace[coordinationType]), newScopes)
  });
  return newConfig;
}
function coordinateComponentsShortcut(config, coordinationType) {
  const componentCoordinationTypes = getComponentCoordinationTypes();
  const newConfig = __spreadProps(__spreadValues({}, config), {
    layout: [...config.layout]
  });
  const newScopes = {};
  newConfig.layout.forEach((component, i) => {
    var _a;
    if (componentCoordinationTypes[component.component].includes(coordinationType) && ((_a = component.coordinationValues) == null ? void 0 : _a[coordinationType])) {
      const scopeValue = component.coordinationValues[coordinationType];
      const scopeName = getNextScope([
        ...getExistingScopesForCoordinationType(config, coordinationType),
        ...Object.keys(newScopes)
      ]);
      newScopes[scopeName] = scopeValue;
      newConfig.layout[i] = __spreadProps(__spreadValues({}, component), {
        coordinationScopes: __spreadProps(__spreadValues({}, component.coordinationScopes), {
          [coordinationType]: scopeName
        })
      });
      delete newConfig.layout[i].coordinationValues[coordinationType];
    }
  });
  newConfig.coordinationSpace = __spreadProps(__spreadValues({}, newConfig.coordinationSpace), {
    [coordinationType]: __spreadValues(__spreadValues({}, newConfig.coordinationSpace[coordinationType]), newScopes)
  });
  return newConfig;
}
function initializeAuto(config) {
  let newConfig = config;
  const componentCoordinationTypes = getComponentCoordinationTypes();
  const defaultCoordinationValues = getDefaultCoordinationValues();
  const coordinationTypes = getCoordinationTypes();
  coordinationTypes.forEach((coordinationType) => {
    newConfig = coordinateComponentsShortcut(newConfig, coordinationType);
  });
  const { layout, datasets } = newConfig;
  coordinationTypes.forEach((coordinationType) => {
    const requiresCoordination = !layout.every((c) => {
      var _a;
      return !componentCoordinationTypes[c.component].includes(coordinationType) || ((_a = c.coordinationScopes) == null ? void 0 : _a[coordinationType]);
    });
    if (requiresCoordination) {
      let defaultValue = defaultCoordinationValues[coordinationType];
      if (coordinationType === "dataset" && datasets.length >= 1) {
        defaultValue = datasets[0].uid;
      }
      if (AUTO_INDEPENDENT_COORDINATION_TYPES.includes(coordinationType)) {
        newConfig = coordinateComponentsIndependent(newConfig, coordinationType, defaultValue);
      } else {
        newConfig = coordinateComponentsTogether(newConfig, coordinationType, defaultValue);
      }
    }
  });
  return newConfig;
}
function checkTypes(config) {
  const coordinationTypesInConfig = Object.keys(config.coordinationSpace || {});
  const allCoordinationTypes = getCoordinationTypes();
  const unknownCoordinationTypes = difference(coordinationTypesInConfig, allCoordinationTypes);
  if (unknownCoordinationTypes.length > 0) {
    return [false, `The following coordination types are not recognized: [${unknownCoordinationTypes}].
If these are plugin coordination types, ensure that they have been properly registered.`];
  }
  const viewTypesInConfig = config.layout.map((c) => c.component);
  const allViewTypes = getViewTypes();
  const unknownViewTypes = difference(viewTypesInConfig, allViewTypes);
  if (unknownViewTypes.length > 0) {
    return [false, `The following view types are not recognized: [${unknownViewTypes}].
If these are plugin view types, ensure that they have been properly registered.`];
  }
  const fileTypesInConfig = config.datasets.flatMap((d) => d.files.map((f) => f.fileType));
  const allFileTypes = getFileTypes();
  const unknownFileTypes = difference(fileTypesInConfig, allFileTypes);
  if (unknownFileTypes.length > 0) {
    return [false, `The following file types are not recognized: [${unknownFileTypes}].
If these are plugin file types, ensure that they have been properly registered.`];
  }
  return [true, "All view types, coordination types, and file types that appear in the view config are recognized."];
}
function assignViewUids(config) {
  const { layout } = config;
  const usedIds = layout.map((view) => view.uid);
  layout.forEach((view, i) => {
    if (!view.uid) {
      const nextUid = getNextScope(usedIds);
      layout[i].uid = nextUid;
      usedIds.push(nextUid);
    }
  });
  return __spreadProps(__spreadValues({}, config), {
    layout
  });
}
function expandConvenienceFileDefs(config) {
  const convenienceFileTypes = getConvenienceFileTypes();
  const { datasets: currDatasets } = config;
  const datasets = cloneDeep2(currDatasets);
  currDatasets.forEach((dataset, i) => {
    const { files: files2 = [] } = dataset;
    let newFiles = [];
    files2.forEach((fileDef) => {
      const { fileType } = fileDef;
      const expansionFunc = convenienceFileTypes[fileType];
      if (expansionFunc && typeof expansionFunc === "function") {
        const expandedFileDefs = expansionFunc(fileDef);
        newFiles = newFiles.concat(expandedFileDefs);
      } else {
        newFiles.push(fileDef);
      }
    });
    datasets[i].files = newFiles;
  });
  return __spreadProps(__spreadValues({}, config), {
    datasets
  });
}
function initialize(config) {
  let newConfig = cloneDeep2(config);
  if (newConfig.initStrategy === "auto") {
    newConfig = initializeAuto(config);
  }
  newConfig = expandConvenienceFileDefs(newConfig);
  return assignViewUids(newConfig);
}
function upgradeAndValidate(oldConfig) {
  let nextConfig = oldConfig;
  let fromVersion;
  let upgradeFunction;
  let validateFunction;
  do {
    fromVersion = nextConfig.version;
    if (!Object.keys(SCHEMA_HANDLERS).includes(fromVersion)) {
      return [{
        title: "Config validation failed",
        preformatted: "Unknown config version."
      }, false];
    }
    [validateFunction, upgradeFunction] = SCHEMA_HANDLERS[fromVersion];
    const validLegacy = validateFunction(nextConfig);
    if (!validLegacy) {
      const failureReason = JSON.stringify(validateFunction.errors, null, 2);
      return [{
        title: "Config validation failed",
        preformatted: failureReason
      }, false];
    }
    if (upgradeFunction) {
      nextConfig = upgradeFunction(nextConfig);
    }
  } while (upgradeFunction);
  console.groupCollapsed(`\u{1F684} Vitessce (${package_default.version}) view configuration`);
  console.info(`data:,${JSON.stringify(nextConfig)}`);
  console.info(JSON.stringify(nextConfig, null, 2));
  console.groupEnd();
  return [nextConfig, true];
}

// src/app/Vitessce.js
var generateClassName = createGenerateClassName({
  disableGlobal: true
});
function Vitessce(props) {
  const {
    config,
    rowHeight,
    height,
    theme,
    onWarn,
    onConfigChange,
    onLoaderChange,
    validateOnConfigChange = false
  } = props;
  const [configOrWarning, success] = useMemo4(() => {
    if (!config) {
      return [{
        title: "No such dataset",
        unformatted: "The dataset configuration could not be found."
      }, false];
    }
    if (!config.version) {
      return [{
        title: "Missing version",
        unformatted: "The dataset configuration is missing a version, preventing validation."
      }, false];
    }
    const [upgradedConfig, upgradeSuccess] = upgradeAndValidate(config);
    if (upgradeSuccess) {
      const [typeCheckSuccess, typeCheckMessage] = checkTypes(upgradedConfig);
      if (typeCheckSuccess) {
        const initializedConfig = initialize(upgradedConfig);
        return [initializedConfig, true];
      }
      return [{
        title: "View config initialization failed.",
        unformatted: typeCheckMessage
      }, false];
    }
    return [upgradedConfig, false];
  }, [config]);
  useEffect7(() => {
    if (success && !isEqual2(configOrWarning, config) && onConfigChange) {
      onConfigChange(configOrWarning);
    }
  }, [success, config, configOrWarning, onConfigChange]);
  return success ? /* @__PURE__ */ React14.createElement(StylesProvider, {
    generateClassName
  }, /* @__PURE__ */ React14.createElement(ThemeProvider, {
    theme: muiTheme[theme]
  }, /* @__PURE__ */ React14.createElement(ViewConfigProvider, {
    createStore: createViewConfigStore
  }, /* @__PURE__ */ React14.createElement(AuxiliaryProvider, {
    createStore: createAuxiliaryStore
  }, /* @__PURE__ */ React14.createElement(VitessceGrid, {
    config: configOrWarning,
    getComponent,
    rowHeight,
    height,
    theme
  }), /* @__PURE__ */ React14.createElement(CallbackPublisher, {
    onWarn,
    onConfigChange,
    onLoaderChange,
    validateOnConfigChange
  }))))) : /* @__PURE__ */ React14.createElement(Warning, __spreadValues({
    theme
  }, configOrWarning));
}

// src/app/export-utils.js
import Bowser from "bowser";
import { compressToEncodedURIComponent, decompressFromEncodedURIComponent } from "lz-string";
var CURRENT_VERSION = "0.0.1";
var VITESSCE_CONF_QUERY_STRING = "vitessce_conf";
var VERSION_QUERY_STRING = "vitessce_conf_version";
var LENGTH_QUERY_STRING = "vitessce_conf_length";
function sniffBrowser() {
  const { browser } = Bowser.parse(window.navigator.userAgent);
  return browser.name;
}
var MAX_BROWSER_URL_LENGTHS = {
  Chrome: 32779,
  "Internet Explorer": 2047,
  Edge: 2047,
  Safari: 65e3,
  Firefox: 65e3
};
var CompressedConfLengthError = class {
  constructor(message) {
    this.message = message;
  }
};
function encodeConfInUrl({
  conf,
  onOverMaximumUrlLength = () => {
  }
}) {
  const compressedConf = compressToEncodedURIComponent(JSON.stringify(conf));
  const newParams = `${LENGTH_QUERY_STRING}=${compressedConf.length}&${VERSION_QUERY_STRING}=${CURRENT_VERSION}&${VITESSCE_CONF_QUERY_STRING}=${compressedConf}`;
  const browser = sniffBrowser();
  const maxLength = MAX_BROWSER_URL_LENGTHS[browser];
  if (newParams.length > maxLength) {
    const willWorkOn = Object.entries(MAX_BROWSER_URL_LENGTHS).filter((entry) => entry[1] > newParams.length).map((entry) => entry[0]);
    const message = `Configuration is ${compressedConf.length} characters; max URL for ${browser} is ${maxLength}: it will work on ${willWorkOn.join(", ") || "no browser"}.`;
    console.error(message);
    onOverMaximumUrlLength({ message, willWorkOn });
  }
  return newParams;
}
function decodeURLParamsToConf(queryString) {
  const params = new URLSearchParams(queryString.replace("#", "&"));
  const compressedConfString = params.get(VITESSCE_CONF_QUERY_STRING);
  const expectedConfLength = Number(params.get(LENGTH_QUERY_STRING));
  if (expectedConfLength !== compressedConfString.length) {
    throw new CompressedConfLengthError(`Compressed conf length (${compressedConfString.length}) != expected (${expectedConfLength}). URL truncated?`);
  }
  const version2 = params.get(VERSION_QUERY_STRING);
  if (version2 === CURRENT_VERSION) {
    const conf = JSON.parse(decompressFromEncodedURIComponent(compressedConfString));
    return conf;
  }
  throw new Error("Unrecognized URL Param Version");
}

// src/app/constants-old.js
var Component2 = {};
var DataType2 = {};
var FileType2 = {};
function makeChangeMessage(newTypeName, newVersion) {
  return `This coordination type was changed to ${newTypeName} in view config schema version ${newVersion}`;
}
var CoordinationType2 = {
  SPATIAL_LAYERS: [
    "spatialLayers",
    "This coordination type was split into multiple coordination types in view config schema version 1.0.1"
  ],
  SPATIAL_RASTER_LAYERS: [
    "spatialRasterLayers",
    makeChangeMessage("spatialImageLayer", "1.0.11")
  ],
  SPATIAL_CELLS_LAYER: [
    "spatialCellsLayer",
    makeChangeMessage("spatialSegmentationLayer", "1.0.11")
  ],
  SPATIAL_MOLECULES_LAYER: [
    "spatialMoleculesLayer",
    makeChangeMessage("spatialPointLayer", "1.0.11")
  ],
  SPATIAL_NEIGHBORHOODS_LAYER: [
    "spatialNeighborhoodsLayer",
    makeChangeMessage("spatialNeighborhoodLayer", "1.0.11")
  ],
  EMBEDDING_CELL_SET_POLYGONS_VISIBLE: [
    "embeddingCellSetPolygonsVisible",
    makeChangeMessage("embeddingObsSetPolygonsVisible", "1.0.11")
  ],
  EMBEDDING_CELL_SET_LABELS_VISIBLE: [
    "embeddingCellSetLabelsVisible",
    makeChangeMessage("embeddingObsSetLabelsVisible", "1.0.11")
  ],
  EMBEDDING_CELL_SET_LABEL_SIZE: [
    "embeddingCellSetLabelSize",
    makeChangeMessage("embeddingObsSetLabelSize", "1.0.11")
  ],
  EMBEDDING_CELL_RADIUS: [
    "embeddingCellRadius",
    makeChangeMessage("embeddingObsRadius", "1.0.11")
  ],
  EMBEDDING_CELL_RADIUS_MODE: [
    "embeddingCellRadiusMode",
    makeChangeMessage("embeddingObsRadiusMode", "1.0.11")
  ],
  EMBEDDING_CELL_OPACITY: [
    "embeddingCellOpacity",
    makeChangeMessage("embeddingObsOpacity", "1.0.11")
  ],
  EMBEDDING_CELL_OPACITY_MODE: [
    "embeddingCellOpacityMode",
    makeChangeMessage("embeddingObsOpacityMode", "1.0.11")
  ],
  CELL_FILTER: [
    "cellFilter",
    makeChangeMessage("obsFilter", "1.0.11")
  ],
  CELL_HIGHLIGHT: [
    "cellHighlight",
    makeChangeMessage("obsHighlight", "1.0.11")
  ],
  CELL_SET_SELECTION: [
    "cellSetSelection",
    makeChangeMessage("obsSetSelection", "1.0.11")
  ],
  CELL_SET_HIGHLIGHT: [
    "cellSetHighlight",
    makeChangeMessage("obsSetHighlight", "1.0.11")
  ],
  CELL_SET_COLOR: [
    "cellSetColor",
    makeChangeMessage("obsSetColor", "1.0.11")
  ],
  CELL_COLOR_ENCODING: [
    "cellColorEncoding",
    makeChangeMessage("obsColorEncoding", "1.0.11")
  ],
  ADDITIONAL_CELL_SETS: [
    "additionalCellSets",
    makeChangeMessage("additionalObsSets", "1.0.11")
  ],
  GENE_FILTER: [
    "geneFilter",
    makeChangeMessage("featureFilter", "1.0.11")
  ],
  GENE_HIGHLIGHT: [
    "geneHighlight",
    makeChangeMessage("featureHighlight", "1.0.11")
  ],
  GENE_SELECTION: [
    "geneSelection",
    makeChangeMessage("featureSelection", "1.0.11")
  ],
  GENE_EXPRESSION_COLORMAP: [
    "geneExpressionColormap",
    makeChangeMessage("featureValueColormap", "1.0.11")
  ],
  GENE_EXPRESSION_TRANSFORM: [
    "geneExpressionTransform",
    makeChangeMessage("featureValueTransform", "1.0.11")
  ],
  GENE_EXPRESSION_COLORMAP_RANGE: [
    "geneExpressionColormapRange",
    makeChangeMessage("featureValueColormapRange", "1.0.11")
  ]
};

// src/app/constants-merged.js
function makeConstantWithDeprecationMessage(currObj, oldObj) {
  const handler = {
    get(obj, prop) {
      const oldKeys = Object.keys(oldObj);
      if (oldKeys.includes(prop)) {
        console.warn(`Notice about the constant mapping ${prop}: '${oldObj[prop][0]}':
${oldObj[prop][1]}`);
        return oldObj[prop];
      }
      return obj[prop];
    }
  };
  const objWithMessage = new Proxy(currObj, handler);
  return objWithMessage;
}
var Component3 = makeConstantWithDeprecationMessage(Component, Component2);
var DataType3 = makeConstantWithDeprecationMessage(DataType, DataType2);
var FileType3 = makeConstantWithDeprecationMessage(FileType, FileType2);
var CoordinationType3 = makeConstantWithDeprecationMessage(CoordinationType, CoordinationType2);
export {
  AbstractTwoStepLoader,
  Component3 as Component,
  CoordinationType3 as CoordinationType,
  DataType3 as DataType,
  FileType3 as FileType,
  JsonLoader,
  JsonSource,
  LoaderResult,
  TitleInfo,
  Vitessce,
  VitessceConfig,
  decodeURLParamsToConf,
  encodeConfInUrl,
  hconcat,
  registerPluginCoordinationType,
  registerPluginFileType,
  registerPluginViewType,
  useComplexCoordination,
  useComponentHover,
  useComponentViewInfo,
  useCoordination,
  useDatasetUids,
  useDescription,
  useLoaders,
  useMatchingLoader,
  useMultiDatasetCoordination,
  useReady,
  useSetComponentHover,
  useSetComponentViewInfo,
  useSetWarning,
  useUrls,
  useViewConfigStore,
  useViewConfigStoreApi,
  useWarning,
  vconcat
};
//# sourceMappingURL=index.js.map
